<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Conjecture - Documentation - FAQ</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-15">
  <!-- link rel="icon" href="conjecture.ico" type="image/x-icon" -->
  <!-- link rel="shortcut icon" href="conjecture.ico" type="image/x-icon" -->
  <link rel="stylesheet" href="style.css" type="text/css" title="plain">
</head>
<body>
<table class="nopad" align="left" border="0" cellpadding="0"
 cellspacing="0" width="100%">
  <tbody>
    <tr>
      <td class="nopad">
<?php
 $mainvalue='Documentation';
 $subvalue='FAQ';
 include_once("header.php");
?>
      </td>
    </tr>
    <tr>
      <td>

      <table class="nopad" align="left" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tbody>
          <tr valign="top">
            <td class="content">

            <div id="overview">
            <h1>FAQ</h1>

            <dl>
             <dt>I'm encountering "multiple definition of" linking errors</dt>
             <dd>
             <p>Although this can happen for many reasons, the architecuture
             of Conjecture is such that if you are not aware of what
             Conjecture is doing, multiple-definition-of errors will
             often occur.</p>

             <p>The <code>src/</code> directory contains
             subdirectories defining all of the C++ classes necessary
             to compile Conjecture. The <code>src/Makefile</code> is
             designed to automatically maintain all dependencies
             between files, and to ensure that a file is always
             compiled if any file it depends on is modified.  Note
             that this is the purpose of a Makefile, but few Makefiles
             actually take care to ensure that <em>all</em> dependencies
             are accounted for.

             <p>It is important to remember note that the
             <code>Makefile</code> finds and compiles EVERY
             <code>*.cc</code> file in the <em>entire directory
             hierarchy</em> (i.e. all sub-directories are searched
             too). This means that you <b>cannot</b> create a "backup"
             or "old" directory within <code>src</code>; such code
             will be automatically detected and compiled by the
             Makefile.  Since backups imply that there is a "non-backup"
             that presumably defines the same class(es), the Makefile
             will encounter multiple definitions of the same class and
             naturally generate "multiple definition of" errors.

             <p>The current solution is to put all backups outside the
             <code>src/</code> directory. As a trivial future-works
             project, extensions can be added to
             <code>src/Makefile</code> to ignore certain directory
             names within the <code>src/</code> directory hierarchy.
             </dd>

             <dt>When I use 'make &lt;target&gt;', unexpected things happen</dt>
             <dd>
             <p>The <code>src</code> directory has multiple
             sub-directories (and sub-sub-directories, etc.), but all
             directories contribute to the overall
             <code>conjecture</code> executable.  Currently,
             subdirectory Makefiles usually perform a simple delegation
             of targets to the <code>src/Makefile</code>.  For most
             targets, this produces the desired behavior, but some
             special-case targets need to be addressed specially, and
             you may encounter a target that doesn't do what you expect
             it to.</p>

             <p> This "problem" may or may not go away when we move to
             an <code>autoconf</code> environment. The "inheritance"
             of targets has advantages that compensate for this
             (presumably rare) potential problem.
             </dd>

             <dt></td>
             <dd>
             </dd>
            </dl>

            </div>

            </td>

            <!-- begin side bar -->
            <td class="right" width="200">
<?php
 include_once("sidebar.php");
?>

            </td>

            <!-- end side bar -->

          </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td class="nopad">
<?php
 include_once("footer.php");
?>
      </td>
    </tr>
  </tbody>
</table>


</body>
</html>
