<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Conjecture - a general OCR framework</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-15">
  <!-- link rel="icon" href="conjecture.ico" type="image/x-icon" -->
  <!-- link rel="shortcut icon" href="conjecture.ico" type="image/x-icon" -->
  <link rel="stylesheet" href="style.css" type="text/css" title="plain">
  <script language="JavaScript" src="http://www.holst.ca/lib/wmh.js" type="text/javascript"></script>
</head>
<body>
<table class="nopad" align="left" border="0" cellpadding="0"
 cellspacing="0" width="100%">
  <tbody>
    <tr>
      <td class="nopad">
<?php 
 $mainvalue='Home';
 $subvalue='';
 include_once("header.php");
?>
      </td>
    </tr>
    <tr>
      <td>
      
      <table class="nopad" align="left" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tbody>
          <tr valign="top">
            <td class="content">

<!-- ****************************************************************** -->

<div id="about">
  <h2> Synopsis </h2>
  <blockquote>

    <p>
    Conjecture is a modular, extensible, open-source C++ framework for
    Optical Character Recognition (OCR). Conjecture is not a single OCR, but
    rather is an extensible collection of OCRs that can be explored,
    analyzed, compared, extended, modified, and merged within a unified
    environment.
    </p>

  </blockquote>
</div>

<!-- ****************************************************************** -->

<div id="features">
  <h2>Features</h2>
  <blockquote>
    <ul>

      <li onclick="javascript:wmhIdDisplayToggle('sub-modular');">
      <b style="text-decoration: underline;">Modular</b>: Conjecture is built around a collection of OCR Modules (more...)

        <div id="sub-modular">
        <ul>

         <li>
         <b>Independent OCRs</b>: Each Module provides a complete solution to
         the problem of converting an input image into output text. When the
         <code>conjecture</code> executable is invoked, the user specifies
         which OCR Module will be used. Conjecture is not a single OCR, but
         rather an arbitrarily large collection of OCRs.
         </li>

         <li>
         <b>Class-based</b>: Each Module is implemented by a C++ "module" class, which
         uses a number of additional "component" classes that implement
         solutions to the various subproblems associated with OCR).
         </li>

         <li>
         <b>Third-party commercial OCRs</b>: Conjecture can create a Module that "wraps"
         an arbitrary third-party OCR, thus allowing that OCR to participate
         in the Conjecture framework.
         </li>

         <li>
         <b>Third-party open-source OCRs</b>Conjecture provides Modules for
         third-party open-source OCRs like GOCR, Ocrad and Claraocr that
         incorporate their code bases into Conjecture. This allows Conjecture
         to benefit from and build on top of existing OCR development.
         </li>

       </ul>
       </div>

       <li onclick="javascript:wmhIdDisplayToggle('sub-testable');"> 
       <b style="text-decoration: underline;">Testable</b>:
       Conjecture provides a sophisticated testing infrastructure that (more...)
        <div id="sub-testable">
        <ul>
          <li>
          <b>Database</b>: Maintains a database of input images and
          associated text files representing what an OCR should produce if it
          is 100% accurate.
          </li>

          <li>
          <b>Module Variants</b>: Formalizes the concept of a <em>Module Variant</em>, which
          concists of a particular OCR Module and a set of values for the
          <em>configurable parameters</em> associated with that Module.
          </li>

          <li>
          <b>Testing</b>: Allows users to execute one or more variants of one or
          more OCR modules on one or more input images.
          </li>
         
          <li>
          <b>Verification</b>: Allows one to verify that a particular change
          in the Conjecture code base has not caused unexpected consequences.
          This is accomplished by invoking <code>conjecture</code> on all
          variants of all modules on all input images and comparing the
          output of each run against <em>expected</em> output.
          </li>

          <li>
          <b>Assessment</b>: Allows one to establish the accuracy of one or
          more module/variant/image triples by comparing generated output
          against <em>desired</em> output.
          </li>
               
        </ul>
        </div>
      </li>

      <li onclick="javascript:wmhIdDisplayToggle('sub-extensible');">
      <b style="text-decoration: underline;">Extensible</b>: Conjecture makes it easy to make Conjecture better (more...)
       <div id="sub-extensible">
       <ul>

          <li>
          <b>Open Source</b>: Conjecture is open source (LGPL license), and
          read/write accessible (via a Subversion repository) to all who are
          interested in advancing the state-of- the-art in optical character
          recognition.
          </li>

          <li>
          <b>User Extensible</b>: Conjecture provides an infrastructure that
          allows non-programmers to experiment with different configurable
          parameters, and to record the combination of parameter values that
          produce the best results. Over time, the best possible combination
          of input parameters for each module/image will be identified,
          benefitting all Conjecture users.
          </li>
     
          <li>
          <b>Programmer Extensible</b>: Conjecture uses an object-oriented
          design emphasizing modularity, making it easy for programmers to
          make everything from tiny incremental changes in a single method of
          an existing Component, to entirely new Modules that implement
          everything necessary for image-to-text conversion.
           <ul>

             <li> Modules (and the associated Components) are described
             by an entry in a special <code>Conjecture.modules</code>
             file.

             <li> Conjecture can automatically and fully generate the
             module class based on the entry in the modules file.

             <li> A Module can reuse components that have already been
             developed for some other Module, or can create new ones.

             <li> Conjecture automatically produces a stub class for
             each new component. These stub classes can then be edited in
             order to provide a new implementation if the issue being
             addressed by the Component in question.

           </ul>
         </li>
       </ul>
       </div>
      </li>

    </ul>
  </blockquote>
</div>

<!-- ****************************************************************** -->

<div id="news">
  <h1>News</h1>
  <blockquote>
  <dl>
    <dt><a name="12062006"></a>12 Jun 2006</dt>
    <dd>

    Initial version of this website.

    </dd>

    <dt><a name="02062006"></a>02 June 2006</dt>
    <dd>

    Project started.

    </dd>

  </dl>
  </blockquote>
</div>

<!-- ****************************************************************** -->

            </td>

            <!-- begin side bar -->
            <td class="right" width="180">
<?php 
 include_once("sidebar.php");
?>

            </td>
            
            <!-- end side bar -->

          </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td class="nopad">
<?php 
 include_once("footer.php");
?>
      </td>
    </tr>
  </tbody>
</table>


<script>
      wmhIdUndisplay('sub-modular');
      wmhIdUndisplay('sub-testable');
      wmhIdUndisplay('sub-extensible');
</script>

</body>
</html>
