<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Conjecture - TODO</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-15">
  <!-- link rel="icon" href="conjecture.ico" type="image/x-icon" -->
  <!-- link rel="shortcut icon" href="conjecture.ico" type="image/x-icon" -->
  <link rel="stylesheet" href="style.css" type="text/css" title="plain">
</head>
<body>
<table class="nopad" align="left" border="0" cellpadding="0"
 cellspacing="0" width="100%">
  <tbody>
    <tr>
      <td class="nopad">
<?php 
 $mainvalue='TODO';
 $subvalue='';
 include_once("header.php");
?>
      </td>
    </tr>
    <tr>
      <td>
      
      <table class="nopad" align="left" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tbody>
          <tr valign="top">
            <td class="content">

<!-- NOTE: We must find a cleaner CSS design for implementing these pages! -->

<!-- ************************* Insert Text Here ********************** -->
<div>
  <h1>TODO</h1>

    <blockquote>
      <p>A collection of things to do, divided into various
      categories. Some of these things will be trivial for you to help
      address - please do so! </blockquote>

    <div id="easy">
      <h2> Easy Issues (Low-hanging fruit)</h2>
      <blockquote>
<pre>
Input Images
------------
 - Convert $CONJECTURE/harness/db/*.pnm to max intensity 255.
   The 4x6.pnm, etc. files have max intensity 65535 and ocrad
   fails on them (poor dumb ocrad!).  We really don't need
   65535 anyway, so it isn't a problem to conver them.

HTML Pages
----------
 - The current web page structure is using TABLE for structuring. We
   want to switch over to DIV (and CSS) to make things more flexible.
   If you have experience with CSS, contact bruno and wade so we can
   colloborate on a redesign.

 - Related to the above, currently using BLOCKQUOTE for indentation
   within sections.  CSS can do better, no?

 - Add indentation to the beginning of each paragraph.  I know it
   is trivial in CSS.

 - A new format for describing existing Components is needed. See <A
   HREF="components.php#existing">here</A> for the to-be-replaced
   format.

High-level Documentation
------------------------

 - If you notice typos or other kinds of errors in any documentation,
   please fix them! New users are the ones most likely to detect such
   errors, and also most in need of clear, concise, accurate
   explanations, so please help maintain the documentation. High level
   documentation is in <code>$CONJECTURE/doc/web</code>. Class and
   method-level documentation is in the header files in
   <code>$CONJECTURE/src/*</code>

 - Write a tutorial for new Modules, with a simple example that can
   be used as a guide for new developers.

Class Documentation
-------------------
 - the header inserted at the beginning of each source file needs to
   be polished, and a much cleaner mechanism of incorporating it into
   files should be established. Presumably SVN has substitution
   variables like CVS does?

Compiler Warnings
-----------------
 - [wade] On cygwin, use of 'std::list<...>::push_back() generates
   compiler warnings of the following form:
      /bin/../lib/gcc/i686-pc-cygwin/3.4.4/include/c++/bits/stl_list.h:435: 
      warning: '__p' might be used uninitialized in this function
   Anyone see the reason?  Line 435 of my cygwin platorms stl_list.h is
      _Node* __p = this->_M_get_node();
   which doesn't seem to be a candidate for such a warning (if anything,
   the field returned by '_M_get_node()' should be being reported as
   potentially unused, since '__p' itself cannot be uninitialized unless
   the return of '_M_get_node' is uninitialized.

   Google reports a few others having this problem, but no solutions as far
   as I could tell.
</pre>
      </blockquote>
    </div>

<!-- ******************** DESIGN ISSUES ************************** -->

    <div id="design">
      <h2> Design Issues </h2>
      <blockquote>
<pre>
Components
----------
 - Many more components can be identified and formalized!
 
 - Currently we only have the "broad strokes".
   <code>ProcessComponent</code> provides total control over the OCR
   implementation. <code>SegmentComponent</code> does Page-to-Glyph
   segmentation (and optionally intermediate segmentation).
   <code>IdentifyComponent</code> does Glyph-to-unicode translation.
   <code>FormatComponent</code> does text placement (words, lines,
   columns, etc.).

   ProcessComponent is almost always implemented by executing a
   SegmentComponent, then an IdentifyComponent, then a
   FormatComponent.  This shows that components can be organized into
   a containment hierarchy.

   The next critical step in Components is to subdivide each of
   Segment, Identify and Format into sub components. For example,
   there should be a DeskewComponent, NoiseRemovalComponent, and
   numerous other components within one or more of these "high-level"
   components.

   Identifying which issues should be formalized into Components is
   not always easy. For example, should thresholding and pixel
   filtering be separate components, or should they be part of a
   single component? Part of the fun of Conjecture is exploring the
   best design!

</pre>
      </blockquote>
    </div>

<!-- *************** IMPLEMENTATION ISSUES ************************** -->

    <div id="implementation">
      <h2> Things To Do Related to Implementation </h2>
      <blockquote>
<pre>

Exceptions
----------
 - Must decide what to do about exceptions. Currently just throwing
   'string' instances, but a much cleaner solution involving a
   hierarchy of exceptions classes is needed eventually. Don't want to
   require Boost until it becomes the standard.

Naming Issues
-------------

 - Find better names for certain classes:
    - The 'Region' class needs to be renamed.

GOCR Documentation
------------------
 - The Gocr Module provides an interface to the GOCR codebase.
   However, although gocr can provide good results, its codebase is
   very poorly documented.
    - Provide an explanation of what each command-line flag does
    - Provide an overview discussion of the flow-of-control in
      gocr and the important methods and files.
    - Provide a detailed discussion of the critical methods
      like ocr0_eE(), etc.
    - All of this documentation should be placed in the
      src/custom/gocr directory (either in source files or other
      discussion files).

</pre>
      </blockquote>
    </div>

<!-- *************** INFRASTRUCTURE ISSUES ************************** -->

    <div id="infrastructure">
      <h2> Things To Do Related to Infrastructure </h2>
      <blockquote>
<pre>

Name
----
 - Determine whether we are staying with the name Conjecture, or
   whether we will be changing the name to something else.

 - During initial development bruno and wade explored various names,
   the favored being Apocryphal and Sorcerer. However, due to the
   negative (if amusing) connotations of Apocryphal, and existing
   image analysis software named Sorcerer, we decided to go with
   Conjecture as our "temporary" name.

 - A name that has the letters 'o', 'c', and 'r' in it seems
   appropriate.  Editing the results of 
       % perl -ne 'next if substr($_,0,6) eq substr($last,0,6); 
                   if ( m/(.*)o(.*)c(.*)r(.*)/ ) { 
                      chomp;
                      printf("%-20s = %s\n", $_, "$1O$2C$3R$4");
                      $last = $_;
                    }' /usr/share/dict/words
   based on double entrendres wrt OCR or amusement value gives the
   following possibilities:
        apocryphal           = apOCRyphal
        aristocracy          = aristOCRacy
        autoincrement        = autOinCRement
        binocular            = binOCulaR
        boxcar               = bOxCaR
        cockroach            = cOCkRoach
        concentrate          = cOnCentRate
        concord              = cOnCoRd
        concur               = cOnCuR
        confectionery        = cOnfeCtioneRy
        conjecture           = cOnjeCtuRe
        consecrate           = cOnseCRate
        constructor          = cOnstruCtoR
        democracy            = demOCRacy
        doctor               = dOCtoR
        hypocrisy            = hypOCRisy
        idiosyncrasies       = idiOsynCRasies
        jockstrap            = jOCkstRap
        mediocre             = mediOCRe
        molecular            = mOleCulaR
        nomenclature         = nOmenClatuRe
        obfuscatory          = ObfusCatoRy
        obscure              = ObsCuRe
        octahedra            = OCtahedRa
        omicron              = OmiCRon
        orchard              = OrChaRd
        orchestra            = OrChestRa
        popcorn              = pOpCoRn
        postscript           = pOstsCRipt
        processor            = prOCessoR
        rhinoceros           = rhinOCeRos
        scorcher             = scOrCheR
        scorecard            = scOreCaRd
        soccer               = sOcCeR
        Socrates             = SOCRates
        sorcerer             = sOrCereR
        Velociraptor         = VelOCiraptoR
        woodpecker           = woOdpeCkeR

Web Pages
---------

 - The web pages always need more work. If you are reading
   documentation for the first time, and something isn't making sence,
   make a note of it! When it starts making sense, go back to edit the
   documentation to make things more clear!


Installation
------------
 - Set up proper installation environment
    - autoconf (assigned to Bruno)
    - maintain the <code>$CONFIGURE/external/Makefile</code>,
      which should automatically download/compile/install third-party
      source code useful to Conjecture.

Platform Support
----------------

 - Verify that code compiles and works on common platforms

    - I have been testing on linux and cygwin machines

    - Windows stupid case-insensitive file directories have
      posed problems on more than one occasion

Hosting
-------
 - Decide when to move the codebase from
   the two temporary mirrors 
      http://www.holst.ca/conjecture
   and
      http://www.corollarium.com/conjecture
   to someplace more formal.

 - Do we want to go to sourceforge?  Bruno says sourceforge has
   SVN - that's good!


Test Harness
------------
 - The test harness is meant to be an (ever expanding) collection
   of images and expected output, and an infrastructure for testing
   the output of 'conjecture' against that expected output.

 - Extend the test harness
    - obtain new images and add them to the harness dir with
      name '<name>.pnm'.
    - create 'harness/<name>.val' by executing
       % src/conjecture -i harness/<name>.pnm -o harness/<name>.val
    - create 'harness/<name>.valid' by hand
    - modify harness/Makefile (or generalize the makefile to look
      for all .pnm files!)

</pre>
      </blockquote>
    </div>

<!-- ********************** WISHLIST ******************************* -->

    <div id="wishlist">
      <h2> Feature Wishlist </h2>
      <p> This is a place to jot down ideas for desired features.
      However, once they have been explored more thoroughly, they will
      be moved into the Design/Implementation/Infrastructure sections.
      <blockquote>
<pre>
</pre>
      </blockquote>
    </div>

</div>

<!-- ************************* Stop Inserting Text ******************** -->

            </td>

            <!-- begin side bar -->
            <td class="right" width="200">
<?php 
 include_once("sidebar.php");
?>

            </td>
            
            <!-- end side bar -->

          </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td class="nopad">
<?php 
 include_once("footer.php");
?>
      </td>
    </tr>
  </tbody>
</table>


</body>
</html>
