<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Conjecture - Usage</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-15">
  <!-- link rel="icon" href="conjecture.ico" type="image/x-icon" -->
  <!-- link rel="shortcut icon" href="conjecture.ico" type="image/x-icon" -->
  <link rel="stylesheet" href="style.css" type="text/css" title="plain">
</head>
<body>
<table class="nopad" align="left" border="0" cellpadding="0"
 cellspacing="0" width="100%">
  <tbody>
    <tr>
      <td class="nopad">
<?php 
 $mainvalue='Usage';
 $subvalue='';
 include_once("header.php");
?>
      </td>
    </tr>
    <tr>
      <td>
      
      <table class="nopad" align="left" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tbody>
          <tr valign="top">
            <td class="content">

<!-- NOTE: We must find a cleaner CSS design for implementing these pages! -->

<!-- ************************* Insert Text Here ********************** -->
<div>
  <h1>Usage</h1>
  <blockquote>
     <p>This document provides some discussion on how to use the
     <code>conjecture</code> executable and the numerous supporting
     scripts provided by the Conjecture framework.

     <p>This discussion assumes that you have already <A
     HREF="download.php#installation">installed</A> Conjecture, have
     added <code>$CONJECTURE/bin</code> to your <code>PATH</code>, and
     have added <code>$CONJECTURE/lib/perl</code> to your
     <code>PERLLIB</code>.

  </blockquote>

  <div id="overview">
    <h2> Overview </h2>
    <blockquote>

  <p> We start out with some simple checks. The following commands
  ensure that you have set your <code>PATH</code> properly. If you get
  errors, or if the paths reported aren't
  <code>$CONJECTURE/bin/*</code>, there is a problem.

  <pre>
   prompt% cd $CONJECTURE
   prompt% which conjecture
   prompt% which ocrdiff
   prompt% which ocrfind
   prompt% which ocrgen
  </pre>

  <p>The following shows the database of images currently available
  (it is currently very small). We (you :-) will be growing this
  database over time. If you have images of interest, please feel free
  to submit them (with some caveats).

  <pre>
   prompt% cd harness/db
  </pre>

  <p>The following assumes you have the <code>display</code> program
  on your machine. Any program that can display .pnm files will work
  just as well, of course (<code>xv</code>, <code>gimp</code>, etc.).
  The <code>rod.pnm</code> file is my current preferred test image
  (for D&D enthusiasts it might be recognizable), simply because it is
  the first image I tried to process when I looked at gocr.

  <pre>
   prompt% display rod.pnm &
  </pre>

  <p>The following command invokes the <code>conjecture</code>
  executable, specifying <code>rod.pnm</code> as the input image file,
  and <code>rod.ocr</code> as the output text file. NOTE: Conjecture
  usually uses the <code>.ocr</code> suffix to represent text output
  from an execution of <code>conjecture</code>).

  <pre>
   prompt% conjecture -i rod.pnm -o rod-default.ocr
   prompt% rod-default.ocr
  </pre>

  <p> The output produced by the above is:
  <pre>
   rejDui,lding rhe Ällu,mian cullectiun af iore uncil ic again
   macches che shelve5 nfThe Library aftke Sublime.
   AdveJ_tu_e Hook: A ja_tian amang tke githyanXi is
   rumored tu hn_e reassembled a workine copy oÃÂ®rhe Rinlal
  </pre>

  <p> Now, visually compare the above output with the desired output:

  <pre>
   rebuilding the illumian collection of lore until it again
   matches the shelves of the Library of the Sublime.
     Adventure Hook: A faction among the githyanki is
   rumored to have reassembled a working copy of the Ritual
  </pre>

  <p> Note that it is certainly not perfect, but does manage to
  recognize a fair number of characters. Note also that it isn't easy
  to tell where the differences are at a glance (we will address this
  issue below).

  <p> The following also invokes <code>conjecture</code>, but
  explicitly specifies which <A HREF="modules.php">OCR Module</A> to
  use (in this case, the <code>gocr</code> module). Note that
  Conjecture started out being a restructuring of gocr, but quickly
  evolved into a much more general framework. Although gocr is
  currently the basis for all of the functional code, this is expected
  to change relatively soon, with other third-party OCRs (and personal
  OCR contributions) coming to hold equal weight with gocr.

  <pre>
   prompt% conjecture -M gocr -i rod.pnm -o rod-gocr.ocr
  </pre>

  <p> The following shows that not specifying a <code>-M</code> flag
  appears to produce the same output as using <code>-M gocr</code>.

  <pre>
   prompt% diff rod-default.ocr rod-gocr.ocr
  </pre>

  <p> Although the above would make immediate sense if the default
  value for <code>-M</code> were <code>gocr</code>, that isn't
  actually the case, as the default value is <code>default</code>.
  However, the <code>DefaultModule</code> currently inherits from
  <code>GocrModule</code>, does not redefine anything, and thus
  produces the same output as gocr. This will change as Conjecture
  evolves and the best component implementations are identified (the
  <code>default</code> module is meant to be the "best" overall OCR we
  know how to make at any given time.

  <p> The following uses the <code>ocrad</code> module. Note that this
  may not succeed if <code>ocrad</code> failed to compile on your
  architecture (support for <code>ocrad</code> has not been tested
  very thoroughly yet). 

  <pre>
   prompt% conjecture -M ocrad -i rod.pnm -o rod-ocrad.ocr
   prompt% cat rod-ocrad.ocr
  </pre>

  <p>The output generated by the <code>ocrad</code> module for this input
  file is:

  <pre>
   T_b_lldLng _he LIL_rman tollPt_lon o_ lo__ unTll |_ ag_In
   m__ch<_ _he __el_e_ o__hc Llb_ary oF[hP Subllm_
   Ad_c7lu_e Hook. A _a__Lon among lhe g__hy_nhl |_
   __mo_Pd _o há_e Tea__crnble_ a woTkl_g copy oF[hc RL_Llal
  </pre>

  <p> The current mechanism that Conjecture is using to provide access
  to <code>ocrad</code> is quite different than the mechanism used to
  provide <code>gocr</code>. In particular, the <code>gocr</code>
  library is compiled directly into the <code>conjecture</code>
  executable, and its codebase is available for programmers to
  explore, modify and borrow as desired. On the other hand, currently
  the <code>ocrad</code> OCR is being supported by using a sub-process
  that invokes <code>ocrad</code>. As such, Conjecture does not have
  any access to its internals, and programmers cannot explore, modify
  and borrow from it. This is temporary (Conjecture will be providing
  direct access to <code>ocrad</code> when we (you) add such support),
  but in the mean time it is a useful means of demonstrating how
  flexible Conjecture is in what kinds of external OCRs it can
  support.

  <p> I was surprised to discover that most open-source OCR projects
  appear to be lacking facilities for assessing the accuracy of their
  codebase [wmh: is this true?]. Which I find rather puzzling, as it
  seems like a rather important feature for developers wanting to
  assess the relative merits of different strategies for solving
  OCR-related issues. 
 
  <p>In any event, Conjecture provides the ever-so-handy
  <code>ocrdiff</code> script. It accepts two files as arguments, the
  first one being the output generated by an OCR, and the second one
  being the "canonical" output (the output that an OCR would produce
  if it were 100% accurate).  For example, we can establish the
  accuracy of the <code>gocr</code> module on the <code>rod.pnm</code>
  input file as follows:

  <pre> 
   prompt% ocrdiff -F rod rod-gocr.ocr rod.valid
  </pre>

  <p> Note the use of <code>rod.valid</code> in the above command. It
  is assumed you are still in the <code>harness/db</code> directory.
  In addition to maintaining a collection of images useful for testing
  purposes, the <code>harness/db</code> directory also maintains
  "canonical" text files for each image file. These files have a
  <code>.valid</code> suffix.

  <p>The above <code>ocrdiff</code> command produces the following on
  <code>stderr</code>:

  <pre>
   Writing to tmp.{od,od+,od-}
   Results Summary:
      OCR  File : rod-gocr.ocr    (  218 chars,  4 lines)
      Goal File : rod.valid       (  217 chars,  4 lines)
      Missing   :     4
      Spurious  :     5
      Mismatches:    33
      All Errors:    42
      Accuracy  :    80.6%        (1-(42/217))*100
  </pre>

  <p> From this output, we can see that the <code>gocr</code> module
  has an overall accuracy of 80.6% for the input image in question. It
  missed segmenting 4 glyphs (possibly because segmentation identified
  two glyphs as one in 4 situations), generated 5 excess glyphs
  (possibly because it split what should have been one glyph into two
  glyphs), and incorrectly identified 33 glyphs (out of 217).

  <p>In addition to the above output, the <code>ocrdiff</code> script
  creates three files. The full details can be found by executing

  <pre>
    prompt% ocrdiff -h
  </pre>

  so here we will only present a very brief discussion of the most
  useful of these generated files, <code>tmp.od</code>. This file
  provides a sophisticated character-by-character difference summary,
  and although the output at first might appear somewhat unintuitive,
  it ends up being a very useful way to understand where the OCR is
  failing, and where it is succeeding.

  <pre>
   ---------- Line   1/  1 ------------------------------------------
      |rejDui,lding rhe D%llu,mian cullectiun af iore uncil ic again
      |rejDui,lding rhe D%llu,mian cullectiun af iore uncil ic again
    13|  jD  ,      r   D%   ,      u      u  a  i      c    c      
     9|  $b  $      t   $i   $      o      o  o  l      t    t      
     4|re$bui$lding the $illu$mian collection of lore until it again
      |rebuilding the illumian collection of lore until it again
   ---------- Line   2/  2 ------------------------------------------
      |macches che shelve5 nfThe Library aftke Sublime.
     2|macches che shelve5 nf$The Library af$tke Sublime.
     9|  c     c         5 n $T           a $ k          
     7|  t     t         s o  t           o   h          
      |matches the shelves of the Library of the Sublime.
      |matches the shelves of the Library of the Sublime.
   ---------- Line   3/  3 ------------------------------------------
      |AdveJ_tu_e Hook: A ja_tian amang tke githyanXi is
     2|$$AdveJ_tu_e Hook: A ja_tian amang tke githyanXi is
    11|$$    J_  _          j _  a    a    k         X    
     8|      $n  r          f c  o    o    h         k    
     1|  Adve$nture Hook: A faction among the githyanki is
      |  Adventure Hook: A faction among the githyanki is
   ---------- Line   4/  4 ------------------------------------------
      |rumored tu hn_e reassembled a workine copy oC.rhe Rinlal
      |rumored tu hn_e reassembled a workine copy oC.rhe Rinlal
     9|         u  n_                      e       C.r     nl  
     9|         o  av                      g       f t     tu  
      |rumored to have reassembled a working copy of the Ritual
      |rumored to have reassembled a working copy of the Ritual
  </pre>

  <p> Each line in the two input files generates 6 lines in this
  output file (plus an initial header that displays the corresponding
  line numbers within the two files. Details on the format are again
  available via <code>ocrdiff -h</code>. For now, suffice it to say
  that lines 4 and 5 of each 7-line "record" shows the set of
  characters that failed (line 4 shows the OCR predictions, line 5 is
  shows the correct characters). In these two lines of output, only
  characters that differ are shown, and thus allow us to see at a
  glance where the OCR is failing.

  <p>For example, let's look at the second record in the above output
  (the record of 7 lines starting with a line containing <code>Line 2/
  2</code>). The first line after the header shows what the gocr OCR
  generated. The last line in the record (just before the <code>
  ------..</code>) shows what should have been generated. The second
  and second-last lines show the input strings after special
  <code>$</code> characters have been inserted to maximize the amount
  of character-to-character correspondence. This process is critical
  to the proper functioning of <code>ocrdiff</code> (discussed in more
  detail in <code>ocrdiff</code> help). The numbers to the left of
  these lines indicate how many <code>$</code> characters were
  inserted, and correspond respectively to the number of characters
  the OCR missed (didn't segment into as glyphs) and the number of
  characters the OCR mistakenly identified as being two characters.

  <p> The middle two lines, as already mentioned, show only those
  characters that differ, and analyzing these lines can give some
  useful insight into what is going wrong. Note that the first
  mismatch is <code>c</code> vs. <code>t</code>. For the given input
  image, these two characters look surprisingly similar, so it isn't
  surprising that gocr is having difficulties with them. The same is
  true of all of the other mismatches on the line.  Note that the
  existence of <code>$</code> characters also indicates that
  gocr failed to identify two glyphs in this line.

  <p> Having briefly explain what <code>ocrdiff</code> does, let's now
  use it to assess the accuracy of the ocrad module. The
  <code>-F</code> flag specifies what file prefix to use when
  generating the <code>.od</code> file(s).

  <pre>
   prompt% ocrdiff -F rod-ocrad rod-ocrad.ocr rod.valid
  </pre>

  which produces the following on <code>stderr</code>:

  <pre>
   Writing to rod-ocrad.{od,od+,od-}
   Results Summary:
      OCR  File : rod-ocrad.ocr   (  214 chars,  5 lines)
      Goal File : rod.valid       (  217 chars,  4 lines)
      Missing   :     6
      Spurious  :     2
      Mismatches:    84
      All Errors:    92
      Accuracy  :    57.6%        (1-(92/217))*100
  </pre>

  <p> From the above, we can see that the <code>ocrad</code> module is
  given much poorer results than <code>gocr</code> for this particular
  input image (using the default parameter values for each module).
  However, keep in mind that the input image, and the parameters sent
  to each ocr, can have a huge affect on overall accuracy.


  <p>The preceeding discussion provides a very brief overview of how
  to get started with <code>conjecture</code>. However, there are many
  command-line flags not yet discussed, and numerous other useful
  scripts provided by Conjecture. Of these scripts, one in particular
  is very useful for individuals wanting to gain a familiarity with
  the Conjecture infrastructure and codebase. If you want to search
  for an arbitrary string among all possible places it might reside,
  you can use <code>ocrfind</code>.

  <pre>
   prompt% ocrfind -u
  </pre>

  <p>The above creates a database of files that <code>ocrfind</code> will
  use in searches.  It takes awhile, but only needs to be generated
  once a day (or so).

  The command

  <pre>
   prompt% ocrfind -h
  </pre>

  gives more details on how to use this script. Keep it in mind,
  because it can be very useful if you are planning on contributing to
  Conjecture in any way.

    </blockquote>
  </div>

  <div id="advanced">
    <h2> Advanced Usage </h2>
    <blockquote>
      Text here
    </blockquote>
  </div>

  <div id="scripts">
    <h2> Scripts </h2>
    <blockquote>
      Text here
    </blockquote>
  </div>

</div>

<!-- ************************* Stop Inserting Text ******************** -->

            </td>

            <!-- begin side bar -->
            <td class="right" width="200">
<?php 
 include_once("sidebar.php");
?>

            </td>
            
            <!-- end side bar -->

          </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td class="nopad">
<?php 
 include_once("footer.php");
?>
      </td>
    </tr>
  </tbody>
</table>


</body>
</html>
