using namespace std;
# include <iostream>
# include "DefaultModule.h"

// ####################################################################
// # Conjecture: An Extensible Optical Character Recognition Framework  #
// #                                                                  #
// # Copyright: Lesser GNU Public License (LGPL)                      #
// #                                                                  #
// # Overview:                                                        #
// #  - Conjecture is a collection of C++ classes, and an OCR engine    #
// #  - Conjecture is designed to allow customization at all levels     #
// #    and to encourage individuals to contribute incremental        #
// #    improvements in algorithms.                                   #
// #  - Overall design discussions can be found in                    #
// #      $SNROOT/docs/doxygen/html/index.html                        #
// #  - Conjecture is designed to interact with and build on other      #
// #    open-source OCR programs.                                     #
// ####################################################################

// Include
#include "StandardProcess.h"
#include "GocrSegment.h"
#include "GocrIdentify.h"
#include "GocrFormat.h"

namespace Conjecture {

  DefaultModule::DefaultModule() {
    // Default Constructor
  }

  // Interface
  ProcessComponent* DefaultModule::createProcessComponent()   const { return new StandardProcess(); }
  SegmentComponent* DefaultModule::createSegmentComponent()   const { return new GocrSegment();     }
  IdentifyComponent* DefaultModule::createIdentifyComponent() const { return new GocrIdentify();    }
  FormatComponent* DefaultModule::createFormatComponent()     const { return new GocrFormat();      }

};

