# ifndef Conjecture_GocrIdentify_h
# define Conjecture_GocrIdentify_h Conjecture_GocrIdentify_h

// Insert SVN header substitution variable here
// Created by wade
// Class Champion: Unassigned

# include "IdentifyComponent.h" // parent

namespace Conjecture {
    class Page;
    
    /** ****************************************************************
     * \class GocrIdentify
     *
     * \brief The abstract superclass of a hierarchy of classes
     * implementing the 'partition' algorithm, which is minimally
     * responsible for identifying the sub-regions of the Page that
     * represent individual Glyphs.  The algorithm may do more than
     * just identify Glyphs however (i.e. may also identify Words,
     * Lines and/or Regions too).
     *
     * This algorithm is the first one called by StandardProcess.
     *
     ******************************************************************/

    class GocrIdentify : public IdentifyComponent {
      public:
	GocrIdentify();
	virtual bool execute(Page* page);
    };
}

# endif // Conjecture_GocrIdentify_h

