# ifndef Conjecture_GocrSegment_h
# define Conjecture_GocrSegment_h Conjecture_GocrSegment_h

// Insert SVN header substitution variable here
// Created by wade
// Class Champion: Unassigned

# include "SegmentComponent.h" // parent

namespace Conjecture {
    class Page;
    
    /** ****************************************************************
     * \class GocrSegment
     *
     * \brief The abstract superclass of a hierarchy of classes
     * implementing the 'Segment' algorithm, which is minimally
     * responsible for identifying the sub-regions of the Page that
     * represent individual Glyphs.  The algorithm may do more than
     * just identify Glyphs however (i.e. may also identify Words,
     * Lines and/or Regions too).
     *
     * This algorithm is the first one called by StandardProcess.
     *
     ******************************************************************/
     
    class GocrSegment : public SegmentComponent {
      public:
	GocrSegment();
	virtual bool execute(Page* page);
    };
}

# endif // Conjecture_GocrSegment_h

