using namespace std;
# include <iostream>
# include "OcradModule.h"

// ####################################################################
// # Conjecture: An Extensible Optical Character Recognition Framework  #
// #                                                                  #
// # Copyright: Lesser GNU Public License (LGPL)                      #
// #                                                                  #
// # Overview:                                                        #
// #  - Conjecture is a collection of C++ classes, and an OCR engine    #
// #  - Conjecture is designed to allow customization at all levels     #
// #    and to encourage individuals to contribute incremental        #
// #    improvements in algorithms.                                   #
// #  - Overall design discussions can be found in                    #
// #      $SNROOT/docs/doxygen/html/index.html                        #
// #  - Conjecture is designed to interact with and build on other      #
// #    open-source OCR programs.                                     #
// ####################################################################

// Include
#include "OcradProcess.h"

namespace Conjecture {

  OcradModule::OcradModule() {
    // Default Constructor
  }

  // Interface
  ProcessComponent* OcradModule::createProcessComponent() const { return new OcradProcess(); }
  SegmentComponent* OcradModule::createSegmentComponent() const { return NULL; }
  IdentifyComponent* OcradModule::createIdentifyComponent() const { return NULL; }
  FormatComponent* OcradModule::createFormatComponent() const { return NULL; }

};

