# ifndef Conjecture_OcradModule_h
# define Conjecture_OcradModule_h Conjecture_OcradModule_h

// Insert SVN header substitution variable here
// Created by wade
// Class Champion: Unassigned

# include "OCRModule.h" // parent

namespace Conjecture {

    /** ****************************************************************
     * \class OcradModule
     *
     * \brief A wrapper for the third-party open-source Ocrad OCR
     *
     * The current implementation of Ocrad is temporary - it invokes
     * 'ocrad' in a subprocess, thus delegating all responsiblity to
     * an external program and providing no access to the internals.
     *
     * An implementation that links the Ocrad library into Conjecture,
     * similar to what was done for Gocr, will be provided when
     * someone finds time to do so.
     *
     ******************************************************************/

    class OcradModule : public OCRModule {
      public:
        // Constructors/Destructors
        OcradModule();
        
        // **************
        // Interface
        virtual ProcessComponent*     createProcessComponent() const;
        virtual SegmentComponent*     createSegmentComponent() const;
        virtual IdentifyComponent*    createIdentifyComponent() const;
        virtual FormatComponent*      createFormatComponent() const;
    };
}

# endif // Conjecture_OcradModule_h

