using namespace std;
# include <iostream>
# include <sstream>
# include "OcradProcess.h"
# include <stdlib.h>
# include "Env.h"

// Include

namespace Conjecture {

  OcradProcess::OcradProcess() {
    // Default Constructor
  }

  // Interface
  bool OcradProcess::execute(Page* page) {
    bool result = false;

    // Establish the input/output files desired
    const Env* env = page->env();
    const string& infile = env->infile();
    const string& outfile = env->outfile();

    // Create a 'command' string that will invoke 'ocrad'
    stringstream s;
    s << "ocrad ";
    string flags = env->rawdata();
    if ( flags.size() > 0 ) { s << flags << " "; }
    s << "-o \"" << outfile << "\" ";
    s << "\"" << infile << "\"";

    string command = s.str();
    cerr << "NOTE: Executing '" << command << "'" << endl;
    int res = system(command.c_str());
    if ( res != 0 ) {
      result = false;
    } else {
      result = true;
    }
    return result;
  }

};

