# ifndef Conjecture_WmhSegment_h
# define Conjecture_WmhSegment_h Conjecture_WmhSegment_h

// Insert SVN header substitution variable here
// Created by wade
// Class Champion: Unassigned

# include "SegmentComponent.h" // parent

namespace Conjecture {
    
    /** ****************************************************************
     * \class WmhSegment
     *
     * \brief Responsible for sub-dividing the Page into Glyphs (and,
     * optionally, Words, Lines and Parts).
     *
     * The abstract superclass of a hierarchy of classes implementing
     * the 'Segment' algorithm, which is minimally responsible for
     * identifying the sub-regions of the Page that represent
     * individual Glyphs. The algorithm may do more than just
     * identify Glyphs however (i.e. may also identify Words, Lines
     * and/or Regions too).
     *
     ******************************************************************/

    class WmhSegment : public SegmentComponent {
      public:
        WmhSegment();
        virtual bool execute(Page* page);
    };
}

# endif // Conjecture_WmhSegment_h

