package Meta::Doc::Lib::Axis;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Object);
use Meta::Lib::Object;

###
# The associations of this class (importation)
use IO::File;
use Carp;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: Axis.type
#   line 713 "graph.meta"
sub type { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'type()'\n"); $_[0]->{__meta_type} = $_[1]; } else { return $_[0]->{__meta_type}; } }
sub typeVal { return $_[0]->{__meta_type}; }
sub getType { return $_[0]->{__meta_type}; }
sub setType { $_[0]->{__meta_type} = $_[1]; }
sub typeSet { $_[0]->{__meta_type} = $_[1]; printf(STDERR "WARNING: Using deprecated typeSet setter\n"); }
sub typeIs { $_[0]->{__meta_type} = $_[1]; }
sub typeRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'type()'\n"); $_[0]->{__meta_type} = $_[1]; } else { return $_[0]->{__meta_type}; } }
    # METALINE: Axis.format
#   line 721 "graph.meta"
sub format { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'format()'\n"); $_[0]->{__meta_format} = $_[1]; } else { return $_[0]->{__meta_format}; } }
sub formatVal { return $_[0]->{__meta_format}; }
sub getFormat { return $_[0]->{__meta_format}; }
sub setFormat { $_[0]->{__meta_format} = $_[1]; }
sub formatSet { $_[0]->{__meta_format} = $_[1]; printf(STDERR "WARNING: Using deprecated formatSet setter\n"); }
sub formatIs { $_[0]->{__meta_format} = $_[1]; }
sub formatRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'format()'\n"); $_[0]->{__meta_format} = $_[1]; } else { return $_[0]->{__meta_format}; } }
    # METALINE: Axis.title
#   line 727 "graph.meta"
sub title { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'title()'\n"); $_[0]->{__meta_title} = $_[1]; } else { return $_[0]->{__meta_title}; } }
sub titleVal { return $_[0]->{__meta_title}; }
sub getTitle { return $_[0]->{__meta_title}; }
sub setTitle { $_[0]->{__meta_title} = $_[1]; }
sub titleSet { $_[0]->{__meta_title} = $_[1]; printf(STDERR "WARNING: Using deprecated titleSet setter\n"); }
sub titleIs { $_[0]->{__meta_title} = $_[1]; }
sub titleRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'title()'\n"); $_[0]->{__meta_title} = $_[1]; } else { return $_[0]->{__meta_title}; } }

#class INITIALIZER 'basicNew'
# METALINE: Meta.Doc.Lib.Axis.basicNew(Meta!StrVMeta!StrV)
#line 731 "graph.meta"
sub basicNew {
    my $__meta_sig = 'Meta.Doc.Lib::Axis::basicNew(Meta!Str class, Meta!Str@ title, Meta!Str@ type = \'real.2\')'; carp("ERROR: $__meta_sig:\n       Expecting between 2 and 3 arguments but found " . scalar(@_) . ".") if ( ( @_ < 2 ) || ( @_ > 3 ) );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $title = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'title' = '$title' should have ref '' but has ref '" . CORE::ref($title) . "'") unless ( ( !defined($title)) || ( CORE::ref($title) eq ''));
    my $type = $_[2]; $type = 'real.2' unless defined($type); carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.Axis.basicNew(Meta!StrVMeta!StrV)SCOPE
#   line 732 "graph.meta"

    $self->setTitle($title);
    if ( $type eq 'int' ) {
      $self->setType($type);
      $self->setFormat('%10d');
    } elsif ( $type =~ m/real(?:\.(\d+))?/ ) {
      my $spec = $1;
      $spec = 2 unless defined($spec);
      $self->setType($type);
      $self->setFormat("%16.${spec}lf");
    }
    # Inserted by Meta
    return $self;

}

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.Axis.__C6__(Meta!StrV)
#line 744 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::Axis::new(Meta!Str class, Meta!Str@ spec)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $spec = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'spec' = '$spec' should have ref '' but has ref '" . CORE::ref($spec) . "'") unless ( ( !defined($spec)) || ( CORE::ref($spec) eq ''));
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.Axis.__C6__(Meta!StrV)SCOPE
#   line 759 "graph.meta"

    my $type = 'real.2';
    if ( $spec =~ s/\s*\(\s*type\s*(.*\S)\s*\)\s*$// ) {
      $type = $1;
    }
    return $class->basicNew($spec, $type);
    # Inserted by Meta
    return $self;

}

#instance METHOD 'asSpec'
# METALINE: Meta.Doc.Lib.Axis.asSpec()
#line 766 "graph.meta"
sub asSpec {
    my $__meta_sig = 'Meta.Doc.Lib::Axis::asSpec(Meta.Doc.Lib.Axis#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Axis') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Axis.asSpec()SCOPE
#   line 768 "graph.meta"

    return $self->title() . ' (type ' . $self->type() . ')';

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_type'        => '',
         '__meta_format'      => '',
         '__meta_title'       => '',
    });
}

sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for Axis (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">Axis.out");
        close(STDERR); open(STDERR, ">Axis.err");
    }

    # Start of user-provided code
    print("No unit test has been provided for CLASS Axis\n");
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'Axis.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Axis.out"); } unlink('Axis.out') unless ( $verbose > 2);
        if ( ( -s 'Axis.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Axis.err"); } unlink('Axis.err') unless ( $verbose > 2);
    }

}
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS Axis\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
