package Meta::Doc::Lib::CompositePlot;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Doc::Lib::PlotInterface);
use Meta::Doc::Lib::PlotInterface;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Plot;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: CompositePlot.plots
#   line 419 "graph.meta"
sub plots { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'plots()'\n"); $_[0]->{__meta_plots} = $_[1]; } else { return $_[0]->{__meta_plots}; } }
sub plotsVal { return $_[0]->{__meta_plots}; }
sub getPlots { return $_[0]->{__meta_plots}; }
sub setPlots { $_[0]->{__meta_plots} = $_[1]; }
sub plotsSet { $_[0]->{__meta_plots} = $_[1]; printf(STDERR "WARNING: Using deprecated plotsSet setter\n"); }
sub plotsIs { $_[0]->{__meta_plots} = $_[1]; }
sub plotsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'plots()'\n"); $_[0]->{__meta_plots} = $_[1]; } else { return $_[0]->{__meta_plots}; } }
sub getPlot { return $_[0]->{__meta_plots}->[$_[1]]; }
sub plot { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'plot()'\n"); $_[0]->{__meta_plots}->[$_[1]] = $_[2]; } else { return $_[0]->{__meta_plots}->[$_[1]]; } }
sub setPlot { $_[0]->{__meta_plots}->[$_[1]] = $_[2]; }
sub numPlot { return scalar(@{$_[0]->{__meta_plots}}); }
sub addPlot { push(@{$_[0]->{__meta_plots}}, $_[1]); }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.CompositePlot.__C3__(Meta!Vec<Meta.Doc.Lib.PlotP>P)
#line 421 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::CompositePlot::new(Meta!Str class, Meta!Vec<Meta.Doc.Lib.Plot*>* initial = undef)'; carp("ERROR: $__meta_sig:\n       Expecting between 1 and 2 arguments but found " . scalar(@_) . ".") if ( ( @_ < 1 ) || ( @_ > 2 ) );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $initial = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'initial' = '$initial' should have ref 'ARRAY' but has ref '" . CORE::ref($initial) . "'") unless ( ( !defined($initial)) || ( CORE::ref($initial) eq 'ARRAY'));
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.CompositePlot.__C3__(Meta!Vec<Meta.Doc.Lib.PlotP>P)SCOPE
#   line 422 "graph.meta"

    if ( $initial ) {
      foreach my $plot (@$initial) {
        $self->registerPlot($plot);
      }
    }
    # Inserted by Meta
    return $self;

}

#instance METHOD 'newPlot'
# METALINE: Meta.Doc.Lib.CompositePlot.newPlot(Meta!StrV...V)
#line 429 "graph.meta"
sub newPlot {
    my $__meta_sig = 'Meta.Doc.Lib::CompositePlot::newPlot(Meta.Doc.Lib.CompositePlot#* self, Meta!Str@ title, ...@ axes)'; carp("ERROR: $__meta_sig:\n       Expecting at least 2 arguments but found " . scalar(@_) . ".") if ( @_ < 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::CompositePlot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::CompositePlot') ) ) );
    my $title = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'title' = '$title' should have ref '' but has ref '" . CORE::ref($title) . "'") unless ( ( !defined($title)) || ( CORE::ref($title) eq ''));
    my @axes = @_[2..$#_];
    #

    # METALINE: Meta.Doc.Lib.CompositePlot.newPlot(Meta!StrV...V)SCOPE
#   line 430 "graph.meta"

    my $plot = Meta::Doc::Lib::Plot->new($title, @axes);
    $self->registerPlot($plot);
    return $plot;

}

#instance METHOD 'registerPlot'
# METALINE: Meta.Doc.Lib.CompositePlot.registerPlot(Meta.Doc.Lib.PlotP)
#line 435 "graph.meta"
sub registerPlot {
    my $__meta_sig = 'Meta.Doc.Lib::CompositePlot::registerPlot(Meta.Doc.Lib.CompositePlot#* self, Meta.Doc.Lib.Plot* plot)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::CompositePlot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::CompositePlot') ) ) );
    my $plot = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'plot' = '$plot' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $plot ) || ( ref($plot) && ( $plot->isa('Meta::Doc::Lib::Plot') ) ) );
    #

    # METALINE: Meta.Doc.Lib.CompositePlot.registerPlot(Meta.Doc.Lib.PlotP)SCOPE
#   line 438 "graph.meta"

    my $plots = $self->plots();
    push(@$plots, $plot);

}

#instance METHOD 'propogateGnuplotVars'
# METALINE: Meta.Doc.Lib.CompositePlot.propogateGnuplotVars()
#line 442 "graph.meta"
sub propogateGnuplotVars {
    my $__meta_sig = 'Meta.Doc.Lib::CompositePlot::propogateGnuplotVars(Meta.Doc.Lib.CompositePlot#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::CompositePlot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::CompositePlot') ) ) );
    #

    # METALINE: Meta.Doc.Lib.CompositePlot.propogateGnuplotVars()SCOPE
#   line 448 "graph.meta"

    my $varset = $self->varsSet();
    my $plots = $self->plots();
    foreach my $plot (@$plots) {
      $plot->mergeGnuplotVars($varset);
    }

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_plots'       => [],
    });
}

sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for CompositePlot (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">CompositePlot.out");
        close(STDERR); open(STDERR, ">CompositePlot.err");
    }

    # Start of user-provided code
    print("No unit test has been provided for CLASS CompositePlot\n");
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'CompositePlot.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat CompositePlot.out"); } unlink('CompositePlot.out') unless ( $verbose > 2);
        if ( ( -s 'CompositePlot.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat CompositePlot.err"); } unlink('CompositePlot.err') unless ( $verbose > 2);
    }

}
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS CompositePlot\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
