package Meta::Doc::Lib::Function;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Doc::Lib::FunctionInterface);
use Meta::Doc::Lib::FunctionInterface;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Axis;
use Meta::Doc::Lib::Point;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: Function.function
#   line 990 "graph.meta"
sub function { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'function()'\n"); $_[0]->{__meta_function} = $_[1]; } else { return $_[0]->{__meta_function}; } }
sub functionVal { return $_[0]->{__meta_function}; }
sub getFunction { return $_[0]->{__meta_function}; }
sub setFunction { $_[0]->{__meta_function} = $_[1]; }
sub functionSet { $_[0]->{__meta_function} = $_[1]; printf(STDERR "WARNING: Using deprecated functionSet setter\n"); }
sub functionIs { $_[0]->{__meta_function} = $_[1]; }
sub functionRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'function()'\n"); $_[0]->{__meta_function} = $_[1]; } else { return $_[0]->{__meta_function}; } }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.Function.__C9__(Meta!StrCRMeta!StrCR)
#line 1006 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::Function::new(Meta!Str class, Meta!Str#& spec, Meta!Str#& function)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $spec = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'spec' = '$spec' should have ref '' but has ref '" . CORE::ref($spec) . "'") unless ( ( !defined($spec)) || ( CORE::ref($spec) eq ''));
    my $function = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'function' = '$function' should have ref '' but has ref '" . CORE::ref($function) . "'") unless ( ( !defined($function)) || ( CORE::ref($function) eq ''));
    #
    my $self = $class->SUPER::new($spec);
    # METALINE: Meta.Doc.Lib.Function.__C9__(Meta!StrCRMeta!StrCR)SCOPE
#   line 1008 "graph.meta"

    $self->functionIs($function);
    # Inserted by Meta
    return $self;

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.Function.writeGnuplot(Meta!AnyP)
#line 1011 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::Function::writeGnuplot(Meta.Doc.Lib.Function#* self, Meta!Any* fp)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Function'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Function') ) ) );
    my $fp = $_[1];
    #

    # METALINE: Meta.Doc.Lib.Function.writeGnuplot(Meta!AnyP)SCOPE
#   line 1015 "graph.meta"

    ## Noop.

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_function'    => '',
    });
}

sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for Function (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">Function.out");
        close(STDERR); open(STDERR, ">Function.err");
    }

    # Start of user-provided code
    print("No unit test has been provided for CLASS Function\n");
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'Function.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Function.out"); } unlink('Function.out') unless ( $verbose > 2);
        if ( ( -s 'Function.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Function.err"); } unlink('Function.err') unless ( $verbose > 2);
    }

}
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS Function\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
