package Meta::Doc::Lib::FunctionInterface;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Object);
use Meta::Lib::Object;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Axis;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: FunctionInterface.title
#   line 787 "graph.meta"
sub title { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'title()'\n"); $_[0]->{__meta_title} = $_[1]; } else { return $_[0]->{__meta_title}; } }
sub titleVal { return $_[0]->{__meta_title}; }
sub getTitle { return $_[0]->{__meta_title}; }
sub setTitle { $_[0]->{__meta_title} = $_[1]; }
sub titleSet { $_[0]->{__meta_title} = $_[1]; printf(STDERR "WARNING: Using deprecated titleSet setter\n"); }
sub titleIs { $_[0]->{__meta_title} = $_[1]; }
sub titleRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'title()'\n"); $_[0]->{__meta_title} = $_[1]; } else { return $_[0]->{__meta_title}; } }
    # METALINE: FunctionInterface.axes
#   line 791 "graph.meta"
sub axes { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'axes()'\n"); $_[0]->{__meta_axes} = $_[1]; } else { return $_[0]->{__meta_axes}; } }
sub axesVal { return $_[0]->{__meta_axes}; }
sub getAxes { return $_[0]->{__meta_axes}; }
sub setAxes { $_[0]->{__meta_axes} = $_[1]; }
sub axesSet { $_[0]->{__meta_axes} = $_[1]; printf(STDERR "WARNING: Using deprecated axesSet setter\n"); }
sub axesIs { $_[0]->{__meta_axes} = $_[1]; }
sub axesRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'axes()'\n"); $_[0]->{__meta_axes} = $_[1]; } else { return $_[0]->{__meta_axes}; } }
sub getAxe { return $_[0]->{__meta_axes}->[$_[1]]; }
sub axe { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'axe()'\n"); $_[0]->{__meta_axes}->[$_[1]] = $_[2]; } else { return $_[0]->{__meta_axes}->[$_[1]]; } }
sub setAxe { $_[0]->{__meta_axes}->[$_[1]] = $_[2]; }
sub numAxe { return scalar(@{$_[0]->{__meta_axes}}); }
sub addAxe { push(@{$_[0]->{__meta_axes}}, $_[1]); }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.FunctionInterface.__C7__(Meta!StrCR)
#line 796 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::FunctionInterface::new(Meta!Str class, Meta!Str#& spec = \'\')'; carp("ERROR: $__meta_sig:\n       Expecting between 1 and 2 arguments but found " . scalar(@_) . ".") if ( ( @_ < 1 ) || ( @_ > 2 ) );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $spec = $_[1]; $spec = '' unless defined($spec); carp("ERROR: $__meta_sig:\n       Arg 'spec' = '$spec' should have ref '' but has ref '" . CORE::ref($spec) . "'") unless ( ( !defined($spec)) || ( CORE::ref($spec) eq ''));
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.FunctionInterface.__C7__(Meta!StrCR)SCOPE
#   line 812 "graph.meta"

    if ( $spec ) {
      if ( $spec =~ m/^(.*)\s+(?:versus|vs\.)\s+(.*)\s+KEY\s+(.*\S)/i ) {
        my ($a1,$a2,$title) = ($1,$2,$3);
        my $axis1 = Meta::Doc::Lib::Axis->new($a1);
        my $axis2 = Meta::Doc::Lib::Axis->new($a2);
        $self->init($title, $axis1, $axis2);
      } else {
        die("ERROR: Invalid Function spec '$spec'\n");
      }
    }
    # Inserted by Meta
    return $self;

}

#instance METHOD 'init'
# METALINE: Meta.Doc.Lib.FunctionInterface.init(Meta!StrCRMeta.Doc.Lib.AxisPMeta.Doc.Lib.AxisP)
#line 824 "graph.meta"
sub init {
    my $__meta_sig = 'Meta.Doc.Lib::FunctionInterface::init(Meta.Doc.Lib.FunctionInterface#* self, Meta!Str#& title, Meta.Doc.Lib.Axis* xaxis, Meta.Doc.Lib.Axis* yaxis)'; carp("ERROR: $__meta_sig:\n       Expecting 4 arguments but found " . scalar(@_) . ".") if ( @_ != 4 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::FunctionInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::FunctionInterface') ) ) );
    my $title = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'title' = '$title' should have ref '' but has ref '" . CORE::ref($title) . "'") unless ( ( !defined($title)) || ( CORE::ref($title) eq ''));
    my $xaxis = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'xaxis' = '$xaxis' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $xaxis ) || ( ref($xaxis) && ( $xaxis->isa('Meta::Doc::Lib::Axis') ) ) );
    my $yaxis = $_[3]; carp("ERROR: $__meta_sig:\n       Arg 'yaxis' = '$yaxis' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $yaxis ) || ( ref($yaxis) && ( $yaxis->isa('Meta::Doc::Lib::Axis') ) ) );
    #

    # METALINE: Meta.Doc.Lib.FunctionInterface.init(Meta!StrCRMeta.Doc.Lib.AxisPMeta.Doc.Lib.AxisP)SCOPE
#   line 828 "graph.meta"

    $self->setTitle($title);
    $self->setAxes( [ $xaxis, $yaxis ] );

}

#instance METHOD 'xaxis'
# METALINE: Meta.Doc.Lib.FunctionInterface.xaxis()
#line 832 "graph.meta"
sub xaxis {
    my $__meta_sig = 'Meta.Doc.Lib::FunctionInterface::xaxis(Meta.Doc.Lib.FunctionInterface#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::FunctionInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::FunctionInterface') ) ) );
    #

    # METALINE: Meta.Doc.Lib.FunctionInterface.xaxis()SCOPE
#   line 833 "graph.meta"

    return $self->axes()->[0];

}

#instance METHOD 'yaxis'
# METALINE: Meta.Doc.Lib.FunctionInterface.yaxis()
#line 836 "graph.meta"
sub yaxis {
    my $__meta_sig = 'Meta.Doc.Lib::FunctionInterface::yaxis(Meta.Doc.Lib.FunctionInterface#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::FunctionInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::FunctionInterface') ) ) );
    #

    # METALINE: Meta.Doc.Lib.FunctionInterface.yaxis()SCOPE
#   line 837 "graph.meta"

    return $self->axes()->[1];

}

#instance METHOD 'asSpec'
# METALINE: Meta.Doc.Lib.FunctionInterface.asSpec()
#line 840 "graph.meta"
sub asSpec {
    my $__meta_sig = 'Meta.Doc.Lib::FunctionInterface::asSpec(Meta.Doc.Lib.FunctionInterface#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::FunctionInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::FunctionInterface') ) ) );
    #

    # METALINE: Meta.Doc.Lib.FunctionInterface.asSpec()SCOPE
#   line 842 "graph.meta"

    return $self->xaxis()->asSpec() . ' vs. ' . $self->yaxis()->asSpec() . ' KEY ' . $self->title();

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.FunctionInterface.writeGnuplot(Meta!AnyP)
#line 845 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::FunctionInterface::writeGnuplot(Meta.Doc.Lib.FunctionInterface#* self, Meta!Any* fp)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::FunctionInterface'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::FunctionInterface') ) ) );
    my $fp = $_[1];
    #

    # METALINE: Meta.Doc.Lib.FunctionInterface.writeGnuplot(Meta!AnyP)SCOPE
#   line 845 "graph.meta"
$_[0]->__meta_subclassResponsibility("Meta.Doc.Lib::FunctionInterface::writeGnuplot(Meta.Doc.Lib.FunctionInterface#* self, Meta!Any* fp)");
}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_title'       => '',
         '__meta_axes'        => [],
    });
}

sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for FunctionInterface (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">FunctionInterface.out");
        close(STDERR); open(STDERR, ">FunctionInterface.err");
    }

    # Start of user-provided code
    print("No unit test has been provided for CLASS FunctionInterface\n");
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'FunctionInterface.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat FunctionInterface.out"); } unlink('FunctionInterface.out') unless ( $verbose > 2);
        if ( ( -s 'FunctionInterface.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat FunctionInterface.err"); } unlink('FunctionInterface.err') unless ( $verbose > 2);
    }

}
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS FunctionInterface\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
