package Meta::Doc::Lib::MultiPlot;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Doc::Lib::CompositePlot);
use Meta::Doc::Lib::CompositePlot;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Plot;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: MultiPlot.rows
#   line 468 "graph.meta"
sub rows { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'rows()'\n"); $_[0]->{__meta_rows} = $_[1]; } else { return $_[0]->{__meta_rows}; } }
sub rowsVal { return $_[0]->{__meta_rows}; }
sub getRows { return $_[0]->{__meta_rows}; }
sub setRows { $_[0]->{__meta_rows} = $_[1]; }
sub rowsSet { $_[0]->{__meta_rows} = $_[1]; printf(STDERR "WARNING: Using deprecated rowsSet setter\n"); }
sub rowsIs { $_[0]->{__meta_rows} = $_[1]; }
sub rowsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'rows()'\n"); $_[0]->{__meta_rows} = $_[1]; } else { return $_[0]->{__meta_rows}; } }
    # METALINE: MultiPlot.cols
#   line 469 "graph.meta"
sub cols { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'cols()'\n"); $_[0]->{__meta_cols} = $_[1]; } else { return $_[0]->{__meta_cols}; } }
sub colsVal { return $_[0]->{__meta_cols}; }
sub getCols { return $_[0]->{__meta_cols}; }
sub setCols { $_[0]->{__meta_cols} = $_[1]; }
sub colsSet { $_[0]->{__meta_cols} = $_[1]; printf(STDERR "WARNING: Using deprecated colsSet setter\n"); }
sub colsIs { $_[0]->{__meta_cols} = $_[1]; }
sub colsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'cols()'\n"); $_[0]->{__meta_cols} = $_[1]; } else { return $_[0]->{__meta_cols}; } }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.MultiPlot.__C4__(Meta!Vec<Meta.Doc.Lib.PlotP>P)
#line 471 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::MultiPlot::new(Meta!Str class, Meta!Vec<Meta.Doc.Lib.Plot*>* initial = undef)'; carp("ERROR: $__meta_sig:\n       Expecting between 1 and 2 arguments but found " . scalar(@_) . ".") if ( ( @_ < 1 ) || ( @_ > 2 ) );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $initial = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'initial' = '$initial' should have ref 'ARRAY' but has ref '" . CORE::ref($initial) . "'") unless ( ( !defined($initial)) || ( CORE::ref($initial) eq 'ARRAY'));
    #
    my $self = $class->SUPER::new($initial);
    # METALINE: Meta.Doc.Lib.MultiPlot.__C4__(Meta!Vec<Meta.Doc.Lib.PlotP>P)SCOPE
#   line 472 "graph.meta"
    # Inserted by Meta
    return $self;

}

#instance METHOD 'setSize'
# METALINE: Meta.Doc.Lib.MultiPlot.setSize(intVintV)
#line 474 "graph.meta"
sub setSize {
    my $__meta_sig = 'Meta.Doc.Lib::MultiPlot::setSize(Meta.Doc.Lib.MultiPlot#* self, int@ rows, int@ columns)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::MultiPlot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::MultiPlot') ) ) );
    my $rows = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'rows' = '$rows' should have ref '' but has ref '" . CORE::ref($rows) . "'") unless ( ( !defined($rows)) || ( CORE::ref($rows) eq '')); carp("ERROR: $__meta_sig:\n       Arg 'rows' = '$rows' fails to match type int") unless $rows =~ m/^[+-]?\d+$/;
    my $columns = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'columns' = '$columns' should have ref '' but has ref '" . CORE::ref($columns) . "'") unless ( ( !defined($columns)) || ( CORE::ref($columns) eq '')); carp("ERROR: $__meta_sig:\n       Arg 'columns' = '$columns' fails to match type int") unless $columns =~ m/^[+-]?\d+$/;
    #

    # METALINE: Meta.Doc.Lib.MultiPlot.setSize(intVintV)SCOPE
#   line 479 "graph.meta"

    $self->rowsIs($rows);
    $self->colsIs($columns);

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.MultiPlot.writeGnuplot(Meta!StrVMeta!StrV)
#line 483 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::MultiPlot::writeGnuplot(Meta.Doc.Lib.MultiPlot#* self, Meta!Str@ filebase, Meta!Str@ type)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::MultiPlot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::MultiPlot') ) ) );
    my $filebase = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'filebase' = '$filebase' should have ref '' but has ref '" . CORE::ref($filebase) . "'") unless ( ( !defined($filebase)) || ( CORE::ref($filebase) eq ''));
    my $type = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.MultiPlot.writeGnuplot(Meta!StrVMeta!StrV)SCOPE
#   line 495 "graph.meta"

    my $gpfile  = "$filebase.gp";

    ## The main .gp file (to be formed incrementally from the
    ## individual subplot .gp files).
    my $gp  = IO::File->new(">$gpfile")  || die("ERROR: Failed to open '$gpfile' for appending - $!");

    ## The plots to mulitplot
    my $plots = $self->plots();

    #####
    ## For MultiPlot instances, we do not propogate gnuplot variables
    ## into Plot instances. Instead, we write the default values
    ## before the 'multiplot' section.
    ##   FUTURE FIX: If we do this, we must either save the current
    ##   environment before so we can restore it after, or must
    ##   provide "undo" commands for each set. Obviously, store/load
    ##   is easier, but tends to be very inefficient.
    print($gp "save 'set.dat'\n");
    my $set = $self->varsSet();
    foreach my $s (sort(keys(%$set))) {
      printf($gp "set $s %s\n", $set->{$s});
    }

    ####
    ## Compute size considerations
    ##
    ## The size of each subplot is, by default, assumed to be dictated
    ## by $rows and $cols. The default position assumes that we tile
    ## the plots to fit the entire space. FUTURE FIX: Somehow allow
    ## individual plots to override their default size (and maybe even
    ## their default position).
    my $rows = $self->rows();
    my $cols = $self->cols();
    if ( ( $rows == 0 ) || ( $cols == 0 ) ) {
      ## A size has not been specified, so we perform a heuristic to
      ## establish an appropriate size.
      my $N = @$plots;
      $rows = int(sqrt($N)+0.5);
      $cols = int($N/$rows);
      if ( $rows*$cols < $N ) { ++$cols; }
      printf("NOTE: Heuristic dictates that for N=$N, r=$rows, c=$cols\n");
    }

    ## Normally, the entire plot space is used, but changing the
    ## following variables can make the overall plot arbitrarily sized
    ## and positioned. The multiplot will start at ($ox,$oy), and will
    ## be limited to the box from ($ox,$oy) to ($ox+$sx,$oy+$sy).
    my ($ox,$oy) = (0,0);  
    my ($sx,$sy) = (1,1);

    ## Each sub-plot is by default of size <dx,dy> and will have a
    ## position that depends on its order in the subplot listing, with
    ## plots starting in bottom left corner, tiling left till $cols
    ## subplots have been generated, then moving back left and up one
    ## row, tiling left, etc.
    my $width  = $sx-$ox;
    my $height = $sy-$oy;
    my $fx     = $width  / $cols;
    my $fy     = $height / $rows;

    my ($dx,$dy)   = (0,0); ## (0.05,0.05);
    my ($dfx,$dfy) = (0,0); ## (0.03,0.03);

    ## The origin of each subplot (modified each time thru loop)
    my ($x,$y) = ($ox,$oy); 

    ## Must insert some initial code into $gp to start the multiplot
    printf($gp "set multiplot\n");

    my $i = 0;
    my @gps;
    foreach my $plot (@$plots) {
      ++$i;

      if ( ! defined($plot) ) {
        ## null plots indicate desire to leave a blank spot
        print($gp "\n");
        print($gp "  # Sub-plot $i: empty plot\n");

      } else {
        ## Obtain the subplot specific filebase and create .gp and .gpd files.
        my $subbase = sprintf("$filebase%02d",$i);
        $plot->writeGnuplot($subbase, $type);

        ## Place control information in $gp dictating sub-plot size and position
        print($gp  "\n");
        print($gp  "  # Sub-plot $i:\n");
        printf($gp "  set size   %1.2f, %1.2f\n", ($fx+$dfx), ($fy+$dfy));
        printf($gp "  set origin %1.2f, %1.2f\n", ($x-$dx), ($y-$dy));

        ## Now read the generated subbase .gp file, mutating it as appropriate.
        my $ifp = IO::File->new("<$subbase.gp") || die("ERROR: Failed to open '$subbase.gp' for reading - $!");
        while (<$ifp>) {
          if ( ! m/^\s*pause/ ) {
            print($gp "  $_");
          } 
        }
      }

      ## Adjust <$x,$y>
      if ( ($i % $cols) == 0 ) {
        ## We are at the end of a column - move back to left side and
        ## move up a row.
        $x = $ox;
        $y += $fy;
      } else {
        ## Advance to the left.
        $x += $fx;
      }
    }

    ## Must insert some wrapup code into $gp to end the multiplot
    printf($gp "\nunset multiplot\n");
    print($gp  "pause -1 \"Press <CR> to continue...\"\n");
    print($gp "load 'set.dat'\n");

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_rows'        => 0,
         '__meta_cols'        => 0,
    });
}


#line 613 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for MultiPlot (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">MultiPlot.out");
        close(STDERR); open(STDERR, ">MultiPlot.err");
    }

    # Start of user-provided code
#line 613 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
    
    
      my $plot = Meta::Doc::Lib::Plot->new('First  example title', 'X-axis label', 'Y-axis label');
      my ($p1,$p2,$p3) = $plot->createMappings('Line1', 'Line2', 'Line3');
      foreach my $i (1,2,3,4,5) {
        $plot->addMultiPoint($i, $i+1, 2*$i+2, 3*$i+3);
      }
    
      my $plot2 = Meta::Doc::Lib::Plot->new('Second example title', 'X-axis label', 'Y-axis label');
      $plot2->createMappings('Line1', 'Line2', 'Line3');
      foreach my $i (1,2,3,4,5) {
        $plot2->addMultiPoint($i, $i+10, 2*$i+15, 3*$i+17);
      }
    
      my $plots = Meta::Doc::Lib::MultiPlot->new([$plot, undef, $plot2]);
      $plots->write('Data/multiplot');
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'MultiPlot.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat MultiPlot.out"); } unlink('MultiPlot.out') unless ( $verbose > 2);
        if ( ( -s 'MultiPlot.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat MultiPlot.err"); } unlink('MultiPlot.err') unless ( $verbose > 2);
    }

}

#line 613 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS MultiPlot\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
