package Meta::Doc::Lib::Plot;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Doc::Lib::PlotInterface);
use Meta::Doc::Lib::PlotInterface;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Doc::Lib::Axis;
use Meta::Doc::Lib::PointMap;
use Meta::Doc::Lib::Function;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: Plot.title
#   line 119 "graph.meta"
sub title { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'title()'\n"); $_[0]->{__meta_title} = $_[1]; } else { return $_[0]->{__meta_title}; } }
sub titleVal { return $_[0]->{__meta_title}; }
sub getTitle { return $_[0]->{__meta_title}; }
sub setTitle { $_[0]->{__meta_title} = $_[1]; }
sub titleSet { $_[0]->{__meta_title} = $_[1]; printf(STDERR "WARNING: Using deprecated titleSet setter\n"); }
sub titleIs { $_[0]->{__meta_title} = $_[1]; }
sub titleRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'title()'\n"); $_[0]->{__meta_title} = $_[1]; } else { return $_[0]->{__meta_title}; } }
    # METALINE: Plot.functions
#   line 123 "graph.meta"
sub functions { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'functions()'\n"); $_[0]->{__meta_functions} = $_[1]; } else { return $_[0]->{__meta_functions}; } }
sub functionsVal { return $_[0]->{__meta_functions}; }
sub getFunctions { return $_[0]->{__meta_functions}; }
sub setFunctions { $_[0]->{__meta_functions} = $_[1]; }
sub functionsSet { $_[0]->{__meta_functions} = $_[1]; printf(STDERR "WARNING: Using deprecated functionsSet setter\n"); }
sub functionsIs { $_[0]->{__meta_functions} = $_[1]; }
sub functionsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'functions()'\n"); $_[0]->{__meta_functions} = $_[1]; } else { return $_[0]->{__meta_functions}; } }
sub getFunction { return $_[0]->{__meta_functions}->[$_[1]]; }
sub function { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'function()'\n"); $_[0]->{__meta_functions}->[$_[1]] = $_[2]; } else { return $_[0]->{__meta_functions}->[$_[1]]; } }
sub setFunction { $_[0]->{__meta_functions}->[$_[1]] = $_[2]; }
sub numFunction { return scalar(@{$_[0]->{__meta_functions}}); }
sub addFunction { push(@{$_[0]->{__meta_functions}}, $_[1]); }
    # METALINE: Plot.activeFunctions
#   line 136 "graph.meta"
sub activeFunctions { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'activeFunctions()'\n"); $_[0]->{__meta_activeFunctions} = $_[1]; } else { return $_[0]->{__meta_activeFunctions}; } }
sub activeFunctionsVal { return $_[0]->{__meta_activeFunctions}; }
sub getActiveFunctions { return $_[0]->{__meta_activeFunctions}; }
sub setActiveFunctions { $_[0]->{__meta_activeFunctions} = $_[1]; }
sub activeFunctionsSet { $_[0]->{__meta_activeFunctions} = $_[1]; printf(STDERR "WARNING: Using deprecated activeFunctionsSet setter\n"); }
sub activeFunctionsIs { $_[0]->{__meta_activeFunctions} = $_[1]; }
sub activeFunctionsRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'activeFunctions()'\n"); $_[0]->{__meta_activeFunctions} = $_[1]; } else { return $_[0]->{__meta_activeFunctions}; } }
sub getActiveFunction { return $_[0]->{__meta_activeFunctions}->[$_[1]]; }
sub activeFunction { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'activeFunction()'\n"); $_[0]->{__meta_activeFunctions}->[$_[1]] = $_[2]; } else { return $_[0]->{__meta_activeFunctions}->[$_[1]]; } }
sub setActiveFunction { $_[0]->{__meta_activeFunctions}->[$_[1]] = $_[2]; }
sub numActiveFunction { return scalar(@{$_[0]->{__meta_activeFunctions}}); }
sub addActiveFunction { push(@{$_[0]->{__meta_activeFunctions}}, $_[1]); }
    # METALINE: Plot.axes
#   line 143 "graph.meta"
sub axes { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'axes()'\n"); $_[0]->{__meta_axes} = $_[1]; } else { return $_[0]->{__meta_axes}; } }
sub axesVal { return $_[0]->{__meta_axes}; }
sub getAxes { return $_[0]->{__meta_axes}; }
sub setAxes { $_[0]->{__meta_axes} = $_[1]; }
sub axesSet { $_[0]->{__meta_axes} = $_[1]; printf(STDERR "WARNING: Using deprecated axesSet setter\n"); }
sub axesIs { $_[0]->{__meta_axes} = $_[1]; }
sub axesRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'axes()'\n"); $_[0]->{__meta_axes} = $_[1]; } else { return $_[0]->{__meta_axes}; } }
sub getAxe { return $_[0]->{__meta_axes}->[$_[1]]; }
sub axe { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'axe()'\n"); $_[0]->{__meta_axes}->[$_[1]] = $_[2]; } else { return $_[0]->{__meta_axes}->[$_[1]]; } }
sub setAxe { $_[0]->{__meta_axes}->[$_[1]] = $_[2]; }
sub numAxe { return scalar(@{$_[0]->{__meta_axes}}); }
sub addAxe { push(@{$_[0]->{__meta_axes}}, $_[1]); }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.Plot.__C2__(Meta!StrV...V)
#line 154 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::new(Meta!Str class, Meta!Str@ title, ...@ axes)'; carp("ERROR: $__meta_sig:\n       Expecting at least 2 arguments but found " . scalar(@_) . ".") if ( @_ < 2 );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my $title = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'title' = '$title' should have ref '' but has ref '" . CORE::ref($title) . "'") unless ( ( !defined($title)) || ( CORE::ref($title) eq ''));
    my @axes = @_[2..$#_];
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.Plot.__C2__(Meta!StrV...V)SCOPE
#   line 155 "graph.meta"

    $self->setTitle($title);

    my @a;
    my $i = 0;
    foreach my $axis (@axes) {
      ++$i;
      if ( ref($axis) eq 'ARRAY' ) {
        my ($name, $type) = @$axis;
        $a = Meta::Doc::Lib::Axis->basicNew($name,$type);
        push(@a, $a);

      } elsif ( !ref($axis) ) {
        my $type = ($i==1) ? 'int' : 'real.2';
        $a = Meta::Doc::Lib::Axis->basicNew($axis,$type);       
        push(@a, $a);        

      } elsif ( $axis->isa('Meta::Doc::Lib::Axis')) {
        push(@a, $axis);

      } else {
        ## Error
        die("ERROR: Illegal axis '$axis'");
      }
    }
    $self->axesIs(\@a);
    $self->activeFunctionsIs(undef);

    ####
    ## By adding these here, we make it easier for methods like
    ## 'noAxisLabels' to remove them later, and avoids special-case
    ## code generation in the gnuplot generators.
    $self->setGnuplotVar('title', "\"$title\"");
    $self->setGnuplotVar('xlabel', sprintf("\"%s\"", $a[0]->title()));
    $self->setGnuplotVar('ylabel', sprintf("\"%s\"", $a[1]->title()));
    # Inserted by Meta
    return $self;

}

#instance METHOD 'addMultiPoint'
# METALINE: Meta.Doc.Lib.Plot.addMultiPoint(doubleV...V)
#line 191 "graph.meta"
sub addMultiPoint {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::addMultiPoint(Meta.Doc.Lib.Plot#* self, double@ x, ...@ ys)'; carp("ERROR: $__meta_sig:\n       Expecting at least 2 arguments but found " . scalar(@_) . ".") if ( @_ < 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $x = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'x' = '$x' should have ref '' but has ref '" . CORE::ref($x) . "'") unless ( ( !defined($x)) || ( CORE::ref($x) eq '')); carp("ERROR: $__meta_sig:\n       Arg 'x' = '$x' fails to match type double") unless $x =~ m/([+-]?)(?=\d|\.\d)\d*(\.\d*)?([Ee]([+-]?\d+))?$/;
    my @ys = @_[2..$#_];
    #

    # METALINE: Meta.Doc.Lib.Plot.addMultiPoint(doubleV...V)SCOPE
#   line 209 "graph.meta"

    my $functions = $self->activeFunctionsRef();
    $functions  ||= $self->functionsRef();
    if ( $#$functions != $#ys ) {
      die(sprintf("ERROR: addMultiPoint given %d y values for %d active functions\n", $#ys+1, $#$functions+1));
    } else {
      foreach my $i (0..$#ys) {
        $functions->[$i]->add($x, $ys[$i]);
      }
    }

}

#instance METHOD 'xaxis'
# METALINE: Meta.Doc.Lib.Plot.xaxis()
#line 220 "graph.meta"
sub xaxis {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::xaxis(Meta.Doc.Lib.Plot#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.xaxis()SCOPE
#   line 221 "graph.meta"
 return $self->axes()->[0]; 

}

#instance METHOD 'axisx'
# METALINE: Meta.Doc.Lib.Plot.axisx()
#line 221 "graph.meta"
sub axisx {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::axisx(Meta.Doc.Lib.Plot#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.axisx()SCOPE
#   line 222 "graph.meta"
 return $self->axes()->[2]; 

}

#instance METHOD 'yaxis'
# METALINE: Meta.Doc.Lib.Plot.yaxis()
#line 222 "graph.meta"
sub yaxis {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::yaxis(Meta.Doc.Lib.Plot#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.yaxis()SCOPE
#   line 223 "graph.meta"
 return $self->axes()->[1]; 

}

#instance METHOD 'axisy'
# METALINE: Meta.Doc.Lib.Plot.axisy()
#line 223 "graph.meta"
sub axisy {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::axisy(Meta.Doc.Lib.Plot#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.axisy()SCOPE
#   line 224 "graph.meta"
 return $self->axes()->[3]; 

}

#instance METHOD 'setXaxis'
# METALINE: Meta.Doc.Lib.Plot.setXaxis(Meta.Doc.Lib.AxisP)
#line 225 "graph.meta"
sub setXaxis {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::setXaxis(Meta.Doc.Lib.Plot#* self, Meta.Doc.Lib.Axis* axis)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $axis = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'axis' = '$axis' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $axis ) || ( ref($axis) && ( $axis->isa('Meta::Doc::Lib::Axis') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.setXaxis(Meta.Doc.Lib.AxisP)SCOPE
#   line 226 "graph.meta"
 $self->axes()->[0] = $axis; 

}

#instance METHOD 'setAxisX'
# METALINE: Meta.Doc.Lib.Plot.setAxisX(Meta.Doc.Lib.AxisP)
#line 226 "graph.meta"
sub setAxisX {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::setAxisX(Meta.Doc.Lib.Plot#* self, Meta.Doc.Lib.Axis* axis)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $axis = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'axis' = '$axis' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $axis ) || ( ref($axis) && ( $axis->isa('Meta::Doc::Lib::Axis') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.setAxisX(Meta.Doc.Lib.AxisP)SCOPE
#   line 227 "graph.meta"
 $self->axes()->[2] = $axis; 

}

#instance METHOD 'setYaxis'
# METALINE: Meta.Doc.Lib.Plot.setYaxis(Meta.Doc.Lib.AxisP)
#line 227 "graph.meta"
sub setYaxis {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::setYaxis(Meta.Doc.Lib.Plot#* self, Meta.Doc.Lib.Axis* axis)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $axis = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'axis' = '$axis' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $axis ) || ( ref($axis) && ( $axis->isa('Meta::Doc::Lib::Axis') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.setYaxis(Meta.Doc.Lib.AxisP)SCOPE
#   line 228 "graph.meta"
 $self->axes()->[1] = $axis; 

}

#instance METHOD 'setAxisY'
# METALINE: Meta.Doc.Lib.Plot.setAxisY(Meta.Doc.Lib.AxisP)
#line 228 "graph.meta"
sub setAxisY {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::setAxisY(Meta.Doc.Lib.Plot#* self, Meta.Doc.Lib.Axis* axis)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $axis = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'axis' = '$axis' is not type compatible with 'Meta::Doc::Lib::Axis'") unless ( ( ! $axis ) || ( ref($axis) && ( $axis->isa('Meta::Doc::Lib::Axis') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.setAxisY(Meta.Doc.Lib.AxisP)SCOPE
#   line 229 "graph.meta"
 $self->axes()->[3] = $axis; 

}

#instance METHOD 'writeGnuplot'
# METALINE: Meta.Doc.Lib.Plot.writeGnuplot(Meta!StrVMeta!StrV)
#line 230 "graph.meta"
sub writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::writeGnuplot(Meta.Doc.Lib.Plot#* self, Meta!Str@ filebase, Meta!Str@ type)'; carp("ERROR: $__meta_sig:\n       Expecting 3 arguments but found " . scalar(@_) . ".") if ( @_ != 3 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $filebase = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'filebase' = '$filebase' should have ref '' but has ref '" . CORE::ref($filebase) . "'") unless ( ( !defined($filebase)) || ( CORE::ref($filebase) eq ''));
    my $type = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.Plot.writeGnuplot(Meta!StrVMeta!StrV)SCOPE
#   line 241 "graph.meta"

    my $gpfile  = "$filebase.gp";
    my $gpdfile = "$filebase.gpd";

    my $gp  = IO::File->new(">$gpfile")  || die("ERROR: Failed to open '$gpfile' for appending - $!");
    my $gpd = IO::File->new(">$gpdfile") || die("ERROR: Failed to open '$gpdfile' for appending - $!");

    $self->_writeGnuplot($gp, $gpd, $gpdfile, $type);

}

#instance METHOD '_writeGnuplot'
# METALINE: Meta.Doc.Lib.Plot._writeGnuplot(Meta!OutputPMeta!OutputPMeta!StrVMeta!StrV)
#line 250 "graph.meta"
sub _writeGnuplot {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::_writeGnuplot(Meta.Doc.Lib.Plot#* self, Meta!Output* gp, Meta!Output* gpd, Meta!Str@ gpdfile, Meta!Str@ type)'; carp("ERROR: $__meta_sig:\n       Expecting 5 arguments but found " . scalar(@_) . ".") if ( @_ != 5 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $gp = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'gp' = '$gp' is not type compatible with 'IO::File'") unless ( ( ! $gp ) || ( ref($gp) && ( $gp->isa('IO::File') ) ) );
    my $gpd = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'gpd' = '$gpd' is not type compatible with 'IO::File'") unless ( ( ! $gpd ) || ( ref($gpd) && ( $gpd->isa('IO::File') ) ) );
    my $gpdfile = $_[3]; carp("ERROR: $__meta_sig:\n       Arg 'gpdfile' = '$gpdfile' should have ref '' but has ref '" . CORE::ref($gpdfile) . "'") unless ( ( !defined($gpdfile)) || ( CORE::ref($gpdfile) eq ''));
    my $type = $_[4]; carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.Plot._writeGnuplot(Meta!OutputPMeta!OutputPMeta!StrVMeta!StrV)SCOPE
#   line 253 "graph.meta"

    my $functions = $self->functions();
    my $first = $functions->[0];

    my $xaxis = $self->xaxis();
    my $yaxis = $self->yaxis();

    ####
    ## Print out the 'set' values.
    my $set = $self->varsSet();
    foreach my $s (sort(keys(%$set))) {
      printf($gp "set $s %s\n", $set->{$s});
    }
    
    my $index = 0;
    print($gp "plot \\");
    my @functions;
    my $functiontype = 'linespoints';
    foreach my $function (@$functions) {
      push(@functions, sprintf("  '$gpdfile' index $index title '%s' with $functiontype", $function->title()));
      $function->writeGnuplot($gpd);
      ++$index;
    }
    print($gp "\n", join(", \\\n", @functions), "\n");
    print($gp "pause -1 \"Press <CR> to continue...\"\n");

    $gp->close();
    $gpd->close();

}

#instance METHOD 'write'
# METALINE: Meta.Doc.Lib.Plot.write(Meta!StrVMeta!StrVMeta!StrV)
#line 283 "graph.meta"
sub write {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::write(Meta.Doc.Lib.Plot#* self, Meta!Str@ filebase, Meta!Str@ format = \'gnuplot\', Meta!Str@ type = \'linespoints\')'; carp("ERROR: $__meta_sig:\n       Expecting between 2 and 4 arguments but found " . scalar(@_) . ".") if ( ( @_ < 2 ) || ( @_ > 4 ) );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $filebase = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'filebase' = '$filebase' should have ref '' but has ref '" . CORE::ref($filebase) . "'") unless ( ( !defined($filebase)) || ( CORE::ref($filebase) eq ''));
    my $format = $_[2]; $format = 'gnuplot' unless defined($format); carp("ERROR: $__meta_sig:\n       Arg 'format' = '$format' should have ref '' but has ref '" . CORE::ref($format) . "'") unless ( ( !defined($format)) || ( CORE::ref($format) eq ''));
    my $type = $_[3]; $type = 'linespoints' unless defined($type); carp("ERROR: $__meta_sig:\n       Arg 'type' = '$type' should have ref '' but has ref '" . CORE::ref($type) . "'") unless ( ( !defined($type)) || ( CORE::ref($type) eq ''));
    #

    # METALINE: Meta.Doc.Lib.Plot.write(Meta!StrVMeta!StrVMeta!StrV)SCOPE
#   line 289 "graph.meta"

    if ( $format eq 'gnuplot' ) {
      $self->writeGnuplot($filebase, $type);
    } else {
      die("Exception: Unknown format '$format'");
    }

}

#instance METHOD 'newFunction'
# METALINE: Meta.Doc.Lib.Plot.newFunction(Meta!StrVMeta!StrVbooleanVbooleanV)
#line 296 "graph.meta"
sub newFunction {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::newFunction(Meta.Doc.Lib.Plot#* self, Meta!Str@ title, Meta!Str@ function, boolean@ axisx = 0, boolean@ axisy = 0)'; carp("ERROR: $__meta_sig:\n       Expecting between 3 and 5 arguments but found " . scalar(@_) . ".") if ( ( @_ < 3 ) || ( @_ > 5 ) );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $title = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'title' = '$title' should have ref '' but has ref '" . CORE::ref($title) . "'") unless ( ( !defined($title)) || ( CORE::ref($title) eq ''));
    my $function = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'function' = '$function' should have ref '' but has ref '" . CORE::ref($function) . "'") unless ( ( !defined($function)) || ( CORE::ref($function) eq ''));
    my $axisx = $_[3]; $axisx = 0 unless defined($axisx);
    my $axisy = $_[4]; $axisy = 0 unless defined($axisy);
    #

    # METALINE: Meta.Doc.Lib.Plot.newFunction(Meta!StrVMeta!StrVbooleanVbooleanV)SCOPE
#   line 302 "graph.meta"

    my $xaxis = $self->xaxis();
    my $yaxis = $self->yaxis();
    my $result;
    if ( $xaxis && $yaxis ) {
      $result = Meta::Doc::Lib::Function->new($title, $function, $xaxis, $yaxis);
      $self->addFunction($result);
    } else {
      print(STDERR "ERROR: Cannot create new functions for Plots without axes\n");
      $result = undef;
    }
    return($result);

}

#instance METHOD 'newMapping'
# METALINE: Meta.Doc.Lib.Plot.newMapping(Meta!StrVbooleanVbooleanV)
#line 315 "graph.meta"
sub newMapping {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::newMapping(Meta.Doc.Lib.Plot#* self, Meta!Str@ title, boolean@ axisx = 0, boolean@ axisy = 0)'; carp("ERROR: $__meta_sig:\n       Expecting between 2 and 4 arguments but found " . scalar(@_) . ".") if ( ( @_ < 2 ) || ( @_ > 4 ) );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $title = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'title' = '$title' should have ref '' but has ref '" . CORE::ref($title) . "'") unless ( ( !defined($title)) || ( CORE::ref($title) eq ''));
    my $axisx = $_[2]; $axisx = 0 unless defined($axisx);
    my $axisy = $_[3]; $axisy = 0 unless defined($axisy);
    #

    # METALINE: Meta.Doc.Lib.Plot.newMapping(Meta!StrVbooleanVbooleanV)SCOPE
#   line 319 "graph.meta"

    my $xaxis = ($axisx ? $self->axisx() : $self->xaxis() );
    my $yaxis = ($axisy ? $self->axisy() : $self->yaxis() );
    my $result;
    if ( $xaxis && $yaxis ) {
      $result = Meta::Doc::Lib::PointMap->new('');
      $result->init($title, $xaxis, $yaxis);
      $self->addFunction($result);
    } else {
      print(STDERR "ERROR: Cannot create new functions for Plots without axes\n");
      $result = undef;
    }
    return($result);

}

#instance METHOD 'createMappings'
# METALINE: Meta.Doc.Lib.Plot.createMappings(...V)
#line 333 "graph.meta"
sub createMappings {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::createMappings(Meta.Doc.Lib.Plot#* self, ...@ titles)'; carp("ERROR: $__meta_sig:\n       Expecting at least 1 arguments but found " . scalar(@_) . ".") if ( @_ < 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my @titles = @_[1..$#_];
    #

    # METALINE: Meta.Doc.Lib.Plot.createMappings(...V)SCOPE
#   line 337 "graph.meta"

    my @functions;
    foreach my $title (@titles) {
      my $function = $self->newMapping($title);
      push(@functions, $function);
    }
    return (wantarray) ? @functions : \@functions;

}

#instance METHOD 'registerFunction'
# METALINE: Meta.Doc.Lib.Plot.registerFunction(Meta.Doc.Lib.FunctionP)
#line 345 "graph.meta"
sub registerFunction {
    my $__meta_sig = 'Meta.Doc.Lib::Plot::registerFunction(Meta.Doc.Lib.Plot#* self, Meta.Doc.Lib.Function* function)'; carp("ERROR: $__meta_sig:\n       Expecting 2 arguments but found " . scalar(@_) . ".") if ( @_ != 2 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Plot'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Plot') ) ) );
    my $function = $_[1]; carp("ERROR: $__meta_sig:\n       Arg 'function' = '$function' is not type compatible with 'Meta::Doc::Lib::Function'") unless ( ( ! $function ) || ( ref($function) && ( $function->isa('Meta::Doc::Lib::Function') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Plot.registerFunction(Meta.Doc.Lib.FunctionP)SCOPE
#   line 350 "graph.meta"

    my $first = $self->functions()->[0];
    my $xaxis = $self->xaxis() || ( $first ? $first->xaxis() : undef );
    my $yaxis = $self->yaxis() || ( $first ? $first->yaxis() : undef );
    my $result;
    if ( 
      ( $xaxis == $function->xaxis() ) && 
      ( $yaxis == $function->yaxis() ) 
    ) {
      $result = 1;
      $self->addFunction($result);
    } else {
      printf(STDERR "ERROR: Current function '%s' does not have axes matching '%s'\n", $function->asSpec(), $first->asSpec());
      $result = 0;
    }
    return $result;

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_title'       => '',
         '__meta_functions'   => [],
         '__meta_activeFunctions' => [],
         '__meta_axes'        => [],
    });
}


#line 367 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for Plot (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">Plot.out");
        close(STDERR); open(STDERR, ">Plot.err");
    }

    # Start of user-provided code
#line 367 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
    
    
      ####
      ## This is the old-style, slower way of creating Plots
      my $xaxis = Meta::Doc::Lib::Axis->basicNew('age', 'int');
      my $yaxis = Meta::Doc::Lib::Axis->basicNew('height');
      my $plot = Meta::Doc::Lib::Plot->new('Testing Plots', $xaxis, $yaxis);
    
      my $function = $plot->newMapping('line1');
      my $point = Meta::Doc::Lib::Point->new( 0, .3);
      $function->addPoint($point);
      $function->add(1, .5);
      $function->addData([2 => .7, 3 => .9]);
      $function->addSpec("
      4  1.1
      5  1.5
      6  1.8
    ");
    
      my $function2 = $plot->newMapping('line2');
      $function2->addSpec("
       2 2
       3 2.1
       4 2.2
       5 2.3
      ");
    
      $plot->writeGnuplot('Data/gnuplot', 'linespoints');
    
      ####
      ## Here is a newer, more concise way to create and populate Plots.
      ## 
      ## Note that the 2nd and 3rd args to the Plot constructor can also
      ## be two-tuples specifying label and type (by default, x-axis is
      ## 'int', and y-axis is 'real.2'.
      my $plot2 = Meta::Doc::Lib::Plot->new('Another example title', 'X-axis label', 'Y-axis label');
      my ($p1,$p2,$p3) = $plot2->createMappings('Line1', 'Line2', 'Line3');
      foreach my $i (1,2,3,4,5) {
        $plot2->addMultiPoint($i, $i+1, 2*$i+2, 3*$i+3);
      }
      $plot2->write('Data/gnuplot2');
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'Plot.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Plot.out"); } unlink('Plot.out') unless ( $verbose > 2);
        if ( ( -s 'Plot.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Plot.err"); } unlink('Plot.err') unless ( $verbose > 2);
    }

}

#line 367 "/home/Wade/Research/Topics/Meta/src/config/metaapp.metaoopl"
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS Plot\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
