package Meta::Doc::Lib::Point;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Object);
use Meta::Lib::Object;

###
# The associations of this class (importation)
use IO::File;
use Carp;

###
# The executable code of this class (methods, accessors, initializers, finalizers)
    # METALINE: Point.tuple
#   line 1026 "graph.meta"
sub tuple { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'tuple()'\n"); $_[0]->{__meta_tuple} = $_[1]; } else { return $_[0]->{__meta_tuple}; } }
sub tupleVal { return $_[0]->{__meta_tuple}; }
sub getTuple { return $_[0]->{__meta_tuple}; }
sub setTuple { $_[0]->{__meta_tuple} = $_[1]; }
sub tupleSet { $_[0]->{__meta_tuple} = $_[1]; printf(STDERR "WARNING: Using deprecated tupleSet setter\n"); }
sub tupleIs { $_[0]->{__meta_tuple} = $_[1]; }
sub tupleRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'tuple()'\n"); $_[0]->{__meta_tuple} = $_[1]; } else { return $_[0]->{__meta_tuple}; } }
sub getTupleElement { return $_[0]->{__meta_tuple}->[$_[1]]; }
sub tupleElement { if ( @_ > 2 ) { print(STDERR "NOTE: Using deprecated form of 'tupleElement()'\n"); $_[0]->{__meta_tuple}->[$_[1]] = $_[2]; } else { return $_[0]->{__meta_tuple}->[$_[1]]; } }
sub setTupleElement { $_[0]->{__meta_tuple}->[$_[1]] = $_[2]; }
sub numTupleElement { return scalar(@{$_[0]->{__meta_tuple}}); }
sub addTupleElement { push(@{$_[0]->{__meta_tuple}}, $_[1]); }

#class INITIALIZER 'new'
# METALINE: Meta.Doc.Lib.Point.__C10__(...V)
#line 1031 "graph.meta"
sub new {
    my $__meta_sig = 'Meta.Doc.Lib::Point::new(Meta!Str class, ...@ dims)'; carp("ERROR: $__meta_sig:\n       Expecting at least 1 arguments but found " . scalar(@_) . ".") if ( @_ < 1 );
    my $class = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'class' = '$class' should have ref '' but has ref '" . CORE::ref($class) . "'") unless ( ( !defined($class)) || ( CORE::ref($class) eq ''));
    my @dims = @_[1..$#_];
    #
    my $self = $class->SUPER::new();
    # METALINE: Meta.Doc.Lib.Point.__C10__(...V)SCOPE
#   line 1032 "graph.meta"

    $self->setTuple(\@dims);
    # Inserted by Meta
    return $self;

}

#instance METHOD 'dim'
# METALINE: Meta.Doc.Lib.Point.dim()
#line 1037 "graph.meta"
sub dim {
    my $__meta_sig = 'Meta.Doc.Lib::Point::dim(Meta.Doc.Lib.Point#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Point'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Point') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Point.dim()SCOPE
#   line 1041 "graph.meta"

      my $tuple = $self->tuple();
      return $#$tuple+1;

}

#instance METHOD 'x'
# METALINE: Meta.Doc.Lib.Point.x()
#line 1045 "graph.meta"
sub x {
    my $__meta_sig = 'Meta.Doc.Lib::Point::x(Meta.Doc.Lib.Point#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Point'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Point') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Point.x()SCOPE
#   line 1046 "graph.meta"

      return $self->tuple()->[0];

}

#instance METHOD 'y'
# METALINE: Meta.Doc.Lib.Point.y()
#line 1049 "graph.meta"
sub y {
    my $__meta_sig = 'Meta.Doc.Lib::Point::y(Meta.Doc.Lib.Point#* self)'; carp("ERROR: $__meta_sig:\n       Expecting 1 argument but found " . scalar(@_) . ".") if ( @_ != 1 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Point'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Point') ) ) );
    #

    # METALINE: Meta.Doc.Lib.Point.y()SCOPE
#   line 1050 "graph.meta"

      return $self->tuple()->[1];

}

#instance METHOD 'write'
# METALINE: Meta.Doc.Lib.Point.write(Meta!AnyPMeta!StrVMeta!StrV)
#line 1057 "graph.meta"
sub write {
    my $__meta_sig = 'Meta.Doc.Lib::Point::write(Meta.Doc.Lib.Point#* self, Meta!Any* fp, Meta!Str@ xformat, Meta!Str@ yformat)'; carp("ERROR: $__meta_sig:\n       Expecting 4 arguments but found " . scalar(@_) . ".") if ( @_ != 4 );
    my $self = $_[0]; carp("ERROR: $__meta_sig:\n       Arg 'self' = '$self' is not type compatible with 'Meta::Doc::Lib::Point'") unless ( ( ! $self ) || ( ref($self) && ( $self->isa('Meta::Doc::Lib::Point') ) ) );
    my $fp = $_[1];
    my $xformat = $_[2]; carp("ERROR: $__meta_sig:\n       Arg 'xformat' = '$xformat' should have ref '' but has ref '" . CORE::ref($xformat) . "'") unless ( ( !defined($xformat)) || ( CORE::ref($xformat) eq ''));
    my $yformat = $_[3]; carp("ERROR: $__meta_sig:\n       Arg 'yformat' = '$yformat' should have ref '' but has ref '" . CORE::ref($yformat) . "'") unless ( ( !defined($yformat)) || ( CORE::ref($yformat) eq ''));
    #

    # METALINE: Meta.Doc.Lib.Point.write(Meta!AnyPMeta!StrVMeta!StrV)SCOPE
#   line 1060 "graph.meta"

      printf($fp "$xformat $yformat\n", $self->x(), $self->y());

}

sub __meta_initInstance {
    $_[0]->SUPER::__meta_initInstance();
    $_[0]->__meta_extend({
         '__meta_tuple'       => [],
    });
}

sub __Meta_main {
    my ($exec,$args,$validate,$verbose) = @_;
    if ( $validate ) {
        print(STDERR "NOTE: Executing unit test for Point (stdout and stderr redirected)\n");
        close(STDOUT); open(STDOUT, ">Point.out");
        close(STDERR); open(STDERR, ">Point.err");
    }

    # Start of user-provided code
    print("No unit test has been provided for CLASS Point\n");
    # End of user-provided code

    if ( $validate ) {
        my $tty = `tty`; chomp($tty);
        close(STDOUT); open(STDOUT, ">$tty");
        close(STDERR); open(STDERR, ">$tty");
        my $errors = &__Meta_validate($validate);
        if ( ( -s 'Point.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Point.out"); } unlink('Point.out') unless ( $verbose > 2);
        if ( ( -s 'Point.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Point.err"); } unlink('Point.err') unless ( $verbose > 2);
    }

}
sub __Meta_validate {
    my ($verbose) = @_;
    my $errors = 0;
    print("NOTE:    No unit testing provided for CLASS Point\n");
    return $errors;
}


###
# All well-formed perl modules return true.
1;

  
