package Meta::Doc::Lib::TableGroup;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Lib::Object);
use Meta::Lib::Object;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Oopl::BaseLanguage::PerlRef;
use Meta::Doc::Lib::Table;

###
# The executable code of this class (methods, accessors, initializers, finalizers)

###############################
# instance FIELD 'label3'
# META: Meta.Doc.Lib.TableGroup.label3:@Meta!Str
sub label3 { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'label3()'\n"); $_[0]->{__meta_label3} = $_[1]; } else { return $_[0]->{__meta_label3}; } }
sub label3Val { return $_[0]->{__meta_label3}; }
sub label3Is { $_[0]->{__meta_label3} = $_[1]; }
sub label3Ref { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'label3()'\n"); $_[0]->{__meta_label3} = $_[1]; } else { return $_[0]->{__meta_label3}; } }

###############################
# instance FIELD 'tables'
# META: Meta.Doc.Lib.TableGroup.tables:*Meta!Map
sub tables { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'tables()'\n"); $_[0]->{__meta_tables} = $_[1]; } else { return $_[0]->{__meta_tables}; } }
sub tablesVal { return $_[0]->{__meta_tables}; }
sub tablesIs { $_[0]->{__meta_tables} = $_[1]; }
sub tablesRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'tables()'\n"); $_[0]->{__meta_tables} = $_[1]; } else { return $_[0]->{__meta_tables}; } }

###############################
# instance FIELD 'order'
# META: Meta.Doc.Lib.TableGroup.order:*Meta!Vec<@Meta!Str>
sub order { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'order()'\n"); $_[0]->{__meta_order} = $_[1]; } else { return $_[0]->{__meta_order}; } }
sub orderVal { return $_[0]->{__meta_order}; }
sub orderIs { $_[0]->{__meta_order} = $_[1]; }
sub orderRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'order()'\n"); $_[0]->{__meta_order} = $_[1]; } else { return $_[0]->{__meta_order}; } }


###############################
# meta METHOD 'new'
# META: Meta.Doc.Lib.TableGroup.new(@Meta!Str,@Meta!Str):void
sub new {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.new\(class\:\@Meta\!Str\,label\:\@Meta\!Str\)\:void";
  my $class = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$class failed typechecking.  Possible reasons are:\n   - \$class must be defined and have ref '' (is '%s')",(defined($class)?ref($class):'undef'))) if ( (((!defined($class)) || (ref($class) ne ''))) );
  my $label = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$label failed typechecking.  Possible reasons are:\n   - \$label must be defined and have ref '' (is '%s')",(defined($label)?ref($label):'undef'))) if ( (((!defined($label)) || (ref($label) ne ''))) );

  my $self = $class->SUPER::new();
  #----------------------------
  # META: start of user-code
  $self->label3Is($label);
  # META: end of user-code
  #----------------------------
  return $self;
}

###############################
# instance METHOD 'rowSlice'
# META: Meta.Doc.Lib.TableGroup.rowSlice(#*Meta.Doc.Lib.TableGroup,@...%):*Meta.Doc.Lib.Table
sub rowSlice {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.rowSlice\(self\:\#\*Meta\.Doc\.Lib\.TableGroup\,options\:\@\.\.\.\%\)\:\*Meta\.Doc\.Lib\.Table";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::TableGroup' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::TableGroup')))) );
  my %options = @_[1..$#_]; 
  #----------------------------
  # META: start of user-code
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'columnSlice'
# META: Meta.Doc.Lib.TableGroup.columnSlice(#*Meta.Doc.Lib.TableGroup,@Meta!Str,@...%):*Meta.Doc.Lib.Table
sub columnSlice {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.columnSlice\(self\:\#\*Meta\.Doc\.Lib\.TableGroup\,colid\:\@Meta\!Str\,options\:\@\.\.\.\%\)\:\*Meta\.Doc\.Lib\.Table";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::TableGroup' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::TableGroup')))) );
  my $colid = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$colid failed typechecking.  Possible reasons are:\n   - \$colid must be defined and have ref '' (is '%s')",(defined($colid)?ref($colid):'undef'))) if ( (((!defined($colid)) || (ref($colid) ne ''))) );
  my %options = @_[2..$#_]; 
  #----------------------------
  # META: start of user-code
  ####
  ## First, we obtain an array of the tables in proper order
  my @tables;
  my @order = @{$self->order()};
  foreach my $dim3 (@order) {
    push(@tables, $self->table($dim3));
  }
  my $first = $tables[0];

  ####
  ## Verify the legality of $colid and the optional rowid
  my $col   = $first->colForId($colid);
  die("ERROR: Illegal column id '$colid'") unless defined($col);
  my $rowid = $options{rowid};
  if ( $rowid ) {
    my $rowcol = $first->colForId($rowid);
    die("ERROR: Illegal column id '$rowid' (rowid)") unless defined($rowcol);
  }

  ####
  ## Establish the config info (name and caption)
  my %config;
  $config{name}    = $options{name} || $self->label3();
  $config{caption} = $options{caption} || 'Fix this caption';

  ####
  ## Establish the set of column ids - this is the set of
  ## dim3 values, in proper order
  my $saferowid = $rowid || 'row';
  my @init = ( $saferowid );
  push(@init, @{$self->order()});

  ####
  ## Create the table
  my $result = Meta::Doc::Lib::Table->new( \%config, @init );

  ####
  ## Populate the table
  my $r = 0;
  while ( 1 ) {
    my %row;
    foreach my $k (0..$#order) {
      my $order = $order[$k];
      my $table = $tables[$k];
      my $row   = $table->rows()->[$r];
      if ( defined($row) ) {
        my $sliceval = $row->{$colid};
        my $rowval   = ( $rowid ) ? $row->{$rowid} : $r;
        $row{$order} = $sliceval;
        ## This next key is being assigned many times, and
        ## is presumably the same every time thru - should
        ## we add some code to verify?
        $row{$saferowid} = $rowval;
      }
    }
    if ( %row ) {
      $result->add(%row);
      ++$r;
    } else {
      last;
    }
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'addFromFile'
# META: Meta.Doc.Lib.TableGroup.addFromFile(#*Meta.Doc.Lib.TableGroup,@Meta!Str,*Meta!Any,@...%):void
sub addFromFile {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.addFromFile\(self\:\#\*Meta\.Doc\.Lib\.TableGroup\,file\:\@Meta\!Str\,dim3re\:\*Meta\!Any\,options\:\@\.\.\.\%\)\:void";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::TableGroup' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::TableGroup')))) );
  my $file = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$file failed typechecking.  Possible reasons are:\n   - \$file must be defined and have ref '' (is '%s')",(defined($file)?ref($file):'undef'))) if ( (((!defined($file)) || (ref($file) ne ''))) );
  my $dim3re = $_[2]; 
  my %options = @_[3..$#_]; 
  #----------------------------
  # META: start of user-code
  my $fp = IO::File->new("<$file") || die("ERROR: Failed to open '$file' for reading");

  while (1) {
    my $table;
    eval {
      $table = Meta::Doc::Lib::Table::newFromFp($fp);
    };
    if ( $@ ) {
      last;
    } else {
      my $footer = $table->footer();
      if ( $footer =~ m/$dim3re/ ) {
        my $dim3 = $1;
        $self->registerTable($dim3, $table);
        $table->print();
      } else {
        print(STDERR "ERROR: Failed to find '$dim3re' in '$footer' - table ignored\n");
      }
    }
  }
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'registerTable'
# META: Meta.Doc.Lib.TableGroup.registerTable(#*Meta.Doc.Lib.TableGroup,@Meta!Str,*Meta.Doc.Lib.Table):@bool
sub registerTable {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.registerTable\(self\:\#\*Meta\.Doc\.Lib\.TableGroup\,dim3\:\@Meta\!Str\,table\:\*Meta\.Doc\.Lib\.Table\)\:\@bool";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::TableGroup' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::TableGroup')))) );
  my $dim3 = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$dim3 failed typechecking.  Possible reasons are:\n   - \$dim3 must be defined and have ref '' (is '%s')",(defined($dim3)?ref($dim3):'undef'))) if ( (((!defined($dim3)) || (ref($dim3) ne ''))) );
  my $table = $_[2]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$table failed typechecking.  Possible reasons are:\n   - \$table has ref '%s' when ref 'Meta::Doc::Lib::Table' expected",(defined($table)?ref($table):'undef'))) if ( (((defined($table)) && (!$table->isa('Meta::Doc::Lib::Table')))) );
  #----------------------------
  # META: start of user-code
  my $order = $self->order();
  my $first = $order->[0];
  my $ok;
  if ( defined($first) ) {
    my $firstTable = $self->table($first);
    ## Make sure $table columns match $firstTable columns!
    ## FIX THIS WMH!!! Add code here to do validation!
    $ok = 1;
  } else {
    ## First table - nothing to validate against
    $ok = 1;
  }
  if ( $ok ) {
    $self->tables()->{$dim3} = $table;
    push(@{$self->orderRef()}, $dim3);
  }
  return $ok;
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_main'
# META: Meta.Doc.Lib.TableGroup.__meta_main(@Meta!Str,*Meta!Vec<@Meta!Str>,@boolean,@int):void
sub __meta_main {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.__meta_main\(exec\:\@Meta\!Str\,args\:\*Meta\!Vec\<\@Meta\!Str\>\,validate\:\@boolean\,verbose\:\@int\)\:void";
  my $exec = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$exec failed typechecking.  Possible reasons are:\n   - \$exec must be defined and have ref '' (is '%s')",(defined($exec)?ref($exec):'undef'))) if ( (((!defined($exec)) || (ref($exec) ne ''))) );
  my $args = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$args failed typechecking.  Possible reasons are:\n   - \$args has ref '%s' when ref 'ARRAY' expected",(defined($args)?ref($args):'undef'))) if ( (((defined($args)) && (ref($args) ne 'ARRAY'))) );
  my $validate = $_[2]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$validate failed typechecking.  Possible reasons are:\n   - \$validate has ref '%s' when ref '' expected",(defined($validate)?ref($validate):'undef'))) if ( (((defined($validate)) && (ref($validate) ne ''))) );
  my $verbose = $_[3]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$verbose failed typechecking.  Possible reasons are:\n   - \$verbose has ref '%s' when ref '' expected",(defined($verbose)?ref($verbose):'undef'))) if ( (((defined($verbose)) && (ref($verbose) ne ''))) );

  {
    # Main method unit-testing prolog
    if ( $validate ) {
      print(STDERR "NOTE: Executing unit test for 'TableGroup' (stdout and stderr redirected)\n");
      close(STDOUT); open(STDOUT, ">TableGroup.out");
      close(STDERR); open(STDERR, ">TableGroup.err");
    } 
  }
  #----------------------------
  # META: start of user-code
  my $file = $args->[0];
  if ( $file ) {
    my $tgroup = Meta::Doc::Lib::TableGroup->new('players');
    $tgroup->addFromFile($file, qr/^\s*(\d+)\s+Players/);
    my $t66 = $tgroup->columnSlice('66', rowid => '#' );
    $t66->print();
  } else {
    die("ERROR: Must provide file of tables");
  }
  # META: end of user-code
  #----------------------------
  {
    # Main method unit-testing epilog
    if ( $validate ) {
      my $tty = `tty`; chomp($tty);
      close(STDOUT); open(STDOUT, ">$tty");
      close(STDERR); open(STDERR, ">$tty");
      my $errors = &__meta_validate($validate);
      if ( ( -s 'TableGroup.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat TableGroup.out"); } unlink('TableGroup.out') unless ( $verbose > 2);
      if ( ( -s 'TableGroup.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat TableGroup.err"); } unlink('TableGroup.err') unless ( $verbose > 2);
    } 
  }
}

###############################
# static METHOD '__meta_validate'
# META: Meta.Doc.Lib.TableGroup.__meta_validate(@int):@int
sub __meta_validate {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.__meta_validate\(verbose\:\@int\)\:\@int";
  my $verbose = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$verbose failed typechecking.  Possible reasons are:\n   - \$verbose has ref '%s' when ref '' expected",(defined($verbose)?ref($verbose):'undef'))) if ( (((defined($verbose)) && (ref($verbose) ne ''))) );
  #----------------------------
  # META: start of user-code
  my $errors = 0;
  print("NOTE:    No unit testing provided for CLASS TableGroup\n");
  return $errors;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD '__meta_initInstance'
# META: Meta.Doc.Lib.TableGroup.__meta_initInstance(#*Meta.Doc.Lib.TableGroup,@int):@int
sub __meta_initInstance {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.__meta_initInstance\(self\:\#\*Meta\.Doc\.Lib\.TableGroup\,verbose\:\@int\)\:\@int";
  my $self = $_[0]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$self failed typechecking.  Possible reasons are:\n   - \$self must be defined and have ref 'Meta::Doc::Lib::TableGroup' (is '%s')",(defined($self)?ref($self):'undef'))) if ( (((!defined($self)) || (!$self->isa('Meta::Doc::Lib::TableGroup')))) );
  my $verbose = $_[1]; CORE::warn(sprintf("Warning: In $__meta_sig:\n  Arg \$verbose failed typechecking.  Possible reasons are:\n   - \$verbose has ref '%s' when ref '' expected",(defined($verbose)?ref($verbose):'undef'))) if ( (((defined($verbose)) && (ref($verbose) ne ''))) );
  #----------------------------
  # META: start of user-code
  $_[0]->SUPER::__meta_initInstance();
  $_[0]->__meta_extend({
         '__meta_label3'      => 0,
         '__meta_tables'      => {},
         '__meta_order'       => [],
  });
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_initStatic'
# META: Meta.Doc.Lib.TableGroup.__meta_initStatic():void
sub __meta_initStatic {
  my $__meta_sig = "Meta\.Doc\.Lib\.TableGroup\.__meta_initStatic\(\)\:void";
  #----------------------------
  # META: start of user-code
  # META: end of user-code
  #----------------------------
}
&__meta_initStatic();


sub __Meta_main { &__meta_main(@_); }


###
# All well-formed perl modules return true.
1;

  
