package Meta::Oopl::BaseLanguage::Perl;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Oopl::BaseLanguage::Root);
use Meta::Oopl::BaseLanguage::Root;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Oopl::BaseLanguage::PerlRef;
use File::Spec;
use Meta::Oopl::Lib::PerlType;

###
# The executable code of this class (methods, accessors, initializers, finalizers)

###############################
# static FIELD 'Data'
# META: Meta.Oopl.BaseLanguage.Perl.Data:@Meta!Str
use vars qw($__meta_Data);
sub Data { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'Data()'\n"); $__meta_Data = $_[0]; } else { return $__meta_Data; } }
sub DataVal { return $__meta_Data; }
sub DataIs { $__meta_Data = $_[0]; }
sub DataRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'Data()'\n"); $__meta_Data = $_[0]; } else { return $__meta_Data; } }

###############################
# static FIELD 'Inst'
# META: Meta.Oopl.BaseLanguage.Perl.Inst:*Meta.Oopl.BaseLanguage.Perl
use vars qw($__meta_Inst);
sub Inst { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'Inst()'\n"); $__meta_Inst = $_[0]; } else { return $__meta_Inst; } }
sub InstVal { return $__meta_Inst; }
sub InstIs { $__meta_Inst = $_[0]; }
sub InstRef { if ( @_ > 1 ) { print(STDERR "NOTE: Using deprecated form of 'Inst()'\n"); $__meta_Inst = $_[0]; } else { return $__meta_Inst; } }


###############################
# meta METHOD 'new'
# META: Meta.Oopl.BaseLanguage.Perl.new(@Meta!Str,&#Meta!Str):void
sub new {
  my $class = $_[0]; 
  my $data = $_[1]; 

  my $self = $class->SUPER::new($data);
  #----------------------------
  # META: start of user-code
  # META: end of user-code
  #----------------------------
  return $self;
}

###############################
# static METHOD 'Instance'
# META: Meta.Oopl.BaseLanguage.Perl.Instance():*Meta.Oopl.BaseLanguage.Perl
sub Instance {
  #----------------------------
  # META: start of user-code
  my $result = &Inst();
  if ( ! $result ) {
    $result = Meta::Oopl::BaseLanguage::Perl->new(&Data());
    InstIs($result);
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'idToVar'
# META: Meta.Oopl.BaseLanguage.Perl.idToVar(#*Meta.Oopl.BaseLanguage.Perl,@Meta!Str,*Meta.Oopl.Lib.Type):@Meta!Str
sub idToVar {
  my $self = $_[0]; 
  my $id = $_[1]; 
  my $type = $_[2]; if (!defined($_[2])) { $type = undef; } 
  #----------------------------
  # META: start of user-code
  my $prefix;
  if ( $type ) {
    my $ntype = $type->asNativeType($self);
    $prefix = $ntype->native()->{prefix};
    ##printf("Obtained native type %s for type %s, with prefix '%s'\n", $type->desc(), $ntype->desc(), $prefix);
  } else {
    $prefix = "\$";
  }
  return $prefix . $id;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'idToInit'
# META: Meta.Oopl.BaseLanguage.Perl.idToInit(#*Meta.Oopl.BaseLanguage.Perl,@Meta!Str,*Meta.Oopl.CLASS):@Meta!Str
sub idToInit {
  my $self = $_[0]; 
  my $id = $_[1]; 
  my $clazz = $_[2]; 
  #----------------------------
  # META: start of user-code
  my $result;
  if ( &Meta::Schema::METASCHEMA::IsAssignedValue($id) ) {
    $result = 'new';
  } else {
    $result = $id;
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'commentLinePrefix'
# META: Meta.Oopl.BaseLanguage.Perl.commentLinePrefix(#*Meta.Oopl.BaseLanguage.Perl):@Meta!Str
sub commentLinePrefix {
  my $self = $_[0]; 
  #----------------------------
  # META: start of user-code
  return '#';
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'metaToNative'
# META: Meta.Oopl.BaseLanguage.Perl.metaToNative(#*Meta.Oopl.BaseLanguage.Perl,@Meta!Str):@Meta!Str
sub metaToNative {
  my $self = $_[0]; 
  my $type = $_[1]; 
  #----------------------------
  # META: start of user-code
  $type =~ s/\./::/g;
  return $type;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'prepareEnvironment'
# META: Meta.Oopl.BaseLanguage.Perl.prepareEnvironment(#*Meta.Oopl.BaseLanguage.Perl):void
sub prepareEnvironment {
  my $self = $_[0]; 
  #----------------------------
  # META: start of user-code
  ## Ensure that PERLLIB contains $META_ROOT/root/lib/Perl
  $self->adjustEnvironment(
    'PERLLIB',
    "$ENV{META_ROOT}/root/lib/Perl"
  );
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'compile'
# META: Meta.Oopl.BaseLanguage.Perl.compile(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Schema.METASCHEMA,&#Meta!Str):@Meta!Str
sub compile {
  my $self = $_[0]; 
  my $schema = $_[1]; 
  my $srcdir = $_[2]; 
  #----------------------------
  # META: start of user-code
  return 'metaperl';
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'asNativeType'
# META: Meta.Oopl.BaseLanguage.Perl.asNativeType(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Oopl.Lib.Type):*Meta.Oopl.Lib.NativeType
sub asNativeType {
  my $self = $_[0]; 
  my $type = $_[1]; 
  #----------------------------
  # META: start of user-code
  #############
  ## 
  ## In general, this method needs to establish the base-language
  ## static type, and compute the base-language code to be executed
  ## at runtime to implement/emulate this type.
  ## 
  ## Note, however, that in Perl we do not need to assign a static
  ## type, since Perl doesn't have static types. However, since Perl
  ## does not have any static typing, we must generate much more
  ## runtime typechecking code for it than we do in other languages.
  ## As well, Perl has an unusual argument-passing style that
  ## requires some 'local variable spreading' code - it is all done
  ## here.
  ## 
  #############
  ##
  ## Here is an example of some Meta code involving types, and
  ## the kinds of information this method needs to compute for
  ## the types involved:
  ##
  ##  -------------------------------
  ##  CLASS A NAMESPACE Tests SCOPE { /# Meta-level
  ##    METHOD f(int& i) SCOPE<*> {   /# function
  ##      Var k : @int = 10;
  ##      Var j : &int = k;
  ##    };
  ##  } RUN<Perl> {                   /# main method, Perl
  ##    my $k = 37;
  ##    my $a = new Tests::A ();
  ##    $a->f($k);                    /# perl programmers do NOT need to pass in a reference!
  ##  } RUN<*> {                      /# main method, Meta(Oopl)*
  ##    Var k : int@ = 37;
  ##    new Var a : A ();
  ##    Call a . f(k);                /# Oopl* programmer does NOT need to send the reference in!
  ##  } class A;
  ##  -------------------------------
  ##  package A;
  ##  ...
  ##  sub f {                          # Perl-level
  ##      my $self = $_[0];
  ##      carp("Receiver is not of type 'SomeClass'") 
  ##         unless (defined($self) && $self->isa('SomeClass'));
  ## 
  ##      my $i; tie($i, 'Meta::Oopl::BaseLanguage::PerlScalarRef', \$_[1]);
  ##      carp("arg1 = '$i' is not of type 'int'") 
  ##         unless ( defined($i) && ( $i =~ m/^[+-]\d+$/ ) );
  ## 
  ##      my $k = 10;
  ## 
  ##      my $j; tie($j, 'Meta::Oopl::BaseLanguage::PerlScalarRef',\$k);
  ##  }
  ##  ...
  ##  sub __Meta_main {                # main method
  ##      ...
  ##      my $k = 37;
  ##      my $a = new Tests::A->new();
  ##      $a->f($a);
  ##  }
  ##  -------------------------------    

  ## We first check if an interned instance already exists.
  my $canonical = $type->inCanonicalForm();
  my $result    = $self->typeRegistry()->{$canonical};

  if ( ! $result ) {
    ## Convert the meta-level basetype to its Perl representation.
    my $natbasetype = $self->nativeBaseTypeFor($type->basetype());

    ## $metacore represents the Meta-level core base type.
    my $metacore    = $type->basetype()->core();

    ## $core represents the Perl-level base type, and is equal to
    ## the value of ref($v) for variables $v of type 'T*', NOT
    ## 'T@').
    my $core        = $natbasetype->core();

    ## Establish what kind of type we are (primitive, simple or
    ## parameterized).
    my $paramtype   = $natbasetype->asParamType();
    my $primtype    = $natbasetype->asPrimitiveType();
    my $simpletype  = $natbasetype->asSimpleType();
    my $notype      = ($core eq '?') ? 1 : 0;  ## special case - typing is disabled if core is '?' (used to implement Meta!Any - may also be used for other purposes)

    ## Note that the use of the simple regexp below relies heavily
    ## on the fact that 'semantics' is canonical and has already
    ## been validated - this regexp does not constrain legality (it
    ## has been done already). Note that the 'non-greedy' spec on
    ## ([#*]*?) is important so that a '#' after all '*' matches the
    ## ([#])? instead.
    my $sem = $type->semantics();
    my ($ref,$ptrs,$val,$const) = ( $sem =~ m/^([&])?([#*]*?)([@])?([#])?$/ );
    $ptrs =~ s/\*/p/g;
    $ptrs =~ s/\#p/P/g;
    my $np = length($ptrs);

    ## More boolean test vars
    my $isStr         = ( $metacore eq 'Meta!Str' ) ? 1 : 0; ## FUTURE FIX: May want to set $isStr   based on something more general than 'Meta!Str' (in case other native types have type-checking similar to Meta!Str)
    my $isArray       = ( $metacore eq 'Meta!Vec' ) ? 1 : 0; ## FUTURE FIX: May want to set $isArray based on something more general than 'Meta!Vec' (in case other native types have type-checking similar to Meta!Vec)
    my $isHash        = ( $metacore eq 'Meta!Map' ) ? 1 : 0; ## FUTURE FIX: May want to set $isHash  based on something more general than 'Meta!Map' (in case other native types have type-checking similar to Meta!Map)
    my $isSpecial     = ( $isArray  || $isHash    ) ? 1 : 0;
    my $classBaseType = ( (!$isStr) && (!$isSpecial) && (!$primtype) );
    my $isPtrConst    = ( $sem =~ m/^\#\*/ ) ? 1 : 0;

    ## At this point, we can use the variables $ref, $val and $const
    ## as simple boolean tests establishing whether the semantics
    ## contains a reference, value or type-const request. The $ptrs
    ## variable is both a boolean test for existence of pointers,
    ## and a specification of how many, and which ones are const -
    ## length of $ptrs is how many, 'p' means pointer, 'P' means
    ## const pointer. The $core variable provides hints as to the
    ## overall 'ref' perl type.

    ######
    ## Meta-type mapping for Perl.
    ## 
    ##  - Note that 'undef' in perl is equivalent to the more
    ##    common concept of "uninitialized" in other languages
    ##    (Perl allows one to know if something is uninitialized,
    ##    unlike most languages).
    ## 
    ##  - Should Meta(Oopl) require that all by-value types be
    ##    initialized?
    ## 
    ##     - by-value class types are never uninitialized.
    ## 
    ##     - by-value primitive types are allowed to be uninitialized
    ##       unless they are 'const' (not allowed to be undef if const).
    ## 
    ##     - by-value native types are supposed to look like
    ##       class types, so they too are not allowed to be
    ##       uninitialized.
    ## 
    ##  - The following tables establish various useful items:
    ##     Type --> the meta-level type in question
    ##     core --> ref($v) for variable $v of type Type.
    ##     UnD  --> 'Y' if variables of this type can be undefined (uninitialized), 'N' otherwise
    ##     Def  --> 'Y' if variables of this type can be assigned a default value, 'N' otherwise
    ##     Pre  --> prefix to place before the variable name
    ##     Acc  --> how the actual value of the variable is accessed
    ##     Elem --> how elements of the variable are accessed (only applicable to container types)
    ##     Tie  --> the tie class to use in implementing the type semantics
    ## 
    ## These are for core types that are primitives ('int' is an example)
    ##   Type   core   UnD Def Pre Acc  Elem Tie                     Notes
    ##   ----   ----   --- --- --- ---  ---- ---                     -----
    ##   @int    -      Y   Y   $  $V     -   -                      normal perl copy
    ##   @#int   -      N   Y   $  $V     -   PerlScalarRefConst     normal perl copy                    
    ##   *int    SCALAR Y   Y   $  $$V    -   -                    
    ##   *#int   SCALAR Y   Y   $  $$V    -   ${PerlScalarRefConst}
    ##   #*int   SCALAR N   Y   $  $$V    -   PerlScalarRefConst
    ##   &int    -      N   N   $  $V     -   PerlScalarRef
    ##   &#int   -      N   N   $  $V     -   PerlScalarRefConst   
    ##   **int   SCALAR Y   Y   $  $$$V   -   -
    ##  ***int   SCALAR Y   Y   $  $$$$V  -   -
    ##   &*int   SCALAR N   N   $  $$V    -   PerlScalarRef
    ##  &**int   SCALAR N   N   $  $$$V   -   PerlScalarRef
    ## &***int   SCALAR N   N   $  $$$$V  -   PerlScalarRef
    ## 
    ## Additional run-time checks can be applied to enforce 
    ## range restrictions.
    ##
    ## These are for core types that are class names ('A' is an example)
    ##   Type   core   UnD Def Pre Acc  Elem Tie                     Notes
    ##   ----   ----   --- --- --- ---  ---- ---                     -----
    ##   @A      A      N   N   $  $V     -   -                      copy
    ##   @#A     A      N   N   $  $V     -   -                      copy, how to deal with #?
    ##   *A      A      Y   Y   $  $V     -   -                        
    ##   *#A     A      Y   Y   $  $V     -   ${PerlScalarRefConst}  how to deal with #?
    ##   #*A     A      N   Y   $  $V     -   PerlScalarRefConst                    
    ##   &A      A      N   N   $  $V     -   -
    ##   &#A     A      N   ?   $  $V     -   -                      how to deal with #?
    ##   **A     SCALAR Y   Y   $  $$V    -   -
    ##  ***A     SCALAR Y   Y   $  $$$V   -   -
    ##   &*A     SCALAR N   N   $  $V     -   PerlScalarRef
    ##  &**A     SCALAR N   N   $  $$V    -   PerlScalarRef
    ## &***A     SCALAR N   N   $  $$$V   -   PerlScalarRef
    ##
    ## NOTE:
    ##   Meta!Str, Meta!Vec and Meta!Map are supposed to emulate equivalent
    ##   class types, so many of their column values are dictated by the values
    ##   established above for class types.  In particular, the 'UnD' and
    ##   'Def' fields of these native types correspond to the values for
    ##   class types, with one exception: &#Meta!Str is allowed a default
    ##   value (and should be efficiently implemented, as it is a very common
    ##   type).
    ##
    ## These are for Meta!Str
    ##   Type    core   UnD Def Pre Acc  Elem Tie                    Notes
    ##   ----    ----   --- --- --- ---  ---- ---                    -----
    ##   @Str    -      N   Y   $  $V     -   -                      normal perl copy
    ##   @#Str   -      N   Y   $  $V     -   PerlScalarRefConst     normal perl copy                    
    ##   *Str    SCALAR Y   Y   $  $$V    -   -                    
    ##   *#Str   SCALAR Y   Y   $  $$V    -   ${PerlScalarRefConst}                    
    ##   #*Str   SCALAR N   N   $  $$V    -   PerlScalarRefConst                    
    ##   &Str    -      N   N   $  $V     -   PerlScalarRef
    ##   &#Str   -      N   Y   $  $V     -   PerlScalarRefConst   
    ##   **Str   SCALAR Y   Y   $  $$$V   -   -
    ##  ***Str   SCALAR Y   Y   $  $$$$V  -   -
    ##   &*Str   SCALAR N   N   $  $$V    -   PerlScalarRef
    ##  &**Str   SCALAR N   N   $  $$$V   -   PerlScalarRef
    ## &***Str   SCALAR N   N   $  $$$$V  -   PerlScalarRef
    ## 
    ## These are for Meta!Vec
    ##   Type    core   UnD Def Pre Acc  Elem Tie                    Notes
    ##   ----    ----   --- --- --- ---  ---- ---                    -----
    ##   @Vec    -      N   N   @  $V    [$1] -                      copy
    ##   @#Vec   -      N   N   @  $V    [$1] PerlArrayRefConst      copy, how to deal with #?
    ##   *Vec    ARRAY  Y   Y   $  $V  ->[$1] -                      
    ##   *#Vec   ARRAY  Y   Y   $  $V  ->[$1] @{PerlArrayRefConst}                    
    ##   #*Vec   ARRAY  N   Y   $  $V  ->[$1] PerlScalarRefConst                    
    ##   &Vec    -      N   N   @  $V    [$1] PerlArrayRef         
    ##   &#Vec   -      N   ?   @  $V    [$1] PerlArrayRefConst    
    ##   **Vec   SCALAR Y   Y   $  $$V    -   -
    ##  ***Vec   SCALAR Y   Y   $  $$$V   -   -
    ##   &*Vec   SCALAR N   N   $  $V     -   PerlScalarRef
    ##  &**Vec   SCALAR N   N   $  $$V    -   PerlScalarRef
    ## &***Vec   SCALAR N   N   $  $$$V   -   PerlScalarRef
    ## 
    ## These are for Meta!Map
    ##   Type    core   UnD Def Pre Acc  Elem Tie                    Notes
    ##   ----    ----   --- --- --- ---  ---- ---                    -----
    ##   @Map    -      N   N   %  $V    {$1} -                      copy
    ##   @#Map   -      N   N   %  $V    {$1} PerlHashRefConst       copy, how to deal with #?
    ##   *Map    HASH   Y   Y   $  $V  ->{$1} -                      
    ##   *#Map   HASH   Y   Y   $  $V  ->{$1} %{PerlHashRefConst}
    ##   #*Map   HASH   N   Y   $  $V  ->{$1} PerlScalarRefConst                    
    ##   &Map    -      N   N   %  $V    {$1} PerlHashRef          
    ##   &#Map   -      N   ?   %  $V    {$1} PerlHashRefConst     
    ##   **Map   SCALAR Y   Y   $  $$V    -   -
    ##  ***Map   SCALAR Y   Y   $  $$$V   -   -
    ##   &*Map   SCALAR N   N   $  $V     -   PerlScalarRef
    ##  &**Map   SCALAR N   N   $  $$V    -   PerlScalarRef
    ## &***Map   SCALAR N   N   $  $$$V   -   PerlScalarRef
    ## 
    ## In addition, the following rules apply:
    ##  - a pointer type can be made const by tieing the pointer
    ##    to PerlScalarRefConst.
    ## 
    ##  - a pointer to a pointer has ref SCALAR, has prefix '$',
    ##    and has an 'Acc' formed by replacing $V with $$V. For
    ##    example, the type *!Map has Acc '$V->{$1}', and the type
    ##    **!Map has Acc '$$V->{$1}' (make sure the precendence works
    ##    properly!)
    ## 
    ##  - a reference to a pointer has the same ref as the pointer
    ##    (the pointer may not actually be a SCALAR, for example if
    ##    it points to a class type).  It is tied to PerlScalarRef
    ##    so that changes to the reference are also changes on the
    ##    underlying pointer.
    ##
    ## From the above, we can make the following general observations
    ## about the perltype (result of 'ref' function), required defined
    ## status, tie semantics, prefix of variable, and access syntax,
    ## in terms of the values of $ref, $val, $const and $ptrs (the
    ## first three of which are boolean tests, the last consisting of
    ## 0 or more 'p' or 'P' characters ('p' meaning pointer, 'P'
    ## meaning constant pointer) and whether the basetype, T, is
    ## primitive, simple or parameterized. 
    ##   1) perltype is empty unless
    ##       - |$ptrs|==1:
    ##          - perltype is $core
    ##       - |$ptrs|>1:
    ##          - perltype is SCALAR
    ##       - |$ptrs|==0:
    ##          - if T is class type, perltype is T
    ## 
    ##   2) The only time the variable can be undefined is when
    ##      the first letter in the canonical $sem is '*', or
    ##      if $val==1 and $primtype.
    ##   
    ##   3) With respect to whether the variable can have a default
    ##      value or not, the values for native types is the same
    ##      as for class types, so we need only consider primitive
    ##      and class types.
    ##        - if primitive, default allowed except for reference types
    ##        - otherwise, default allowed except for value or reference types
    ##          and the special case of &#Meta!Str.
    ##   
    ##   4) The variable prefix is almost always '$', the only
    ##      exceptions being when $ptrs is empty and the core is
    ##      Meta!Vec or Meta!Map (in which case the prefix is '@'
    ##      and '%' respectively).
    ##
    ##   5) The 'Acc' string associated with the type is needed
    ##      if 'deep typechecking' is desired (usually level 4, see
    ##      below), since we need to know how to access individual
    ##      elements of the variable. Deep checking can be expensive
    ##      for container types Meta!Map and Meta!Vec, and require
    ##      us to know how to iterate over the value V for those
    ##      container types. Note that the 'Acc' string could also
    ##      be used to automatically generate default FIELD accessor
    ##      strings!!!  Acc is established by:
    ##       - If class type or $isArray or $isMap, |ptrs| '$'
    ##         followed by 'V'. 
    ##       - Otherwise, |ptrs|+1 '$' followed by 'V'.
    ## 
    ##   6) The 'Elem' string is what is added to 'Acc' to access
    ##      an element of the variable (which means it empty
    ##      unless the type is a container class).
    ##       - if $isArray, '[$1]' except when |ptrs|==1,
    ##         when it is '->[$1]' instead.
    ##       - if $isHash, '{$1}' except when |ptrs|==1,
    ##         when it is '->{$1}' instead.
    ##
    ##   7) A variable of the type in question is tied to a class:
    ##       - if $ref and |$ptrs|>0
    ##           tie = 'PerlScalarRef'
    ##       - if not class
    ##          - if $val and $const
    ##              tie = 'Perl<C>Ref'
    ##            where 
    ##              <C> is 'Array'  if $isArray
    ##              <C> is 'Hash'   if $isHash
    ##              <C> is 'Scalar' otherwise
    ##          - if $ref and |$ptrs|==0
    ##              tie is 'Perl<C>Ref<c>'
    ##            where <C> is defined above and
    ##              <c> is 'Const'  if $isConst
    ##              <c> is empty    otherwise
    ##          - if $isPtrConst
    ##              tie is 'PerlScalarRef'
    ##          - if |$nptrs|==1 and $isConst
    ##              tie is 'Perl<C>RefConst'
    ##              tieadj = <CC>
    ##         empty, and
    ##          - $const is true and either $val or $ref is true, in
    ##            which case the tie class is Perl<X>RefConst, where
    ##            <X> is 'Hash' if core is Meta!Map, 'Array' if core
    ##            is Meta!Vec, and 'Scalar' otherwise.
    ##          - $ref is true and $const is not true, in which case
    ##            the tie class is Perl<X>Ref.
    ##       - if $ptrs >= 1, and $ref
    ##
    ## ###############################################################

    ####
    ## Establish $perltype based on $type.  Remember that $perltype
    ## is the value of the 'ref' command on a variable, so it is
    ## pretty limited.
    ##   1) perltype is empty unless
    ##       - |$ptrs|==1:
    ##          - perltype is $core
    ##       - |$ptrs|>1:
    ##          - perltype is SCALAR
    ##       - otherwise (|$ptrs|==0):
    ##          - if T is class type, perltype is T
    my $perltype;
    if ( $np == 1 ) {
      $perltype = $core;
    } elsif ( $np > 1 ) {
      ## multiple pointers - always scalar
      $perltype = 'SCALAR';
    } elsif ( $classBaseType ) {
      ## no ptrs, and class type - use core
      $perltype = $core;
    } else {
      ## if none of the above match, perltype is empty
      $perltype = '';
    }

    ####
    ## Established whether it is ok for the variable to be
    ## undefined.
    ##   2) The only time the variable can be undefined is when
    ##      the first letter in the canonical $sem is '*', or
    ##      if $val and $primtype.
    my $undefok = ( ( $sem =~ m/^\*/ ) || ( $val && $primtype ) ) ? 1 : 0;

    ##   3) With respect to whether the variable can have a default
    ##      value or not, the values for native types is the same
    ##      as for class types, so we need only consider primitive
    ##      and class types.
    ##        - if primitive, default allowed except for reference types
    ##        - otherwise, default allowed except for value or reference types
    ##          and the special case of &#Meta!Str.
    my $defaultok;
    if ( $primtype ) {
      ## Primitive types can have a default unless they are by reference
      $defaultok = ( $ref ? 0 : 1 );
    } elsif ( $isStr ) {
      ## Meta!Str can have a default unless it is by-value or
      ## by-reference (except that a &#Meta!Str is allowed
      ## a default).
      if ( $ref ) {
        $defaultok = ($const && !$ptrs) ? 1 : 0;
      } elsif ( $val ) {
        $defaultok = 0;
      } else {
        $defaultok = 1;
      }
    } else {
      ## Class and native types can have a default unless they are
      ## by-value or by-reference
      $defaultok = ( ($ref||$val) ? 0 : 1 );
    }

    ####
    ## Establish the variable prefix
    ##   4) The variable prefix is almost always '$', the only
    ##      exceptions being 
    ##       a) when $ptrs is empty and the core is Meta!Vec or
    ##          Meta!Map (in which case the prefix is '@' and '%'
    ##          respectively).
    ##       b) when the type is primitive and bits < 0 (varargs).
    ##          The prefix is '@' if bits is -1, and '%' if bits is -2
    my $vpref;
    if ( ! $ptrs ) {
      if ( ( $primtype ) && ( $primtype->bits() < 0 ) ) {
        ## Deal with 4.b)
        my $bits = $primtype->bits();
        $vpref = ( $bits == -2 ) ? "\%" : "\@";
      } else {
        ## Deal with 4.a)
        $vpref = ( $isArray ) ? "\@" : ( $isHash ? "\%" : "\$" );
      }
    } else {
      $vpref = "\$";
    }

    ####
    ## Establish the perl code needs to access the basetype value
    ## of a variable V of type $type.
    ##   5) Acc is established by:
    ##       - If class type or $isArray or $isMap, |ptrs| '$'
    ##         followed by 'V'. 
    ##       - Otherwise, |ptrs|+1 '$' followed by 'V'.
    my $acc;
    if ( $classBaseType || $isSpecial ) {
      my $p = ( $np ) ? $np : 1;
      $acc = ("\$" x $p) . 'V';
    } else {
      $acc = ("\$" x ($np+1)) . 'V';
    }

    ####
    ## Establish the 'Elem' value
    ##   6) The 'Elem' string is what is added to 'Acc' to access
    ##      an element of the variable (which means it empty
    ##      unless the type is a container class).
    ##       - if $isArray, '[$1]' except when |ptrs|==1,
    ##         when it is '->[$1]' instead.
    ##       - if $isHash, '{$1}' except when |ptrs|==1,
    ##         when it is '->{$1}' instead.
    my $elem;
    if ( $isArray ) {
      $elem = ( $np >= 1 ) ? "->[\$1]" : "[\$1]";
    } elsif ( $isHash ) {
      $elem = ( $np >= 1 ) ? "->{\$1}" : "{\$1}";
    } else {
      $elem = '';
    }

    ####
    ## Establish the 'tie' class associated with variables of this type
    ##  7) A variable of the type in question is tied to a class:
    ## 
    ##   - if $ref
    ##       tie = 'PerlScalarRef'
    ##   - 
    ## 
    ##      - $const is true and either $val or $ref is true, in
    ##        which case the tie class is Perl<X>RefConst, where
    ##        <X> is 'Hash' if core is Meta!Map, 'Array' if core
    ##        is Meta!Vec, and 'Scalar' otherwise.
    ## 
    ##      - $ref is true and $const is not true, in which case
    ##        the tie class is Perl<X>Ref.
    ## 
    ##   - if $ptrs >= 1, and $ref
    my $tie = '';
    if ( ( ! $classBaseType ) && ( ! $ptrs ) ) {
      my $infix = ( $isArray ) ? 'Array' : ( $isHash ? 'Hash' : 'Scalar' );
      if ( ( $const ) && ( $val || $ref ) ) {
        $tie = "Perl${infix}RefConst";
      } elsif ( ( ! $const ) && ( $ref ) ) {
        $tie = "Perl${infix}Ref";
      }
    } elsif ( ( $np >= 1 ) && ( $ref ) ) {
      $tie = "PerlScalarRef";
    }

    ## @code is an array of hashes with the following keys:
    ##   error   --> an expression evaluating to boolean true if an
    ##                error should be generated
    ##   output  --> a string to print if the error code evaluates
    ##               to false
    my @code;
    ## The information in @code will be used by the compiler as
    ## follows:
    ##  - A "level", T, of typechecking is established, which is always
    ##    guaranteed to be 0 or more.
    ## 
    ##  - Join all 'error' code snippets from $code[0] to $code[T] with
    ##    '&&' to form a single large boolean test.
    ## 
    ##  - Find the largest 'i' <= T for which $code[i]->{output} is defined
    ##    and from that obtain the error string (use a default if not defined)
    ## 
    ##  - In a method invocation, a method prolog will be generated 
    ##    in which the code associated with the type of each variable
    ##    is inserted. The various snippets use the following special
    ##    notation (which is replaced with the associate value each
    ##    time type-checking code is generated).
    ##     - <V> is the name of the variable (without prefix - the
    ##       prefix must either be added here, or established during
    ##       instantiation somehow).
    ##     - <S> is the variable, expression, etc. from which the
    ##       variable is initialized.  For args, this is always defined,
    ##       but may not be for local vars.  <S> must provide the
    ##       proper perl variable prefix.
    ##     - <T> is the variable, expression, etc. to use as the third
    ##       argument in 'tie' expressions.  It is usually equal to <S>,
    ##       but is somewhat different in special cases.
    ##     - <D> is the base-language syntax for a default value.
    ##    In the 'output' string, the following variables are also used:
    ##     - <R> is the value of ref(<V>), in single quotes.  Thus, 
    ##       if the variable has ref type SCALAR, <R> is 'SCALAR'.
    ##     - <v> is the value of <V>, in single quotes.  Thus, if the
    ##       variable has value hello, <v> is 'hello'.
    ## 
    ##  - A similar algorithm is used for 'code', except that the 
    ##    snippets from individual indices are concatenated together
    ##    without any delimiters (each snippet is assumed to contain 0
    ##    or more legal perl statements to be executed). Any output is
    ##    part of the 'code' snippets themselves.  All variables,
    ##    <V>,<S>,<R> and <v> are available in 'code' snippets. 
    ##
    ## The semantics of indices in @code are:
    ##  - index 0  : always executed, since T guaranteed to be >= 0.
    ##  - index 1  : tests which, if not true, result in the potential of
    ##               real problems arising in the code stream.  Examples
    ##               include undef values when not allowed and incorrect
    ##               ref types.
    ##  - index 2-4: successively more detailed tests.  Should avoid
    ##               adding anything above index 4, so that we always
    ##               know some number that is guaranteed to provide
    ##               full typechecking support.
    ##      index2 : often form-based checks (i.e. int types look like ints, floats look like floats)
    ##      index3 : often range-based checks (i.e. int types in proper order)
    ##      index4 : often for "deep" type-checking of container types.
    ## 
    ## NOTE: Could have provided both 'warning' and 'error' fields in
    ## @code but all typechecking failures really are errors, and we
    ## will be providing support at the compiler level to specify how
    ## typechecking errors should be reported (i.e. whether to use
    ## 'warn', 'carp', 'croak', etc.), so there is no need to make a
    ## distinction between them here - the varying levels in @code
    ## already make sufficient distinction, although conceptually they
    ## really aren't ordered in terms of decreasing importance but
    ## rather, usually in order of decreasing benefit-to-cost ratio.
    ## 
    ## Index 0 is used to specify the variable spreading code, and is
    ## absolutely crucial to the proper functioning of the program.
    ## All indices about 0 are optional, but in general index 1 is for
    ## undef and ref tests, with index 2+ used for regexp analysis of
    ## values, etc.

    my $warn = 'CORE::warn';

    #####
    ## %code is a map that establishes the core variable
    ## initialization schema based on type.
    ## 
    ## The initialization to 0 is VERY IMPORTANT in code below.
    ## If a value is 0, its value is copied from a related key,
    ## whereas if a value is 'undef', it stays undef (and means
    ## the key in question isn't legal).
    my %code = map { $_ => 0 } qw(UR UD SR SD XR XD);
    ## 
    ##  - Assume we are dealing with type T (which includes semantics S
    ##    and a base type that is either a primitive P, class type
    ##    C, or native type N).
    ## 
    ##  - We want to identify a collection of code snippets and tests.
    ##
    ##     [UR] variable definition and association (but may cause run-time fatal errors if invoked with improper types)
    ##     [UD] variable initialization (may be "in addition" to [SR], or may replace [SR])
    ##     [SR] variable definition and assocation (with minimum typechecking needed to avoid fatal runtime errors if misused)
    ##     [SD] variable initialization (may be "in addition" to [UR], or may replace [UR])
    ##     [T1] basic type checking
    ##     ...
    ##     [T4] super detailed type checking
    ##
    ##  - The base code for the variable is identified from [UR], [UD], [SR] and
    ##    [SD] depending on whether a default value has been provided, and
    ##    whether we are compiling in unsafe or safe mode (typecheck -1 or >= 0).
    ##    Use [UR] for unsafe required, [UD] for unsafe default, [SR] for
    ##    safe required, and [SD] for safe default.  If [UD] or [SD] starts with
    ##    ';', [UR] or [SR] is prepended, otherwise it is taken verbatim.
    ## 
    ##  - Some notation:
    ##      <N>   --> variable being introduced, without prefix
    ##
    ##      <V>   --> variable being introduced, with appropriate prefix
    ##                 - @<N> if T = @Meta!Vec or @#Meta!Vec
    ##                 - %<N> if T = @Meta!Map or @#Meta!Map
    ##                 - $<N> if T anything else
    ##
    ##      <A>   --> the reference from which <V> is initialized
    ##                 - always exists for argument passing
    ##                 - only exists for local vars for reference types (&T),
    ##                   and can easily be confused with <D> in this situation.
    ##                   Must establish a means of disambiguiting the concepts.
    ##
    ##      <V=A> --> normally expands to 'my <V> = <A>;', but for local
    ##                variables may expand to 'my <V>;' depending on
    ##                situation.
    ## 
    ##      <D>   --> the default value for the variable
    ##                 - for args, currently restricted to literals
    ##                 - for local vars, can at least be literals or variables,
    ##                   and may want to allow arbitrary lvalue, or even
    ##                   an arbitrary collection of statements.
    ## 
    ##      <R>   --> quoted value of actual ref type of variable

    ## We provide certain default values for %code and @code, then
    ## modify them in special cases.
    ##  - level 0 type checking involves ensuring that the variable
    ##    is defined (unless allowed to be undef) and has the expected
    ##    ref type.
    ##  - note that we provide two forms, one that checks against
    ##    <A>, one that checks against <V>.  The check against <A>
    ##    is more efficient in situations where <V> is a 'tie', and
    ##    in situations where <V> is a array or hash, the typechecking
    ##    code applies to the type of <A>, not <V>.  On the other hand,
    ##    the check against <V> is usually preferred because it works
    ##    on default values (the check against <A> does not).
    ##    
    my $defrefCheck;
    my $vecrefCheck;
    my $maprefCheck;
    my $clsrefCheck;
    if ( $undefok ) {
      $defrefCheck = {
        error  => "((defined(<V>)) && (ref(<V>) ne '$perltype'))",
        output => "\\<V> has ref <R> when ref '$perltype' expected",
      };
      $vecrefCheck = {
        error  => "((defined(<A>)) && (ref(<A>) ne 'ARRAY'))",
        output => "\\<V> has ref <r> when ref '$perltype' expected",
      };
      $maprefCheck = {
        error  => "((defined(<A>)) && (ref(<A>) ne 'HASH'))",
        output => "\\<V> has ref <r> when ref '$perltype' expected",
      };
      $clsrefCheck = {
        error  => "((defined(<V>)) && (!<V>->isa('$perltype')))",
        output => "\\<V> has ref <R> when ref '$perltype' expected",
      };
    } else {
      $defrefCheck = {
        error  => "((!defined(<V>)) || (ref(<V>) ne '$perltype'))",
        output => "\\<V> must be defined and have ref '$perltype' (is <R>)",
      };
      $vecrefCheck = {
        error  => "((!defined(<A>)) || (ref(<A>) ne 'ARRAY'))",
        output => "\\<V> must be defined and have ref '$perltype' (is <r>)",
      };
      $maprefCheck = {
        error  => "((!defined(<A>)) || (ref(<A>) ne 'HASH'))",
        output => "\\<V> must be defined and have ref '$perltype' (is <r>)",
      };
      $clsrefCheck = {
        error  => "((!defined(<V>)) || (!<V>->isa('$perltype')))",
        output => "\\<V> must be defined and have ref '$perltype' (is <R>)",
      };
    }

    ####
    ## Default initialization values.
    my $defdef = ' if (!defined(<A>)) { <V> = <D>; }';
    $code{UR} = 'my <V> = <A>;';
    $code{UD} = $code{UR} . $defdef;

    ## Level 1 type checking involves undef/ref checks
    $code[1] = $defrefCheck;


    ## FUTURE FIX: The following code initializes the %code and
    ## @code arrays using special-case code depending on what the
    ## type is like (is it primitive, a class type, etc., and is it
    ## a by-value, by-ref or by-ptr, etc.).  Currently, there is
    ## special case code not for the general question "is the type a
    ## native type?", but rather, "is the type Meta!Str?", "is the
    ## type "Meta!Vec", etc.  This native-type-specific code means
    ## that the 'Data' field, with its attempts to abstract all
    ## native-type information into a daa-structure, is not currently
    ## as general as it needs to be.  By changing the semantics of
    ## $isStr, $isArray and $isMap to something more general than just
    ## 'Meta!Str', 'Meta!Vec' and 'Meta!Map', we would be able to introduce
    ## new native types that share the same typing semantics as these
    ## fundamental types.  The goal is to establish a set of "low-level" type
    ## semantics that all native types (and all types in general) can be
    ## described in terms of.  So far, this set is:
    ##     primitive  (i.e. int*)
    ##     str-like   (i.e  Meta!Str#&)
    ##     array-like (i.e. Meta!Vec@)
    ##     hash-like  (i.e. Meta!Map@)
    ##     class-like (i.e. Meta.Str*)
    ##     notyping   (i.e. Meta!Any*)
    ## The 'notyping' semantics has been recently added to
    ## support Meta!Any* and other types for which perl-level
    ## type-checking should not occur, or is not yet available.
    if ( $notype ) {
      ## No typing - blank the default
      $code[1] = undef;

    } elsif ( $primtype ) {
      ###################################
      ##        Primitives
      ###################################
      ## T=@P  (pass-by-value primitive)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (defined(<V>) && ( ref(<V>) ne ''))
      ##        NOTE: non-const by-value primitives are allowed to be undef!
      ##   [T2] <V> !~ m/.../
      ##   [T3] (defined(<V>) && ( (LOW > <V>) || (HIGH <= <V>)))
      ##        NOTE: the extra defined test is unfortunate, but the only way
      ##        to avoid it involves putting the range tests up in T1, which
      ##        incurs more inefficiency for level 1 type checking than I want.
      ##        Note that if we don't check for defined, we would cause
      ##        mmmundefined warnings when doing the comparisons.
      ##------
      ## T=@#P   (pass-by-value const primitive)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##        NOTE: Unsafe mode doesn't enforce constness.
      ##   [SR] my <V>; tie(<V>, 'PerlScalarRefConst', \<A>);
      ##   [SD] my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, 'PerScalarRefConst', \$__meta_<N>); } else { tie(<V>, 'PerlScalarRefConst', \<A>); };
      ##        NOTE: We use <A> in typecheck tests instead of <V> for efficiency
      ##   [T1] (!defined(<V>)) || ( ref(<V>) ne '' )
      ##   [T2] <V> !~ m/.../
      ##   [T3] (LOW > <V>) || (HIGH < <V>) 
      ##        NOTE: Do not have the same redundant check as for T=@P here because
      ##        we won't get to this test if <V> is undef (it will fail in T1)
      ##------
      ## T=&P  (pass-by-reference primitive)
      ##   [UR] my <V>; tie(<V>,'PerlScalarRef', \<A>);
      ##   [UD] error?
      ##   [T1] (defined(<V>)) || (ref(<V>) ne '')
      ##   [T2] <V> !~ m/.../
      ##   [T3] (LOW > <V>) || (HIGH <= <V>) 
      ##------
      ## T=&#P   (pass-by-reference const primitive)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##        NOTE: Unsafe mode treats const ref as non-const value
      ##   [XR] my <V>; tie(<V>, 'PerlScalarRefConst', \<A>);
      ##   [XD] my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, 'PerScalarRefConst', \$__meta_<N>); } else { tie(<V>, 'PerlScalarRefConst', \<A>); }; 
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')
      ##   [T2] <V> !~ m/.../
      ##   [T3] (LOW > <V>) || (HIGH < <V>) 
      ##------
      ## T=*P   (pass-by-pointer primitive)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <A>; }
      ##   [T1] (defined(<V>) && (ref(<V>) eq 'SCALAR'))
      ##   [T4] (defined(<V>) && (($<V> !~ m/.../) || (LOW > $<V>) || (HIGH <= $<V>)))
      ##------
      ## T=*#P  (pass-by-pointer const primitive)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##        NOTE: Unsafe mode treats const ref as non-const value
      ##   [XR] my <V>; tie($<V>, 'PerlScalarRefConst', \$<A>);
      ##   [XD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne 'SCALAR')
      ##   [T4] ($<V> !~ m/.../) || (LOW > $<V>) || (HIGH <= $<V>) 

      ####
      ## Regardless of semantics, we establish some type-checking
      ## conditions for the primitive type.
      my ($min,$max,$form,$formout,$rangeout);
      my $N = $primtype->bits();
      my $code = $primtype->code();
      if ( $code == 1 ) {
        ## boolean - no tests - allow any empty-ref val to be boolean
      } elsif ( $code == 2 ) {
        ## ordinal
        $form     = "( <V> !~ m/^[+-]?\\d+\$/ )";
        $formout  = "\\<V> = <v> is not of type 'ordinal'";
        $max      = 2**($N-1);
        $min      = -$max;
        $rangeout = "\\<V> = <v> is not of type 'ordinal<$N>";
      } elsif ( $code == 3 ) {
        ## uordinal
        $form     = "( <V> !~ m/^[+]?\\d+\$/ )";
        $max      = 2**$N;
        $min      = 0;
        $formout  = "\\<V> = <v> is not of type 'uordinal'";
        $rangeout = "\\<V> = <v> is not of type 'uordinal<$N>";
      } elsif ( $code == 4 ) {
        ## real - no real need to put range restrictions on this!
        $form = "( <V> =~ m/^[+-]?(?:\\d*\.\\d+|\\d+(\.\\d+)?)\$/ )",
        $formout = "\\<V> = <v> is not of type 'real'";
      } elsif ( $code == 5 ) {
        ## char
        $form = "( length(<V>) == 1 )",
        $formout = "\\<V> = <v> is expected to have length 1";
      } elsif ( $code == 6 ) {
        ## varargs
        $code{UR} = 'my <V> = @_[<a>..$#_];';
        $code{UD} = $code{UR};
        $code[1] = undef; ## FUTURE FIX: should verify that $#_-<a>+1 is even!
        $form = '';
        $formout = '';
      }
      my $formCheck = {
        error  => $form,
        output => $formout,
      };
      my $rangeCheck;
      if ( defined($min) ) {
        $rangeCheck = {
          error  => "($min> > <V>) || ($max < <V>)",
          output => $rangeout,
        };
      }

      ####
      ## Semantics-specific initialization
      if ( $val ) {
        ###################
        ## Value Primitives
        ###################
        ## We do form and range type-checking for all value primitives
        ## except varargs.
        if ( $code != 6 ) {
          $code[2] = $formCheck;
          $code[3] = $rangeCheck;

          if ( $const ) {
            ## Since by-value consts are rather useless, we only enforce
            ## them in X.
            $code{XR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';
            $code{XD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerScalarRefConst", \$__meta_<N>); } else { tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>); };';
          }
        }

      } elsif ( $ref ) {
        #######################
        ## Reference Primitives
        #######################
        ## We do form and range type-checking for all reference primitives
        $code[2] = $formCheck;
        $code[3] = $rangeCheck;

        if ( $const ) {
          ## Note that at U and S, we treat const-refs as
          ## non-const-vals. Only at X do we implement real
          ## const-ref semantics.
          $code{XR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';
          $code{XD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerScalarRefConst", \$__meta_<N>); } else { tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>); };';

        } else {
          ## Non-const reference:
          ##  - We must always use 'tie'
          ##  - Currently not allowing defaults (would need to be
          ##    lvalues, not literals, and the eligible literals aren't
          ##    worth it for now).
          $code{UR} = 'my <V>; tie(<V>,"Meta::Oopl::BaseLanguage::PerlScalarRef", \<A>);';
          $code{UD} = undef;
        }
      } elsif ( $np ) {
        #####################
        ## Pointer Primitives
        #####################
        if ( $np == 1 ) {
          if ( $const && $isPtrConst ) {
            printf(STDERR "ERROR: Cannot yet handle type '$canonical'\n");
          } elsif ( $const ) {
            ## NOTE: Type '*#P' is treated as '*P' at U, and enforced at 'S.
            ## (the reason why U is unsafe is because of exactly this situation).
            ## 
            ## The value to which the pointer points is const (the
            ## pointer itself is not const). Note that <A> is a
            ## pointer, but we make a copy of that pointer for use
            ## in 'tie' (via \*<A>). If we did not, then <A> would
            ## be blessed, and subsequent subcalls passing <A> could
            ## rebless it into a different class (so that when we
            ## came back up to this class, the code would perform
            ## incorrectly).
            $code{SR} = 'my <V>; tie($<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \${<A>});';
            $code{SD} = $code{SR} . $defdef;

          } elsif ( $isPtrConst ) {
            ## NOTE: Type '#*P' is very rare, so we could actually
            ## support const at level U, but we wait till level S.
            ## 
            ## The pointer is const, not the value to which the pointer points.
            ## Note that we do NOT need to make a copy of the <A> pointer,
            ## since we are making a pointer to the pointer in the ref anyway.
            ## Hopefully, the only time this will pose problems is if the
            ## underyling value to which <A> refers changes (which shouldn't
            ## be possible while in the sub-function call chain??).
            $code{SR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';

            ## Note that if a default exists, we cannot just use XR
            ## + '<V> = <D>' because <V> is not allowed to accept
            ## assignments from X.
            $code{SD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \$__meta_<N>); } else { tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>); }';

          } else {
            ## Nothing constant - the default is fine.
            ## But do we want to add some safety code at SR or XR to
            ## ensure that we really have the proper thing???  Or
            ## some typechecking code at some level???  Level 1 is
            ## ensuring proper ref type, but nothing more.
            ##
            ## NOTE: If we add code here, it must also be added in
            ## $isPtrConst!!!
          }

        } else {
          die("ERROR: Note yet handling type '$canonical'");
        }
      }

    } elsif ( $isStr ) {
      ###################################
      ##        Meta!Str
      ###################################
      ##
      ## IMPORTANT: There exists a code tangle between this code and
      ## the code above for primitive types. Although not identical
      ## (strings do not do range or form checking), the %code code
      ## is currently identical between the two, so "fixes" to one
      ## or the other will probably also apply to the other.
      ##
      ## T=@Str (pass-by-value Meta!Str)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (!defined(<V>)) || (ref($v) ne '')
      ##        NOTE: @Str not allowed to be undef (emulating class type)
      ##------
      ## T=@#Str  (pass-by-value const Meta!Str)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##        NOTE: unsafe mode does not enforce const-ness
      ##   [SR] my <V>; tie(<V>, 'PerlScalarRefConst', \<A>);
      ##   [SD] my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, 'PerScalarRefConst', \$__meta_<N>); } else { tie(<V>, 'PerlScalarRefConst', \<A>); };
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')
      ##------
      ## T=&Str (pass-by-reference Meta!Str)
      ##   [UR] my <V>; tie(<V>, 'PerlScalarRef', \<A>);
      ##   [UD] error
      ##   [XR] my <V>; if (ref(<A>) eq '') { tie(<V>, 'PerlScalarRef', \<A>); } else { warn("..."); }
      ##   [XD] error
      ##   [T1] (!defined(<V>)) || (ref($v) ne '')
      ##------
      ## T=&#Str  (pass-by-reference const Meta!Str)
      ##   [UR] my <V>; tie(<V>, 'PerlScalarRef', \<A>);
      ##   [UD] ; if (!defined(<A>)) { <V> = <D>; }
      ##        NOTE: unsafe mode does not enforce const-ness
      ##   [SR] my <V>; tie(<V>, 'PerlScalarRefConst', \<A>);
      ##   [SD] my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, 'PerScalarRefConst', \$__meta_<N>); } else { tie(<V>, 'PerlScalarRefConst', \<A>); };
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')
      ##------
      ## T=*Str (pass-by-pointer Meta!Str)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (defined(<V>) && (ref(<V>) ne 'SCALAR'))
      ##------
      ## T=*#Str  (pass-by-pointer const Meta!Str)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<A>)) { <V> = <D>; }
      ##        NOTE: unsafe mode does not enforce const-ness
      ##   [SR] my <V>; tie(<V>, 'PerlScalarRefConst', \<A>);
      ##   [SD] my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, 'PerScalarRefConst', \$__meta_<N>); } else { tie(<V>, 'PerlScalarRefConst', <A>); };
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')

      ####
      ## Semantics-specific initialization
      if ( $val ) {
        ###################
        ## Value Meta!Str
        ###################
        if ( $const ) {
          ## By-value const types are really not very useful,
          ## so we only really enforce them in X.
          $code{XR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';
          $code{XD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerScalarRefConst", \$__meta_<N>); } else { tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>); };';
        }

      } elsif ( $ref ) {
        #####################
        ## Reference Meta!Str
        #####################
        if ( $const ) {
          ## Note that at U and S, we treat const-refs as
          ## non-const-vals. Only at X do we implement real
          ## const-ref semantics. This means that const string
          ## references ARE more efficiently implemented than
          ## non-const string references, except in safety level X,
          ## which is good given how common they are.
          $code{XR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';
          $code{XD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerScalarRefConst", \$__meta_<N>); } else { tie(<V>, "PerlScalarRefConst", \<A>); };';

        } else {
          ## Non-const reference:
          ##  - We must always use 'tie'
          ##  - Currently not allowing defaults (would need to be
          ##    lvalues, not literals, and the eligible literals aren't
          ##    worth it for now).
          $code{UR} = 'my <V>; tie(<V>,"Meta::Oopl::BaseLanguage::PerlScalarRef", \<A>);';
          $code{UD} = undef;
        }
      } elsif ( $np ) {
        #####################
        ## Pointer Meta!Str
        #####################
        if ( $np == 1 ) {
          if ( $const && $isPtrConst ) {
            printf(STDERR "ERROR: Cannot yet handle type '$canonical'\n");
          } elsif ( $const ) {
            ## NOTE: Type '*#Meta!Str' is sufficiently common to
            ## merit enforcing constness at level 'S'.
            ## 
            ## The value to which the pointer points is const (the
            ## pointer itself is not const). Note that <A> is a
            ## pointer, but we make a copy of that pointer for use
            ## in 'tie' (via \*<A>). If we did not, then <A> would
            ## be blessed, and subsequent subcalls passing <A> could
            ## rebless it into a different class (so that when we
            ## came back up to this class, the code would perform
            ## incorrectly).
            $code{SR} = 'my <V>; tie($<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \${<A>});';
            $code{SD} = $code{SR} . $defdef;

          } elsif ( $isPtrConst ) {
            ## NOTE: Type '#*Meta!Str' is very rare, so we could
            ## actually support const at level U, but we wait till
            ## level S.
            ## 
            ## The pointer is const, not the value to which the pointer points.
            ## Note that we do NOT need to make a copy of the <A> pointer,
            ## since we are making a pointer to the pointer in the ref anyway.
            ## Hopefully, the only time this will pose problems is if the
            ## underyling value to which <A> refers changes (which shouldn't
            ## be possible while in the sub-function call chain??).
            $code{SR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';

            ## Note that if a default exists, we cannot just use XR
            ## + '<V> = <D>' because <V> is not allowed to accept
            ## assignments from X.
            $code{SD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \$__meta_<N>); } else { tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>); }';

          } else {
            ## Nothing constant - the default is fine.
            ## But do we want to add some safety code at SR or XR to
            ## ensure that we really have the proper thing???  Or
            ## some typechecking code at some level???  Level 1 is
            ## ensuring proper ref type, but nothing more.
            ##
            ## NOTE: If we add code here, it must also be added in
            ## $isPtrConst!!!

          }

        } else {
          die("ERROR: Note yet handling type '$canonical'");
        }
      }

    } elsif ( $isArray ) {
      ###################################
      ##        Meta!Vec
      ###################################
      ##------
      ## T=@Vec  (pass-by-value array)
      ##   [UR] my <V> = @{<A>};
      ##   [UD] error to provide default to by-value vec???
      ##   [SR] my <V>; if (defined(<A>) && (ref(<A>) eq 'ARRAY')) { <V> = @{<A>}; } else { warn("..."); };
      ##   [SD] error to provide default to by-value vec???
      ##   [T4] type-check the elements of <V>.  ugh!
      ##------
      ## T=@#Vec  (pass-by-value const array)
      ##   [UR] my <V>; tie(<V>, 'PerlArrayRefConst', <A>);
      ##        NOTE: we implement const by-value as if const by-reference!
      ##   [UD] error to provide default to by-value vec???
      ##   [SR] 
      ##        NOTE: we could actually perform the copy, but why???
      ##   [SD] error to provide default to by-value vec???
      ##   [T4] type-check the elements of <V>.  ugh!
      ##------
      ## T=&Vec  (pass-by-reference array)
      ##   [UR] my <V>; tie(<V>, 'PerlArrayRef', <A>);
      ##        NOTE: We bind <V> to <A>, not \<A>, since <A> is already an ARRAY
      ##              (that is, Meta passes by-value vecs and maps by pointer!!!)
      ##        NOTE: For local vars, we need to change <A> to \@<A> to get a copy
      ##              of the pointer.  However, for args, we probably do not need
      ##              to do this.
      ##   [UD] error to provide default to &Vec
      ##   [SR] NOTE: If we use \@<A> instead of <A>, we will need
      ##        to verify that ref(<A>) eq 'ARRAY' before the dereference to
      ##        avoid runtime errors.  However, this is a common type, and
      ##        we want to provide efficiency, so we avoid this test unless
      ##        in ultra-safe mode.
      ##   [XR] my <V>; if ( ref(<A>) eq 'ARRAY' ) { tie(<V>, 'PerlArrayRef', <A>); } else { warn("..."); }
      ##   [T1] (!defined(<V>)) || (ref($v) ne '')
      ##------
      ## T=&#Vec  (pass-by-reference const array)
      ##   [UR] my <V>; tie(<V>, 'PerlArrayRefConst', <A>);
      ##   [UD] error to provide default to &Vec
      ##        NOTE: we could ignore const-ness in unsafe
      ##        mode, but since we already need to use tie
      ##        to get reference semantics, there is no real
      ##        benefit to defering.
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')
      ##------
      ## T=*Vec  (pass-by-pointer array)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<A>)) { <V> = <D>; }
      ##   [T1] (defined(<V>) && (ref($v) ne 'ARRAY'))
      ##------
      ## T=*#Vec  (pass-by-pointer const array)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<A>)) { <V> = <D>; }
      ##        NOTE: unsafe mode does not enforce const-ness
      ##   [SR] my <V>; tie(@{<V>}, 'PerlArrayRefConst', <A>);
      ##   [SD] my <V>; if (!defined(<A>)) { <V> = <D>; } else { tie(@{<V>}, 'PerlArrayRefConst', <A>); };
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')
      ## 
      ## Future notes:
      ##   - For **#Vec, we could use 'my <V>; ...; tie(@{@{<V>}}, 'PerlArrayRefConst', ${<A>})'
      ##     (we dereference the arg once, leaving a single pointer.  Will appropriate
      ##     sub elements of the local <V> pop into existence properly though?  Or do we
      ##     need 'my <V> = []; ...'?  If we do, we are in trouble for ***#Vec.

      ## IMPORTANT: There is a pseudo-code-tangle between this code and that
      ## for Meta!Map.  Changes made here most likely apply there as well.

      ####
      ## Semantics-specific initialization
      if ( $val ) {
        ###################
        ## Value Meta!Vec
        ###################
        ## - the default behavior '<V> = <A>' does NOT work here, because
        ##   Meta must pass by-value !Vec types by pointer, then
        ##   copy them during local variable definition.  Note that <V>
        ##   will contain the proper '@' prefix, but we must explicitly
        ##   dereference <A> to obtain copies.
        ## - For now, we do not allow default values for !Vec value types.
        ## - the default $code[1] typecheck looks at <V> (which for value
        ##   array/hash types is wrong because 'defined(@v)' and 'ref(@v)'
        ##   don't make sense (and the typecheck code is expecting a pointer,
        ##   not a value, even if it did make sense).  What we really need
        ##   $code[1] to do is test <A>, not <V>.  Since default values are
        ##   not allowed, no problems occur because of this switch.
        $code{UD} = undef;
        $code[1] = $vecrefCheck;

        if ( $const ) {
          ## Constant value types are uncommon in C++ as they aren't
          ## any more useful than non-const value types).
          ## Interestingly enough, however, they provide an
          ## interesting optimization potential (I wonder if C++
          ## ever takes advantage of this??). In particular, const
          ## by-value arrays can be implemented as const
          ## by-reference arrays to avoid incuring the copy!
          ## 
          ## We use this optimization at U, and don't both "fixing" it even
          ## at X (we would need to copy AND make a reference, for no reason)
          $code{UR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlArrayRefConst", \@{<A>});';
          $code[1] = undef; ## FUTURE FIX!  Cannot be $vecrefCheck unless we can figure out how to make real copies of pointers!! \@{<A>} == <A>!
        } else {
          ## non-const by-value vectors are to be copied. Remember
          ## that they are passed by-pointer, so the arg must be
          ## dereferenced.
          $code{UR} = 'my <V> = @{<A>};';
          $code{XR} = "my <V>; if (ref(<A>) eq \"ARRAY\") { <V> = \@{<A>}; } else { $warn\(\"Attempt to dereference ARRAY when \"); }";
        }

      } elsif ( $ref ) {
        #####################
        ## Reference Meta!Vec
        #####################
        ## - For now, we do not allow default values for !Map ref types.
        ## - the default $code[1] typecheck looks at <V> (which for ref
        ##   array/hash types is wrong because 'defined(%v)' and 'ref(%v)'
        ##   don't make sense (and the typecheck code is expecting a pointer,
        ##   not a value, even if it did make sense).  What we really need
        ##   $code[1] to do is test <A>, not <V>.  Since default values are
        ##   not allowed, no problems occur because of this switch.
        $code{UD} = undef;
        $code[1] = undef; ## $vecrefCheck;

        if ( $const ) {
          ## For arrays, unlike primitives and strings, we implement const-refs
          ## for real at U (implementing as non-const-vals incurs a copy that
          ## is probably more expensive than the indirections caused by the
          ## reference implementation, although this depends on how much the
          ## array is accessed within the method.
          $code{UR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlArrayRefConst", \@{<A>});';

        } else {
          ## Non-const reference:
          ##  - We must always use 'tie'
          ##  - Currently not allowing defaults (would need to be
          ##    lvalues, not literals, and the eligible literals aren't
          ##    worth it for now).
          ##  - remember that <A> is an ARRAY (pointer) already!  We
          ##    make a copy of the pointer before typing.
          $code{UR} = 'my <V>; tie(<V>,"Meta::Oopl::BaseLanguage::PerlArrayRef", \@{<A>});';
        }
      } elsif ( $np ) {
        #####################
        ## Pointer Meta!Vec
        #####################
        if ( $np == 1 ) {
          if ( $const && $isPtrConst ) {
            printf(STDERR "ERROR: Cannot yet handle type '$canonical'\n");
          } elsif ( $const ) {
            ## NOTE: Type '*#Meta!Vec' is sufficiently common to merit enforcing
            ## constness at level 'S'.
            ## 
            ## The value to which the pointer points is const (the
            ## pointer itself is not const). Note that <A> is a
            ## ARRAY, but we make a copy of that pointer for use
            ## in 'tie' (via \*<A>). If we did not, then <A> would
            ## be blessed, and subsequent subcalls passing <A> could
            ## rebless it into a different class (so that when we
            ## came back up to this class, the code would perform
            ## incorrectly).
            $code{SR} = 'my <V>; tie(@<V>, "Meta::Oopl::BaseLanguage::PerlArrayRefConst", \@{<A>});';
            $code{SD} = $code{SR} . $defdef;

          } elsif ( $isPtrConst ) {
            ## NOTE: Type '#*Meta!Vec' is very rare, so we could
            ## actually support const at level U, but we wait till
            ## level S.
            ## 
            ## The pointer is const, not the value to which the pointer points.
            ## Note that we do NOT need to make a copy of the <A> pointer,
            ## since we are making a pointer to the pointer in the ref anyway.
            ## Hopefully, the only time this will pose problems is if the
            ## underyling value to which <A> refers changes (which shouldn't
            ## be possible while in the sub-function call chain??).
            $code{SR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';

            ## Note that if a default exists, we cannot just use XR
            ## + '<V> = <D>' because <V> is not allowed to accept
            ## assignments from X.
            $code{SD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \$__meta_<N>); } else { tie(<V>, "PerlScalarRefConst", \<A>); }';

          } else {
            ## Nothing constant - the default is fine.
            ## But do we want to add some safety code at SR or XR to
            ## ensure that we really have the proper thing???  Or
            ## some typechecking code at some level???  Level 1 is
            ## ensuring proper ref type, but nothing more.
            ##
            ## NOTE: If we add code here, it must also be added in
            ## $isPtrConst!!!
          }

        } else {
          die("ERROR: Note yet handling type '$canonical'");
        }
      }

    } elsif ( $isHash ) {
      ###################################
      ##        Meta!Map
      ###################################
      ##------
      ## T=@Map  (pass-by-value hash)
      ##   [UR] my <V> = %{<A>};
      ##   [UD] error to provide default to by-value vec???
      ##   [SR] my <V>; if (defined(<A>) && (ref(<A>) eq 'HASH')) { <V> = %{<A>}; } else { warn("..."); };
      ##   [SD] error to provide default to by-value vec???
      ##   [T4] type-check the elements of <V>.  ugh!
      ##------
      ## T=@#Map  (pass-by-value const hash)
      ##   [UR] my <V>; tie(<V>, 'PerlHashRefConst', <A>);
      ##        NOTE: we implement const by-value as if const by-reference!
      ##   [UD] error to provide default to by-value vec???
      ##   [SR] 
      ##        NOTE: we could actually perform the copy, but why???
      ##   [SD] error to provide default to by-value vec???
      ##   [T4] type-check the key/value pairs of <V>.  ugh!
      ##------
      ## T=&Map  (pass-by-reference hash)
      ##   [UR] my <V>; tie(<V>, 'PerlHashRef', <A>);
      ##        NOTE: We bind <V> to <A>, not \<A>, since <A> is already an HASH
      ##   [UD] error
      ##   [XR] my <V>; if ( ref(<A>) eq 'HASH' ) { tie(<V>, 'PerlHashRef', <A>); } else { warn("..."); }
      ##   [T1] (!defined(<V>)) || (ref($v) ne '')
      ##------
      ## T=&#Map  (pass-by-reference const hash)
      ##   [UR] my <V>; tie(<V>, 'PerlHashRefConst', <A>);
      ##   [UD] error 
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')
      ## 
      ##------
      ## T=*Map  (pass-by-pointer hash)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<A>)) { <V> = <D>; }
      ##   [T1] (defined(<V>) && (ref($v) ne ''))
      ##------
      ## T=*#Map  (pass-by-pointer const hash)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<A>)) { <V> = <D>; }
      ##        NOTE: unsafe mode does not enforce const-ness
      ##   [SR] my <V>; tie(%{<V>}, 'PerlHashRefConst', <A>);
      ##   [SD] my <V>; if (!defined(<A>)) { <V> = <D>; } else { tie(%{<V>}, 'PerlHashRefConst', <A>); };
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne '')

      ## IMPORTANT: There is a pseudo-code-tangle between this code and that
      ## for Meta!Vec.  Changes made here most likely apply there as well.

      ####
      ## Semantics-specific initialization
      if ( $val ) {
        ###################
        ## Value Meta!Map
        ###################
        ## - the default behavior '<V> = <A>' does NOT work here, because
        ##   Meta must pass by-value !Map types by pointer, then
        ##   copy them during local variable definition.  Note that <V>
        ##   will contain the proper '%' prefix, but we must explicitly
        ##   dereference <A> to obtain copies.
        ## - For now, we do not allow default values for !Map value types.
        ## - the default $code[1] typecheck looks at <V> (which for value
        ##   array/hash types is wrong because 'defined(%v)' and 'ref(%v)'
        ##   don't make sense (and the typecheck code is expecting a pointer,
        ##   not a value, even if it did make sense).  What we really need
        ##   $code[1] to do is test <A>, not <V>.  Since default values are
        ##   not allowed, no problems occur because of this switch.
        $code{UD} = undef;
        $code[1] = $maprefCheck;

        if ( $const ) {
          ## Constant value types are uncommon in C++ as they aren't
          ## any more useful than non-const value types).
          ## Interestingly enough, however, they provide an
          ## interesting optimization potential (I wonder if C++
          ## ever takes advantage of this??). In particular, const
          ## by-value arrays can be implemented as const
          ## by-reference arrays to avoid incuring the copy!
          ## 
          ## We use this optimization at U, and don't both "fixing" it even
          ## at X (we would need to copy AND make a reference, for no reason)
          $code{UR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlHashRefConst", \%{<A>});';
          $code[1] = undef; ## FUTURE FIX!  Cannot be $vecrefCheck unless we can figure out how to make real copies of pointers!! \%{<A>} == <A>!
        } else {
          ## non-const by-value vectors are to be copied. Remember
          ## that they are passed by-pointer, so the arg must be
          ## dereferenced.
          $code{UR} = 'my <V> = %{<A>};';
          $code{SR} = "my <V>; if (ref(<A>) eq \"HASH\") { <V> = \%{<A>}; } else { $warn\(\"Attempt to dereference HASH when \"); }";
        }

      } elsif ( $ref ) {
        #####################
        ## Reference Meta!Map
        #####################
        ## - For now, we do not allow default values for !Map ref types.
        ## - the default $code[1] typecheck looks at <V> (which for ref
        ##   array/hash types is wrong because 'defined(%v)' and 'ref(%v)'
        ##   don't make sense (and the typecheck code is expecting a pointer,
        ##   not a value, even if it did make sense).  What we really need
        ##   $code[1] to do is test <A>, not <V>.  Since default values are
        ##   not allowed, no problems occur because of this switch.
        $code{UD} = undef;
        $code[1] = undef; ## $maprefCheck;

        if ( $const ) {
          ## For hashes, unlike primitives and strings, we implement const-refs
          ## for real at U (implementing as non-const-vals incurs a copy that
          ## is probably more expensive than the indirections caused by the
          ## reference implementation, although this depends on how much the
          ## hash is accessed within the method.
          $code{UR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlHashRefConst", \%{<A>});';

        } else {
          ## Non-const reference:
          ##  - We must always use 'tie'
          ##  - Currently not allowing defaults (would need to be
          ##    lvalues, not literals, and the eligible literals aren't
          ##    worth it for now).
          ##  - remember that <A> is an HASH (pointer) already!  We
          ##    make a copy of the pointer before typing.
          $code{UR} = 'my <V>; tie(<V>,"Meta::Oopl::BaseLanguage::PerlHashRef", \%{<A>});';
        }
      } elsif ( $np ) {
        #####################
        ## Pointer Meta!Map
        #####################
        if ( $np == 1 ) {
          if ( $const && $isPtrConst ) {
            printf(STDERR "ERROR: Cannot yet handle type '$canonical'\n");
          } elsif ( $const ) {
            ## NOTE: Type '*#Meta!Map' is sufficiently common to merit enforcing
            ## constness at level 'S'.
            ## 
            ## The value to which the pointer points is const (the
            ## pointer itself is not const). Note that <A> is a
            ## HASH, but we make a copy of that pointer for use
            ## in 'tie' (via \*<A>). If we did not, then <A> would
            ## be blessed, and subsequent subcalls passing <A> could
            ## rebless it into a different class (so that when we
            ## came back up to this class, the code would perform
            ## incorrectly).
            $code{SR} = 'my <V>; tie(%<V>, "Meta::Oopl::BaseLanguage::PerlHashRefConst", \%{<A>});';
            $code{SD} = $code{SR} . $defdef;

          } elsif ( $isPtrConst ) {
            ## NOTE: Type '#*Meta!Map' is very rare, so we could
            ## actually support const at level U, but we wait till
            ## level S.
            ## 
            ## The pointer is const, not the value to which the pointer points.
            ## Note that we do NOT need to make a copy of the <A> pointer,
            ## since we are making a pointer to the pointer in the ref anyway.
            ## Hopefully, the only time this will pose problems is if the
            ## underyling value to which <A> refers changes (which shouldn't
            ## be possible while in the sub-function call chain??).
            $code{SR} = 'my <V>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \<A>);';

            ## Note that if a default exists, we cannot just use XR
            ## + '<V> = <D>' because <V> is not allowed to accept
            ## assignments from X.
            $code{SD} = 'my <V>; if (!defined(<A>)) { my $__meta_<N> = <D>; tie(<V>, "Meta::Oopl::BaseLanguage::PerlScalarRefConst", \$__meta_<N>); } else { tie(<V>, "PerlScalarRefConst", \<A>); }';

          } else {
            ## Nothing constant - the default is fine.
            ## But do we want to add some safety code at SR or XR to
            ## ensure that we really have the proper thing???  Or
            ## some typechecking code at some level???  Level 1 is
            ## ensuring proper ref type, but nothing more.
            ##
            ## NOTE: If we add code here, it must also be added in
            ## $isPtrConst!!!
          }

        } else {
          die("ERROR: Note yet handling type '$canonical'");
        }
      }


    } else {
      ###################################
      ##        Classes
      ###################################
      ## T=@C   (pass-by-value class type  --> implemented as cloned pointer)
      ##   [UR] my <V> = <A>->__meta_clone();
      ##        NOTE: Or should we just use <A> and avoid the clone entirely?
      ##   [UD] error to provide default for by-value class types???
      ##   [SR] my <V> = defined(<A>) ? <A>->clone() : undef;
      ##   [SD] error to provide default for by-value class types???
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne 'C')
      ##------
      ## T=@#C  (pass-by-value const class type)
      ##   NOTE: Currently implemented @#C like @C, since @#C has little semantic utility
      ##------
      ## T=&C   (pass-by-reference class type  --> implemented as pointer verified to be non-undef)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne 'C')
      ##------
      ## T=&#C  (pass-by-reference const class type)
      ##   [UR] my <V> = <A>;
      ##   [UD] error to provide default for const ref class types
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne 'C')
      ##------
      ## T=*C   (pass-by-pointer class type  --> implemented as pointer verified to be non-undef)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne 'C')
      ##------
      ## T=*#C  (pass-by-pointer const class type)
      ##   [UR] my <V> = <A>;
      ##   [UD] ; if (!defined(<V>)) { <V> = <D>; }
      ##   [T1] (!defined(<V>)) || (ref(<V>) ne 'C')

      ## Note that classes are treated rather specially with respect
      ## to semantics, in that @A, &A and *A are all implemented as
      ## basic perl objects (although @A requires a clone). The only
      ## difference between &A and *A is that the former cannot be
      ## undef (and cannot accept a default) while the latter can be
      ## undef (and can accept a default).
      ## 
      ## Constness of class types will be supported via the
      ## 'PerlClassRefConst' tie class, but it is not yet
      ## implemented. It will assume a HASH-based object layout and
      ## will probably require an extra level of indirection to
      ## ensure that we do not rebless the underlying class object.

      $code[1] = $clsrefCheck;

      if ( $val ) {
        $code{SR} = 'my <V> = <A>->__meta_clone();';
        $code{SD} = undef;
      }
    }

    if ((!$code{SR})&&(defined($code{SR}))) { $code{SR} = $code{UR}; }
    if ((!$code{SD})&&(defined($code{SD}))) { $code{SD} = $code{UD}; }
    if ((!$code{XR})&&(defined($code{XR}))) { $code{XR} = $code{SR}; }
    if ((!$code{XD})&&(defined($code{XD}))) { $code{XD} = $code{SD}; }

    foreach my $k (keys(%code)) {
      my $v = $code{$k};
      if ( defined($v) ) {
        $code{$k} .= ' <T>' unless ($v =~ m/<T>/);
      }
    }

    ## In Perl, we don't really assign a type, but it is important
    ## that we do so when we create the NativeType instance, because
    ## the first argument is used as the key into the registry.
    ## Although there is probably a faked-up perl type that results
    ## in slightly fewer native type instances being created, we
    ## just use the canonical representation of $type as our
    ## key (note that we do NOT need to maintain multiple instances
    ## of NativeType for each variation of Type (we do for Type
    ## so that we can reproduce user code verbatim))
    ##
    ## arg1 is canonical meta-type
    ## arg2 is the complete native base-language type (we make one up in perl)
    ## arg3 is the native basetype (is it necessary to create this, or just validate it???)
    ## arg4 is myself
    ## arg5 is a map containing keys: code, prefix, access, element
    my $ndesc = "$perltype($acc$elem)"; 
    my $special = {
      vardecl => \%code,
      ref     => $perltype, 
      prefix  => $vpref,
      access  => $acc,
      element => $elem,
      'undef' => $undefok,
      tie     => $tie
    };
    ##printf("NAT: $natbasetype  D: %s\n", $natbasetype->inCanonicalForm());
    $result = Meta::Oopl::Lib::PerlType->new(
      $canonical, 
      $ndesc,
      $natbasetype, 
      $self,
      \@code,
      $special,
    );
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'nativeBaseTypeFor'
# META: Meta.Oopl.BaseLanguage.Perl.nativeBaseTypeFor(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Oopl.Lib.BaseType):*Meta.Oopl.Lib.BaseType
sub nativeBaseTypeFor {
  my $self = $_[0]; 
  my $basetype = $_[1]; 
  #----------------------------
  # META: start of user-code
  ## First, determine if we already have a base-language-specific
  ## BaseType for $basetype.  There are two ways this can happen:
  ##   1) $basetype itself is already base-language-specific (it
  ##      is an error if it is specific, but not to this base
  ##      language).
  ##   2) the generalized representation of $basetype is a key in
  ##      my 'basetypeRegistry' field
  ## 
  ## Note however that if 1) is true, then 2) will be too, so we
  ## only need to check 1) first if it is notably more efficient
  ## (which, considering the minimal amount of time the compiler
  ## spends in these methods, is highly unlikely).
  my $key    = $basetype->inCanonicalForm();
  my $result = $self->basetypeRegistry()->{$key};
  if ( ! $result ) {
    ####
    ## Establish some variables that will help us convert
    ## $metacore to Perl.
    my $metacore   = $basetype->core();
    my $importCore = $self->importMap()->{$metacore};
    ## Adjust $metacore if an import specification exists!
    if ( $importCore ) { 
      $metacore = $importCore;
    }

    my $nativeSpec = $self->nativeBases()->{$metacore};
    my $paramType  = $basetype->asParamType();
    my $simpleType = $basetype->asSimpleType();
    my $primType   = $basetype->asPrimitiveType();

    ####
    ## Now establish $core, the "inconsistent" Perl ref type
    my $core;
    if ( $nativeSpec ) {
      ## $metacore is a native type native type. The 'nativeBases'
      ## mapping provides meta-level native to base-language info,
      ## including the perl 'ref' type to use for 'T*' types
      ## (most of the native types don't have a type for 'T@').
      $core = $nativeSpec->{basenative};
      my $pargs = ( $paramType ) ? $paramType->params() : undef;
      ## FUTURE FIX: Ensure that the expected number of arguments
      ## specified in $nativeSpec matches the $pargs count and type!
    } else {
      ## If $metacore looks like 'Meta!', it is an error for it
      ## not to have a native spec.  FUTURE FIX: How do we report errors here??
      print(STDERR "ERROR: $metacore is not a legal native type (internal - fix how this error is reported!)\n") if ( $metacore =~ m/^Meta!/ );

      if ( $primType ) {
        ## All primitive types have perl ref ''. The exception to this
        ## (added late), are the varargs primitives.
        my $code = $primType->code();
        if ( $code == &Meta::Oopl::Lib::PrimitiveType::CodeMap()->{varargs} ) {
          my $bits = $primType->bits();
          $core = ( $bits == -2 ) ? 'HASH' : 'ARRAY';
        } else {
          $core = 'SCALAR';
        }
      } else {
        ## It is assumed that $metacore represents a class type. We
        ## set $core to $metacore and fix scoping operators below (the
        ## fix applies to other $core values too).
        $core = $metacore;
      }
    }

    ####
    ## Now ensure that we are using Perl scoping operators
    $core = $self->metaToNative($core);

    ####
    ## Now that we've converted $core to Perl, we create an instance
    ## of the appropriate subclass of BaseType.
    if ( $paramType ) {
      ## Must recursively convert parameters to native base types too!
      my @params = map { $_->asNativeType($self) } @{$paramType->params()};
      $result = Meta::Oopl::Lib::ParamType->new($key, $core, \@params, $self);
    } elsif ( $simpleType ) {
      ## The easiest BaseType to create - all we need is the core.
      $result = Meta::Oopl::Lib::SimpleType->new($key, $core,$self);
    } else {
      ## $basetype is a PrimitiveType.
      $result = Meta::Oopl::Lib::PrimitiveType->new($key, $core, $self);
    }

    ## Assertion
    if ( $result->baselang() != $self ) { die("ERROR: Expecting result->baselang to be self but it is not!"); } ## DEBUGONLY
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'compileCLASS'
# META: Meta.Oopl.BaseLanguage.Perl.compileCLASS(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Oopl.CLASS,*Meta.Schema.METASCHEMA):void
sub compileCLASS {
  my $self = $_[0]; 
  my $clazz = $_[1]; 
  my $schema = $_[2]; 
  #----------------------------
  # META: start of user-code
  ####
  ## Some initial variables
  my $name     = $clazz->id();
  my $options  = $schema->options();
  my $app      = $schema->metaApp();
  my $outdir   = $app->baseInstance()->safeNativePath( $app->tmpDir() );
  my $type     = $clazz->type();
  $schema->metaNote(sprintf("Compiling %s\n", $clazz->tid()),4);
  $schema->adjIndent(2);

  ####
  ## Since Perl does not provide its own pseudo-variable for
  ## receiver objects, we need to do it ourselves. The type of the
  ## receiver is always the same for every method within this class,
  ## so we create a single Type instance and use it. The same is
  ## true of class methods.
  my $fqn      = $clazz->fullyQualifiedName($schema);
  my $thisType = Meta::Oopl::Lib::Type::ForName("#*$fqn");
  my $metaType = Meta::Oopl::Lib::Type::ForName("\@Meta!Str"); ## FUTURE FIX: Should this be '#&Meta!Str'???
  my $thisVar  = Meta::Oopl::Lib::Vardecl->new('self', $thisType);
  my $metaVar  = Meta::Oopl::Lib::Vardecl->new('class', $metaType);
  $clazz->thisVarIs($thisVar);
  $clazz->metaVarIs($metaVar);

  ####
  ## Obtain the attributes
  my %string;
  my %list;
  my %block;
  foreach my $attr (qw(Position Visibility Presence PARENT NAMESPACE)) {
    my $attribute  = $clazz->safeAttr($schema, $attr);
    $string{$attr} = $attribute->valueAsString() if defined($attribute);
  }
  foreach my $attr (qw(IMPLEMENTS IMPORTS ASSOCIATIONS)) {
    my $attribute  = $clazz->safeAttr($schema, $attr);
    $list{$attr}   = $attribute->valueAsStringList() if defined($attribute);
  }
  foreach my $attr (qw(RUN TEST CLINIT FLAGS SCOPE)) {
    my $attribute  = $clazz->safeAttr($schema, $attr);
    $block{$attr}  = $attribute if defined($attribute);
  }

  ####
  ## The 'NAMESPACE' attribute allows us to fully qualify the name
  ## of this class. It is important in establishing the filename
  ## associated with this class. $outdir is modified by appending
  ## namespace to it (properly modified by replacing scoping
  ## separators with '/').
  ##   NOTE: This is "repeated" code relative to
  ##   Oopl::CLASS::fullyQualifiedName, but is more "efficient". Can
  ##   we merge them efficiently?  FIX THIS WMH!!!
  my $fullname;
  my $namespace = $string{NAMESPACE};
  if ( $namespace ) {
    my $namepath = $self->metaToNative($namespace);
    $fullname = "${namepath}::$name";
    $namepath =~ s%::%\/%g;
    $outdir .= "/$namepath";
    if ( ! -d $outdir ) { system("mkdir -p $outdir") && die("ERROR: Failed to mkdir -p $outdir - $!"); }
  } else {
    $fullname = $name;
  }

  ## if ( $fullname !~ m/::Tests::/ ) { die("ERROR: Currently only allowing new-style parsing on ::Tests:: classes!\n"); }

  ####
  ## The 'TEMPLATE<Perl.pm>' attribute stores a template description
  ## of what a class file looks like in Perl.  Various special strings
  ## will be replaced with instantiated strings computed based on
  ## all the other attributes of this CLASS construct.
  my $filemap = Meta::Compiler::FileMap->new( $clazz->file() );
  my $template = $clazz->nearestConstructAttribute($schema, 'CLASS', 'TEMPLATE<Perl.pm>');
  if ( ! $template ) {
    $schema->fileFatal($clazz->line(), sprintf("Failed to find a TEMPLATE<Perl.pm> attribute for %s", $clazz->tid()), 0);
  }
  my $ctmplLines = $template->valueAsStringList();
  my $outfile  = File::Spec->canonpath("$outdir/$name.pm");
  $filemap->addFile('pm', $outfile, $ctmplLines);
  $options->fileMapIs($filemap);

  ####
  ## The 'Position' attribute identifies whether this class can be
  ## subclassed, is a root class, or is internal. A 'root' class is
  ## one that inherits from the base-language root class (or
  ## Meta.Root if the base language does not have a root class) if
  ## no parent is specified. An 'internal' class inherits from
  ## Meta.Object if a parent is not specified. A 'leaf' class cannot
  ## be subclassed. - currently unused???

  ####
  ## The 'Visibility' attribute establishes whether this class is
  ## visible to all, or private.
  ##  - what exactly is the semantics of a private class in Java?
  ##  - can this be emulated in a base-language-neutral manner?

  ####
  ## The 'Presence' attribute establishes whether this class can
  ## be instantiated or not.
  ##  - this can be emulated in Perl by inserting a check on $class
  ##    in every initializer to ensure that it does NOT match the
  ##    name of this class.
  my $presence = $string{Presence};
  my $isAbstract = ( $presence eq 'abstract' ) ? 1 : 0;

  ####
  ## The 'PARENT' attribute specifies the parent of this class
  ## (should be changed to EXTENDS to avoid plurality issues).
  ##   - A class without an explicit parent is assigned one
  ##   - Should the default be placed in the Oopl.metaschema file?
  ##      - the default should be Meta::Object, and be changed
  ##        here if Position is 'root' (changed to Meta::Lib::Root).
  my $parent = $string{PARENT};
  if ( ! $parent ) {
    if ( $string{Position} eq 'root' ) {
      $parent = 'Meta::Lib::Root';
    } else {
      $parent = 'Meta::Lib::Object';
    }
  }
  my @parents = map { $self->metaToNative($_) } split(/[\s,]+/, $parent);
  my $parentdef = sprintf("\@ISA = qw(%s);\n%s", join(' ', @parents), join("\n", map { "use $_;" } @parents) );

  ####
  ## The 'IMPLEMENTS' attribute specifies a list of INTERFACE
  ## constructs that this class implements. Perl has duck-typing, so
  ## the only reason to emulate the concept of classes implementing
  ## INTERFACEs is to have the Meta-level Perl type-checking work
  ## properly.
  my $implements = $list{IMPLEMENTS};
  foreach my $interface (@$implements) {
    ## do what?
  }

  ####
  ## The 'IMPORTS' attribute specifies a list of namespaces and
  ## fully-qualified CLASS names. CLASSes listed here do not need
  ## to be fully qualified, and all CLASSes within namespaces in
  ## this list do not need to be fully qualified.
  ##  - providing shorthand notation for full CLASSes specified here
  ##    is relative easy, but namespaces require more work and
  ##    in general will probably break separate compilation.
  ##  - See the 'Perl::nativeBaseType' method, which supports
  ##    this by mapping simple class names to fully-qualified
  ##    names based on the 'importMap' field.  We need to add
  ##    to this map here (also keeping track of which keys added
  ##    were new), then delete the new keys from the map when 
  ##    we finish this method.
  my $imports = $list{IMPORTS};
  if ( $imports ) {
    foreach my $import (@$imports) {
      ## do what?
    }
  }

  ####
  ## The 'ASSOCIATIONS' attribute specifies a list of classes (and
  ## some special syntax) that are needed for the proper functioning
  ## of this class.  In some base languages, these classes must be
  ## specified syntactically, while in others the associations are
  ## only used conceptually (and in UML diagram generation).
  ## 
  ## FUTURE FIX: Must establish a way to include 
  ##    Meta::Oopl::BaseLanguage::PerlScalarRef (etc.)
  ## when needed without having to include it everywhere!
  ## This will probably involve having the CLASS do a pre-analysis
  ## of each construct within its SCOPE asking for the reference-related
  ## classes that are needed.  This will probably be generalizable
  ## to an "automatic" detection of associations in general - in Meta<C++>,
  ## shouldn't need to include "B" if it is used as an argument.
  my @assocs = qw(IO::File Carp Meta::Oopl::BaseLanguage::PerlRef);
  if ( $list{ASSOCIATIONS} ) {
    foreach my $assoc (@{$list{ASSOCIATIONS}}) {
      if ( $assoc !~ m/^[<\"]/ ) { $assoc =~ s/^[*@!]//; push(@assocs, $assoc); }
    }
  }
  my $includes = join("\n", map { s/\./::/g; s/^[*@!]//; "use $_;" } @assocs);

  ####
  ## Some initial instantiation work
  my $pm = $filemap->findFile('pm');
  $pm->modifyPre('name',      $fullname);
  $pm->modifyPre('includes',  $includes);
  $pm->modifyPre('parentdef', $parentdef);
  $pm->write();
  my $pmfp = $pm->fp();

  ####
  ## We start a special 'state' stream - it will be modified during
  ## the compilation of instance FIELD constructs found within SCOPE.
  my $ststr = "  \$_[0]->SUPER::__meta_initInstance();\n  \$_[0]->__meta_extend({";
  $filemap->addStr('state', "\n$ststr\n");
  ## 'staticState' is augmented during compilation of static FIELD constructs.
  $filemap->addStr('staticState', "\n");

  ####
  ## The 'SCOPE' attribute is obviously the most critical one during
  ## compilation. If its value is undef, it means that the class in
  ## question should not be created for the current base language.
  ## This attribute will ALWAYS be complex-block-typed.
  ## 
  ## We perform two passes over the SCOPE:
  ##   1) establish the set of explicitly defined METHOD constructs within the SCOPE
  ##   2) compile all constructs.
  ## We obtain the set of METHODs before compiling so that we can detect
  ## conflicts between explicitly specified METHOD definitions and implicitly
  ## provided definitions like FIELD accessors, etc.
  my $scope = $block{SCOPE};
  if ( $scope ) {
    ## First pass - find all methods of the same name
    ##  - will allow us to emulate method overloading
    ##    in perl!
    my %names;
    ##$scope->findNames($schema, \%names);

    ## Second pass
    foreach my $child ($scope->orderedConstructs()) {
      $child->compileMeta($schema);
    }
  } elsif ( ! $isAbstract ) {
    ## This class is presumably specific to a particular
    ## base-language (or at least doesn't apply to Perl).
    $schema->fileNote($clazz->line(), "CLASS $name is not being generated for Perl", 0);
    return;
  }

  #######################
  ## Create some METHOD instances and compile them into $clazz. Note
  ## that we do not add these METHOD instances to the scope, so as
  ## not to affect canonicalization, etc. However, each instance IS
  ## connected to its lexical parent ($clazz) so that config-chain
  ## searches during compilation will work.
  ##
  ## Methods created:
  ##   __meta_main         --> class-specific entry point
  ##   __meta_validate     --> unit-testing
  ##   __meta_initInstance --> instance field initialization routine
  ##   __meta_initStatic   --> static field initialization routine
  ##
  ## FUTURE FIX: Currently, the methods generated do NOT have the
  ## above names - must be fixed!!!  They currently are:
  ##   __Meta_main
  ##   __Meta_validate
  ##   __Meta_initState
  ##   (no __meta_initStatic)

  ####
  ## The RUN attribute corresponds to the creation of a __Meta_main
  ## method. The method is always created with a SCOPE<*> attribute.
  ## This is because it is easier to provide support for both simple
  ## and complex RUN blocks using a complex method scope than using
  ## a simple method scope (which would require support for mixed
  ## blocks).
  ## 
  ## Within the SCOPE<*> complex block, prolog and epilog code is
  ## inserted before and after the user-provided code specified in
  ## the RUN attribute, and this is done by creating 'Block'
  ## constructs with 'SCOPE<Perl>' attributes.
  my $id = $clazz->id();

  ## The prolog turns on unit testing if it was requested
  ##   - redirect stdout and stderr
  my $prolog     = $schema->initializedConstructInstance(undef, 'Block', {
    'SCOPE<Perl>' => <<"EOF"
  # Main method unit-testing prolog
  if ( \$validate ) {
    print(STDERR "NOTE: Executing unit test for '$id' (stdout and stderr redirected)\\n");
    close(STDOUT); open(STDOUT, ">$id.out");
    close(STDERR); open(STDERR, ">$id.err");
  } 
EOF
  });

  ## The RUN attribute becomes a SCOPE attribute within the main
  ## method. If RUN is complex, we use SCOPE<*>, otherwise
  ## SCOPE<Perl>.
  my $mainScope;
  my $run = $block{RUN};
  if ( $run ) {
    ## We could just clone $run, but that performs a deeper copy
    ## than we strictly need, so we optimize slightly.
    if ( $run->asComplexBlock() ) {
      $mainScope = $schema->newComplexBlock('SCOPE<*>',$run->value());
    } else {
      $mainScope = $schema->newSimpleBlockFromList('SCOPE<Perl>',$run->value()); 
    }
    ## my $complexRun = $run->asComplexBlock();
    ## if ( $complexRun ) {
    ##   @mainConstructs = @{$complexRun->value()};
    ## } else {
    ##   my $lines = $run->valueAsStringList();
    ##   my $body = $schema->initializedConstructInstance(undef, 'Block', {
    ##     'SCOPE<Perl>' => '',
    ##   });
    ##   my $scope = $body->rawAttr($schema, 'SCOPE<Perl>');
    ##   $scope->valueIs($lines);
    ##   $scope->lineIs( $run->line() );
    ##   push(@mainConstructs, $body);
    ## }
  } else {
    ## No RUN block was provided - insert a basic comment
    $mainScope = $schema->newSimpleBlock('SCOPE<Perl>', "    # Main method core\n    print(\"No RUN attribute was specified for $type $id\\n\");");
    ## my $body = $schema->initializedConstructInstance(undef, 'Block', {
    ##   'SCOPE<Perl>' => "    # Main method core\n    print(\"No RUN attribute was specified for $type $id\\n\");"
    ## });
    ## printf("No RUN block - SCOPE line is %d\n", $body->rawAttr($schema, 'SCOPE<Perl>')->line());
    ## push(@mainConstructs, $body);
  }

  ## The epilog turns off unit testing if it was turned on
  ##   - return redirect stdout and stderr to their original locations
  my $epilog = $schema->initializedConstructInstance(undef, 'Block', {
    'SCOPE<Perl>' => <<"EOF",
  # Main method unit-testing epilog
  if ( \$validate ) {
    my \$tty = \`tty\`; chomp(\$tty);
    close(STDOUT); open(STDOUT, ">\$tty");
    close(STDERR); open(STDERR, ">\$tty");
    my \$errors = &__meta_validate(\$validate);
    if ( ( -s '$id.out' ) && ( \$verbose > 1 ) ) { print(\"\\nSTDOUT\\n======\\n\"); system(\"cat $id.out\"); } unlink('$id.out') unless ( \$verbose > 2);
    if ( ( -s '$id.err' ) && ( \$verbose > 1 ) ) { print(\"\\nSTDERR\\n======\\n\"); system(\"cat $id.err\"); } unlink('$id.err') unless ( \$verbose > 2);
  } 
EOF
  });

  ## The main method always has the same signature.
  my $mainMethod = $schema->initializedConstructInstance($clazz, 'METHOD', {
    Visibility    => 'public',
    Level         => 'static',
    METHOD        => '__meta_main',
    PARAMS        => 'Meta!Str@ exec, Meta!Vec<Meta!Str@>* args, boolean@ validate, int@ verbose',
    RETURNS       => 'void',
  }, undef, [qw(Visibility Level METHOD PARAMS RETURNS)]);
  $mainMethod->addAttribute($mainScope);
  $mainMethod->locationIs( $run ? $run->line() : 0 );
  $mainMethod->prologIs($prolog);
  $mainMethod->epilogIs($epilog);
  $mainMethod->compileMeta($schema);

  ####
  ## The TEST attribute of CLASS corresponds to the creation of
  ## a special __Meta_validate method.
  ## 
  ## Meta_validate() exists for every class for every base language.
  ##  - it is a public static void method that takes no arguments.
  ##  - is responsible for comparing the output of Meta_main()
  ##    against canonical representations.
  ##  - The TEST attribute is a complex block containing OUTPUT
  ##    constructs, which in turn have a PATH and a SCOPE or EXTERNAL.
  ##    The PATH specifies the path to a file that is expected
  ##    to exists, and SCOPE represents the text that that file
  ##    should match against, exactly.  EXTERNAL is the path to
  ##    an external file that represents the text to match
  ##    against exactly.  Additional mechanisms
  ##    besides identical-match will be added later.
  ##  - If the TEST attribute is provided for a CLASS, it
  ##    is assumed that the OUTPUT constructs apply to the
  ##    output generated by RUN, with the special caveat that
  ##    standard output is in $class.out and standard error
  ##    is in $class.err (where $class is the name of the class).
  ##  - The Meta_validate() method contains code to dynamically
  ##    create validation files, compare them against generated
  ##    files, report differences, etc.
  ##  - Note that EXTERNAL is more convenient in some ways because
  ##    if validation fails, it is often because the input files
  ##    have grown (rather than due to errors), in which case
  ##    the validation text must be updated.  If this text is
  ##    in an external file, the new text can be automatically
  ##    copied, whereas if the validation text is embedded within
  ##    a .meta file it is more difficult to update this information
  ##    (although once canonicalization is robust this too will
  ##    be relatively easy).
  my @metaval;
  push(@metaval, "  my \$errors = 0;\n");
  my $test = $block{TEST};
  if ( $test ) { 
    foreach my $testc ($test->orderedConstructs()) {
      my $path  = $testc->safeAttr($schema, 'PATH')->valueAsString(); $path =~ s/\'/\\'/g;
      my $ext   = $testc->safeAttr($schema, 'EXTERNAL')->valueAsString() || "$path.valid";  $ext  =~ s/\'/\\'/g;
      push(@metaval, "  ++\$errors if &Meta::Lib::Root::__Meta_compare('$path', '$ext', { verbose => \$verbose } );\n");
    }
  } else {
    push(@metaval, "  print(\"NOTE:    No unit testing provided for $type $id\\n\");\n");
  }
  push(@metaval, "  return \$errors;\n");
  my $metaval = join('', @metaval);

  my $validateMethod = $schema->initializedConstructInstance($clazz, 'METHOD', {
    Visibility    => 'private',
    Level         => 'static',
    METHOD        => '__meta_validate',
    PARAMS        => 'int@ verbose',
    RETURNS       => 'int@',
    'SCOPE<Perl>' => $metaval,
  }, undef, [qw(Visibility Level METHOD PARAMS RETURNS SCOPE<Perl>)]);
  ## Should be impossible to cause errors in this code
  $validateMethod->locationIs(0);
  $validateMethod->compileMeta($schema);

  ####
  ## __meta_initInstance
  ## 
  ##   This method is responsible for initializing instance state to
  ##   default values, and is always invoked during the constructor
  ##   invocation process.
  ## 
  ##   FUTURE FIX: Should find a way to make this more efficient!
  ##   Rather than having a separate method that is invoked in each
  ##   constructor, can we instead analyze the code provided in the
  ##   constructors and insert appropriate field initialization code
  ##   in cases where the field in question isn't explicitly
  ##   initialized in the constructor? How does this interact with
  ##   MANDATE and REQUIRES?
  ## 
  ##   FUTURE FIX: This check against 'Meta::Lib::Root' is a
  ##   terrible hack - can we do something cleaner? FIX THIS WMH!!!
  if ( $fullname ne 'Meta::Lib::Root' ) {
    ## The 'state' string has been populated with field
    ## default initialization code.
    $filemap->appendStr('state', "  });\n");

    ## Now create a METHOD to represent the default init. code.
    my $initInstanceMethod = $schema->initializedConstructInstance($clazz, 'METHOD', {
      Visibility    => 'private',
      Level         => 'instance',
      METHOD        => '__meta_initInstance',
      PARAMS        => 'int@ verbose',
      RETURNS       => 'int@',
      'SCOPE<Perl>' => $filemap->findStr('state'),
    }, undef, [qw(Visibility Level METHOD PARAMS RETURNS SCOPE<Perl>)]);
    ## Should be impossible to cause errors in this code
    $initInstanceMethod->locationIs(0);
    $initInstanceMethod->compileMeta($schema);
  }

  ####
  ## __meta_initStatic:
  ## 
  ##   This method is responsible for initializing static variables
  ##   associated with the class, and is always guaranteed to be
  ##   invoked when the class is first loaded.
  ##
  ##   The method has two parts:
  ##    - in the first part, DEFAULT attributes associated with
  ##      static FIELD constructs are used to initialize the
  ##      relevant fields.  This code is always base-language-specific.
  ##
  ##    - in the second part, the lines making up the CLINIT block
  ##      are added. CLINIT<*> specifies meta-statements, while
  ##      CLINIT<L> provides base-language specific code.
  my $sa = 'Perl';
  my $staticStrAttrs = {
    Visibility    => 'private',
    Level         => 'static',
    METHOD        => '__meta_initStatic',
    PARAMS        => '',
    RETURNS       => 'void',
  };
  my $staticBlockAttrs = undef;
  my @staticOrder = qw(Visibility Level METHOD PARAMS RETURNS);
  my $staticScope = $filemap->findStr('staticState');
  if ( $block{CLINIT} ) {
   ### CLINIT isn't required, but we generate a __meta_initStatic
   ### METHOD whether or not CLINIT is provided.
    if ( $block{CLINIT}->asComplexBlock() ) {
     ### We have a CLINIT<*> - must compile the statements. This is
     ### probably best done by having the METHOD being created have a
     ### complex SCOPE<*>, and adding the part1 field initialization
     ### code as a Block SCOPE<Perl>.
      $sa = '*';
      $schema->metaError("Not yet able to handle CLINIT<*>",0);
     ### $staticBlockAttrs->{'SCOPE<*>'} = ???;
    } else {
     ### We have a Perl specific CLINIT block that can be appended
     ### to the part1 initialization code.
      push(@staticOrder, 'SCOPE<Perl>');
      $staticScope = $filemap->findStr('staticState');
      my $tmp = $block{CLINIT}->valueAsString('  ');
      $staticScope .= $tmp;
      ## DEBUG: $staticScope .= "  print(STDERR \"NOTE: Invoked ${fqn}::__meta_initStatic\\n\");\n";
      $staticStrAttrs->{'SCOPE<Perl>'} = $staticScope;
    }
  } else {
    $staticStrAttrs->{'SCOPE<Perl>'} = $filemap->findStr('staticState');
    push(@staticOrder, 'SCOPE<Perl>');
  }
  my $initStaticMethodMethod = $schema->initializedConstructInstance
  ($clazz, 'METHOD', $staticStrAttrs, $staticBlockAttrs, 
  [@staticOrder]);
  #### Should be impossible to cause errors in this code
  $initStaticMethodMethod->locationIs(0);
  $initStaticMethodMethod->compileMeta($schema);
  print($pmfp "\n&__meta_initStatic();\n");

  ####
  ## Temporary hacks
  ##   - once the old-style compilation is gone, we can remove these.
  ##   - fix 'metaperl' - calls '__meta_main', and '__meta_validate'.
  print($pmfp "\n\nsub __Meta_main { &__meta_main(\@_); }\n");
  ## end temporary

  ####
  ## Write all streams to the '.pm' file
  $pm->doneBody();
  $pm->write();
  $pm->done();
  $schema->metaNote("Wrote $outfile",3);

  ####
  ## Record the existence of the base-language file
  $options->recordBaseFile($outfile);

  ####
  ## Now create the meta-classes
  ##   NOTE: In Perl, we may not even want to generate level-2 meta-classes, but
  ##     for now we allow it.
  ##   NOTE: Must update this code to new interface (no Env anymore, thank goodness!)
  ## 
  ## if ( $vars{genmop} ) {
  ##   my (@c) = $self->generateMop($env, $filemap, $options, \%vars);
  ##   foreach my $c (@c) {
  ##     $c->compilePerl($env, undef, $options);
  ##   }
  ## }

  $schema->adjIndent(-2);
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'compileMETHOD'
# META: Meta.Oopl.BaseLanguage.Perl.compileMETHOD(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Oopl.METHOD,*Meta.Schema.METASCHEMA):void
sub compileMETHOD {
  my $self = $_[0]; 
  my $method = $_[1]; 
  my $schema = $_[2]; 
  #----------------------------
  # META: start of user-code
  my $options = $schema->options();
  $schema->metaNote(sprintf("PERL %s\n", $method->tid()),4);
  $schema->adjIndent(2);

  my $clazz = $method->findClassLikeScope();
  if ( $clazz ) {
    ####
    ## NOTE: In the past, the TEMPLATE parameter of CONSTRUCT METHOD
    ## was used to establish a user-controllable template for the
    ## method.  This has been removed, since the only customization
    ## that is really desirable is the syntax of method documentation,
    ## which can be specified in some alternative manner.

    my $scopedent = $options->scopeIndent();
    my $indent    = ' ' x $scopedent;
    my $subindent = ' ' x ($scopedent+2);

    ####
    ## Obtain the attributes
    my %string;
    my %list;
    my %block;
    foreach my $attr (qw(Coverage Presence Visibility Level Nature Mutability Dispatch Inheritance THROWS DELEGATE)) {
      my $attribute  = $method->safeAttr($schema, $attr);
      $string{$attr} = $attribute->valueAsString() if defined($attribute);
    }
    foreach my $attr (qw(REQUIRES)) {
      my $attribute  = $method->safeAttr($schema, $attr);
      $list{$attr}   = $attribute->valueAsStringList() if defined($attribute);
    }
    foreach my $attr (qw(PRE POST SCOPE)) {
      my $attribute  = $method->safeAttr($schema, $attr);
      $block{$attr}  = $attribute if defined($attribute);
    }

    ####
    ## Some variables initialized below
    ##  - prolog is sequence of Perl statements placed before user-code
    ##  - body is the sequence of Perl statements making up the user-code
    ##    for this method.
    ##  - epilog is sequence of Perl statements placed after user-code
    ##    (implies there can only be one 'return' statement, and it
    ##    must appear at the end of the method).
    my @prolog;
    my @body;
    my @epilog;

    #######################
    ## FEATURE ATTRIBUTES
    #######################

    ####
    ## Coverage has values 'limited' and 'general', and dictates
    ## whether this method applies to all base languages, or only to a
    ## limited subset. If compiling a method into base language L, the
    ## method is not abstract, and no SCOPE block is found, it is a
    ## warning unless Coverage is 'limited'. Individuals should need
    ## to explicitly indicate that they don't want specialized
    ## methods.

    ####
    ## Presence has values 'abstract' and 'concrete', and dictates
    ## whether this method requires a SCOPE (concrete) or disallows
    ## a SCOPE (abstract). Related to this is the problem of how to
    ## declare an abstract METHOD with Coverage limited (no SCOPE
    ## means we need to find another way to identify which base
    ## languagees to compile into. Maybe using PARAMS?
    my $isAbstract = ($string{Presence} eq 'abstract') ? 1 : 0;

    ####
    ## Visibility dicates whether this method can be seen by all other
    ## classes (public), subclasses (protected), or only itself
    ## (private).
    ## 
    ##  - perl has no concept of visibility restriction
    ## 
    ##  - perl provides access to the entire call stack at runtime,
    ##    so we can perform a runtime check to ensure that $self
    ##    'isa' class (protected) or 'eq' class (private).
    if ( $string{Visibility} eq 'protected' ) {
      ## Add typechecking code to @prolog
    } elsif ( $string{Visibility} eq 'private' ) {
      ## Add typechecking code to @prolog
    }

    ####
    ## Level establishes whether the method is instance, static or
    ## meta. Instance methods have an object receiver, static
    ## methods have no receiver (but require scoping), and meta
    ## methods have class receivers (and are in general placed in
    ## the meta-class for a given class, not the class itself).
    ## However, in Perl, which can partially support all three types
    ## directly, we could conceivable provide all three within the
    ## class itself.
    ## 
    ##  - only problem is that we would need to specify that class
    ##    level (meta level) fields and methods are in the same
    ##    namespace as instance and static fields (which isn't
    ##    strictly necessary in Smalltalk or languages that use
    ##    meta-classes).
    my $isStatic = ( $string{Level} eq 'static' ) ? 1 : 0;
    my $isMeta   = ( $string{Level} eq 'meta'   ) ? 1 : 0;

    ####
    ## Nature establishes inlining
    ##  - perl has no inlining support, so it will need to be
    ##    done at Meta-level if it is done at all.
    my $isInline  = ( $string{Nature} eq 'inline' ) ? 1 : 0;

    ####
    ## Mutability establishes whether this method is allowed to
    ## modify its receiver space or not.
    ##  - not sure if we will continue to support both 'immutable'
    ##    and 'const', or just 'const'.
    my $isConst   = ( $string{Mutability} eq 'mutable' ) ? 0 : 1;

    ####
    ## Dispatch establishes virtualness.
    my $isNonVirtual = ( $string{Dispatch} eq 'nonvirtual' ) ? 1 : 0;
    my $isVirtual    = ( $string{Dispatch} eq 'virtual' ) ? 1 : 0;

    #######################################
    ## Synergism between Feature Attributes
    if ( ( $isVirtual ) && ( $isStatic ) ) {
      ## May want to add some sugar here:
      ##  - suppose the default Dispatch is 'virtual'
      ##  - normally, this will force all 'static' METHODs
      ##    to explicitly be 'nonvirtual'
      ##  - may want to be "smart", and assume that if
      ##    'static' is explict but 'virtual' is implicit,
      ##    that we implicitly establish nonvirtual status
      ##    (with or without a warning to that effect).
      $method->newError("virtual and static are incompatible for METHOD",0,0,$schema);
    }

    #######################
    ## SECONDARY ATTRIBUTES
    #######################

    ####
    ## PARAMS provides the list of parameters. It is a
    ## ParamListAttribute containing an array of Vardecl instances.
    ##  - Perl has no type-checking, but Meta provides run-time
    ##    emulation of type-checking based on Vardecl and Type
    ##    instances.
    ##  - Perl does not provide a pseudo-variable for the
    ##    receiver - it is explicitly provided by the
    ##    method definer.  Meta<Perl> provides the
    ##    variable $self, which always has the same type
    ##    (and has been stored in $clazz->thisType()).
    my $paramsig;
    my $paramdesc;
    my @typecheck;
    my $params      = $method->safeAttr($schema, 'PARAMS');
    my $checklevel  = $options->typecheck();
    my $safetylevel = $options->safety();
    if ( $params ) {
      $params  = $params->asParamList();
      my @params = @{$params->value()};

      ## Add $self to 'instance' methods, $class to 'class' methods.
      if ( $isMeta ) {
        unshift(@params, $clazz->metaVar());
      } elsif ( $isStatic ) {
      } else {
        unshift(@params, $clazz->thisVar());
      }

      ## Obtain typechecking code for each parameter
      my @types;
      my @vars;
      foreach my $i (0..$#params) {
        my $var     = $params[$i];
        my $type    = $var->type();
        my $cantype = $type->inCanonicalForm();
        push(@types, $cantype);
        push(@vars,  $var->var() . ":$cantype");
        ##printf("Var %s : %s\n", $var->var(), $var->type()->desc());
        my $perltype = $type->asNativeType($self);
        my $check = $perltype->instantiate($safetylevel, $checklevel, $subindent, $i, $var->var(), $var->valptr());
        push(@typecheck, $check);
      }
      $paramdesc = join(',',@vars);
      $paramsig  = join(',',@types);
    } else {
      ## An error should already have been generated by safeAttr???
      ## But how to write this code in a manner that will work even
      ## if the schema file changes PARAMS to not be <required>?
      ## Maybe '<required>' should be removed from the eligible set
      ## of values to appear in DEFAULT???
      $method->newError("Failed to find PARAMS for METHOD",0,0,$schema);
    }

    ####
    ## RETURNS is a Type instance
    ##  - in Perl, we are currently not doing anything
    ##    to typecheck returns, although if we enforced
    ##    single-return-at-end-of-method (which we will
    ##    probably need to), we could insert runtime
    ##    typechecking code to verify the result being
    ##    returned is accurate.
    my $retdesc = '?';
    my $return = $method->safeAttr($schema, 'RETURNS');
    if ( defined($return) ) {
      $return = $return->asType();
      if ( $return ) {
        ##my $type = $return->value()->newtype();
        my $type = $return->value();
        if ( $type ) {
          ## old-style code not creating return type instances for
          ## primitive values (I think). can probably remove the
          ## conditional when code is fully moved to new version.
          $retdesc = $type->inCanonicalForm();
        }
      } else {
        print(STDERR "WARN: Return type isn't a TypeAttribute!\n");
      }
    } else {
      ## Returns not really needed in Perl.  Furthermore, it is
      ## not usually marked as <required> because special variants
      ## (initializers, finalizers, etc.) may not have a return type.
      ## This may be changed in the future though.  For now, we generate
      ## a warning.
      my $line = $method->line();
      $method->newWarning("Expecting a return type (line $line?)",0);
    }

    ####
    ## THROWS is a list of xids representing classes
    ## potentially throw by this method.
    ##  - in Perl, try/catch semantics is very weak to begin
    ##    with (emulated via 'die' commands).
    ##  - currently not doing anything with this list in Perl

    ####
    ## REQUIRES is a list of RESOURCE ids this METHOD needs
    ##  - Not currently processed in Perl

    ####
    ## PRE is a collection of boolean tests to insert before
    ## the user-provided main body
    ##  - FIX THIS WMH!!!

    ####
    ## POST is a collection of boolean tests to insert after
    ## the user-provided main body.
    ##  - FIX THIS WMH!!!

    ####
    ## DELEGATE is the name of a FIELD within the CLASS
    ## containing the METHOD to delegate to.  A scope is not
    ## needed (and should not currently be supplied) if this
    ## attribute exists.
    my $isDelegate = defined($string{DELEGATE}) ? 1 : 0;

    ####
    ## Establish some useful information
    ##   name         --> base name of method
    ##   comment      --> string used to prefix one-line comments
    ##   implicit     --> the construct this METHOD is really implementing (undef normally)
    ##   realtype     --> the type of construct really being implemented
    ##   fqname       --> fully qualified name of method
    ##   cname        --> base name of class containing method
    ##   fqcname      --> fully qualified class name
    ##   tmpldefn     --> the base-language-specific template definition  (i.e. <typename KEY, typename VALUE>)
    ##   tmpldecl     --> the base-language-specific template declaration (i.e. <KEY,VALUE>)
    ##   indent       --> indentation that every output line should have (additional indentation added explicitly)
    my $name     = $method->id();  ## Change to primary-based safeAttr request?
    my $comment  = $self->commentLinePrefix();
    my $implicit = $method->implicit();
    my $realtype = $implicit ? $implicit->type() : $method->type();
    my $isField  = ($realtype eq 'FIELD') ? 1 : 0;

    ## FROM INVOKABLE.computeInvokableSubs
    ##   old template  is new $templdefn
    ##   old tmp       is new $tmpldecl
    ##   old cname     is new $cname . $tmpldecl
    ##   old rawcname  is new $cname
    ##   old fqcname   is new $fqcname . $tmpldecl

    ##my $cname        = $clazz->id();
    my $fqmetaname   = $clazz->fullyQualifiedName($schema, \$name);

    ##my $fqmetacname  = $clazz->fullyQualifiedName($schema);
    ##my $fqname       = $self->metaToNative($fqmetaname);
    ##my $fqcname      = $self->metaToNative($fqmetacname);

    my $templateAttr = $clazz->safeAttr($schema, 'TEMPLATE');
    my ($tmpldecl,$tmpldefn);
    if ( $templateAttr ) {
      ## The template will look something like this:
      ##    "typename KEY, typename ITEM"
      ## Exactly what is legal in place of 'typename' needs to be
      ## established. In any event, we need two strings based on the
      ## above:
      ##    "template<typename KEY, typename ITEM>"
      ## and
      ##    "<KEY,ITEM>"
      $tmpldefn = $templateAttr->valueAsString();
      $tmpldecl = "<$tmpldefn>";
      $tmpldecl =~ s/\s*(typename|class)\s+//g;
    }

    my $file      = $method->myFile();
    my $line      = $method->line();
    my $scopeLine = 0;

    ####
    ## The SCOPE or DELEGATE of a METHOD
    ##  - SCOPE is often of type 'simple' (block), but with the advent
    ##    of statement-level constructs and Meta(Oopl)*, it will
    ##    become more and more common to see complex-valued SCOPE
    ##    attributes in METHOD constructs.
    ##  - no SCOPE needed or permitted if $isAbstract or $isDelegate.
    ##  - required otherwise (not able to specify this in ATTRIBUTE
    ##    spec because of the conditional situations above where it
    ##    isn't required).
    my $scope = $block{SCOPE};

    my @lines;
    my $write = 1;
    if ( ! $isField ) {
      ## We have a "real" method. First, establish its signature(s)
      ## and insert a special variable at the front of @typecheck if
      ## the checklevel can possibly produce errors (since all
      ## errors assume the existence of a '__meta_sig' variable).
      my $signature   = "$fqmetaname($paramsig):$retdesc";
      my $declaration = "$fqmetaname($paramdesc):$retdesc";
      if ( $checklevel > 0 ) {
        unshift(@typecheck, "${subindent}my \$__meta_sig = \"\Q$declaration\E\";");
      }

      ## non-field methods are separated from preceeding text by an
      ## empty line, and start with two comments, one describing
      ## the method in human readable terms, and one representing
      ## the mangled descriptor, for use in error generation.
      push(@lines, ''); 
      push(@lines, $comment . ('#'x30));
      push(@lines, "$comment $string{Level} $realtype '$name'");
      push(@lines, "$comment META: $signature");
      ## push(@lines, "$comment line $line \"$file\""); /# TEMPORARY
      push(@lines, "sub $name \{");
      if ( $isAbstract ) {
        ####
        ## We insert code that generate a run-time error when this
        ## method is invoked - subclasses should redefine it.
        if ( $scope ) {
          $method->newWarning("abstract METHODs should not have a SCOPE attribute (it is being ignored)",0);
        }
        push(@lines, "  CORE::warn(\"SubclassResponsibility - \Q$declaration\E is abstract and should be redefined in children\");");

      } elsif ( $isDelegate ) {
        ####
        ## Delegated methods involve invoking exactly the same
        ## method, with exactly the same arguments, on a field of
        ## myself.
        if ( $scope ) {
          $method->newWarning("The DELEGATE attribute defines a SCOPE, so the one provided is ignored",0);
        }
        my $del = $string{DELEGATE};
        push(@lines, "  shift->$del()->$name(\@_);");

      } elsif ( ! $scope ) {
        ####
        ## If a particular method does not have a SCOPE, and is not
        ## abstract or delegate, then no code is generated.
        ## 
        ## FUTURE FIX: We need to add a feature attribute and check
        ## that it is a particular value in this situation (otherwise
        ## we should report a warning that the method is not being
        ## generated for the base language in question).
        $write = 0;

      } else {
        ####
        ## Record the @lines array with $options so that subsequent
        ## method invocations will know where to write output.
        $options->scopeIs(\@lines);

        ####
        ## Add typechecking prolog
        push(@lines, @typecheck);

        ####
        ## Deal with the prolog (as dicated by METHOD attributes,
        ## which differs from the meta-prolog only in who causes
        ## it).
        push(@lines, @prolog);

        ####
        ## Add any meta-prolog (another construct using METHOD as an
        ## implementation device may need to insert code before
        ## user-provided code).
        my $prolog = $method->prolog();
        if ( $prolog ) {
          ##push(@lines, "  # Method Prolog");
          push(@lines, '');
          $prolog->withinIs($method);
          $prolog->compileMeta($schema);
        }

        ####
        ## Deal with the user-provided body
        if ( $scope ) {
          push(@lines, "$subindent$comment" . ('-'x28));
          push(@lines, "$subindent$comment META: start of user-code");
          $scope->compileMeta($schema);
          push(@lines, "$subindent$comment META: end of user-code");
          push(@lines, "$subindent$comment" . ('-'x28));
        } else {
          printf(STDERR "ERROR: undef scope!\n");
        }

        ####
        ## Add any meta-epilog (another construct using METHOD as an
        ## implementation device may need to insert code after
        ## user-provided code).
        my $epilog = $method->epilog();
        if ( $epilog ) {
          ##push(@lines, "  # Method Epilog");
          $epilog->withinIs($method);
          $epilog->compileMeta($schema);
        }

        ####
        ## Deal with the epilog (as dicated by METHOD attributes,
        ## which differs from the meta-epilog only in who causes
        ## it).
        push(@lines, @epilog);
      } 

      ## End the method
      push(@lines, "}");

      ## We record the line(s) within the .meta source file
      ## associated with this method in the meta .map file.
      ##   - $line reprsents the line within the .meta file
      ##     at which this METHOD begins (primary attribute line, or
      ##     start of features??)
      ##   - $scopeLine represents the line within the .meta
      ##     file at which the SCOPE block begins.
      ##
      ## If $line is 0, the current METHOD is auto-generated (and is
      ## assumed to be error free, do we do not need to record info
      ## for it).  If the .map files end up being used for more than
      ## just error redirection (i.e. provide list of methods, we may
      ## want to "reallow" auto-generated entries in the .map file.
      if ( $line > 0 ) {
        $scopeLine = ( $scope ) ? ($scope->{_line}||$line) : 0;
        my $outfp = $schema->outfp();
        printf($outfp "%6d %6d %s\n", $line, $scopeLine, $signature);
      }

    } else {
      ## Field methods are treated specially
      ##   - no typechecking
      ##   - no individual METALINE specs or comments
      ##   - sub definition and body all on one line.
      my $bodyarr = $scope->valueAsStringList();
      my $body = join('', @$bodyarr); ## should always be one line
      push(@lines, "sub $name { $body }");
    }

    ####
    ## Write the method body to file
    if ( $write ) {
      my $fp = $options->fileMap()->findFile('pm')->fp();
      print($fp join("\n", '', @lines), '');
    } else {
      $method->newNote("Not writing $fqmetaname - no Perl scope",0);
    }

  } else {
    $method->newError("Failed to find a class-like lexical parent for " . $method->tid(), 0, 0, $schema);
  }

  $schema->adjIndent(-2);
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'compileINITIALIZER'
# META: Meta.Oopl.BaseLanguage.Perl.compileINITIALIZER(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Oopl.INITIALIZER,*Meta.Schema.METASCHEMA):void
sub compileINITIALIZER {
  my $self = $_[0]; 
  my $initializer = $_[1]; 
  my $schema = $_[2]; 
  #----------------------------
  # META: start of user-code
  my $method = $self->methodForInitializer($initializer, $schema);
  if ( $method ) {
    ####
    ## In perl, for now, the INITIALIZER is implemented via a static
    ## 'new' method that returns a new instance. If $id is assigned,
    ## we change it to 'new', otherwise we keep the same name as
    ## provided in the primary INITIALIZER.
    ## 
    ## THis code is temporary
    my $id = $initializer->id();
    if ( &Meta::Schema::METASCHEMA::IsAssignedValue($id) ) {
      $id = 'new';
    }
    my $pattr = $schema->newId('METHOD',$id);
    $method->setPrimaryAttribute($pattr);
    ## End temporary

    ####
    ## A prolog is used to enforce post-extend semantics (calling
    ## of parent constructors). The prolog also deals with PREINIT
    ## (or does it???)
    my $PARGS = $initializer->safeAttr($schema, 'PARGS');
    my $args = '';
    if ( $PARGS ) {
      my $PARAMS = $initializer->safeAttr($schema, 'PARAMS');
      my $params = $PARGS->valueAsString();
      $args = $self->metaBasicListToBase($params);
      ## FUTURE FIX: Using 'metaBasicListToBase' as-is fails to deal
      ## with varargs in PARGS (a very common idiom in my Perl
      ## code). This code is rather dirty, and must be cleaned up
      ## (and extended to handle array-based varargs too).
      my $valarr = $PARAMS->value();
      my $lastarg = $valarr->[-1];
      if ( $lastarg->type() == &Meta::Oopl::Lib::Type::MapVarArgs() ) {
        my $v = $lastarg->var();
        $args =~ s/\$$v/\%$v/;
      }
    }
    my $prolog     = $schema->initializedConstructInstance(undef, 'Block', {
      Wrapping      => 'unwrapped',
      'SCOPE<Perl>' => "  my \$self = \$class->SUPER::new($args);\n",
    });
    $method->prologIs($prolog);

    ####
    ## An epilog is used to perform the return of $self. FUTURE FIX: If
    ## we switch over to the new/operator_new/constructor emulation
    ## in Perl, this epilog will no longer be needed, as the 'new'
    ## method will allocate (via 'operator_new'), initialize (via
    ## invocation of a "constructor"), and return. The INITIALIZER
    ## would just be implementing the "constructor" method.
    my $epilog = $schema->initializedConstructInstance(undef, 'Block', {
      Wrapping      => 'unwrapped',
      'SCOPE<Perl>' => "  return \$self;",
    });
    $method->epilogIs($epilog);

    $method->compileMeta($schema);
  } else {
    $initializer->newError("Could not implement INIITALIZER as METHOD", 0, 0, $schema);
  }
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'compileFIELD'
# META: Meta.Oopl.BaseLanguage.Perl.compileFIELD(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Oopl.FIELD,*Meta.Schema.METASCHEMA):void
sub compileFIELD {
  my $self = $_[0]; 
  my $field = $_[1]; 
  my $schema = $_[2]; 
  #----------------------------
  # META: start of user-code
  my $options = $schema->options();
  $schema->metaNote(sprintf("PERL %s\n", $field->tid()),4);
  $schema->adjIndent(2);

  my $clazz = $field->findClassLikeScope();
  if ( $clazz ) {
    my $scopedent = $options->scopeIndent();
    my $indent    = ' ' x $scopedent;
    my $subindent = ' ' x ($scopedent+2);
    my $filemap   = $options->fileMap();
    my $pmfp      = $filemap->findFile('pm')->fp();

    ##################
    ## Now process the attributes

    ####
    ## FIELD: the primary value and the PREFIX value together
    ## dictate the name of the field.
    my $id = $field->id();

    ####
    ## PREFIX: is used to establish what should be placed before the
    ## FIELD id when forming the underlying state name.
    my $PREFIX = $field->safeAttr($schema, 'PREFIX');
    my $prefix;
    if ( $PREFIX ) {
      $prefix = $PREFIX->valueAsString();
    } else {
      ## The METASCHEMA should always provide a meaningful prefix.
      $schema->metaFatal("Failed to find a PREFIX for FIELD - corrupted Schema file");
      $prefix = '__meta_';
    }

    ####
    ## Status: indicates whether the field is part of the initial
    ## layout, or whether it is dynamically added on an
    ## instance-by-instance basis.
    my $Status = $field->safeAttr($schema, 'Status');
    my $isOptional = 0;
    if ( $Status ) {
      my $status = $Status->valueAsString();
      if ( $status eq 'optional' ) {
        $isOptional = 1;
      }
    } else {
    }

    ####
    ## Visibility: dictates the visibility of accessors for the
    ## field. The actual definition of the field is ALWAYS at
    ## private scope.
    my $Visibility = $field->safeAttr($schema, 'Visibility');
    if ( $Visibility ) {
      my $visibility = $Visibility->valueAsString();
    } else {
    }

    ####
    ## Level: 'instance', 'static' or 'meta'.
    my $Level = $field->safeAttr($schema, 'Level');
    my ($isInstance, $isStatic, $isMeta) = (0,0,0);
    my $level;
    if ( $Level ) {
      $level = $Level->valueAsString();
      if ( $level eq 'instance' ) {
        ####
        ## We add the field
        $isInstance = 1;
      } elsif ( $level eq 'static' ) {
        $isStatic = 1;
      } elsif ( $level eq 'meta' ) {
        $isMeta = 1;
      } else {
        $schema->metaFatal("Invalid Level '$level' encountered during FIELD $id", 0);
      }
    } else {
    }

    ####
    ## Mutability: can probably be removed
    ##  - FUTURE FIX: 'const' types make this unnecessary, no?
    ##  - Could have a non-const field with no setter methods, but
    ##    this can also be done via different attributes.
    my $Mutability = $field->safeAttr($schema, 'Mutability');
    if ( $Mutability ) {
      my $mutability = $Mutability->valueAsString();
    } else {
    }

    ####
    ## TYPE: The type of the field.
    ##  - used to establish the return type and arg
    ##    type of various accessors.
    ##  - used to establish the "default" value to
    ##    assign to fields.
    my $defaultDefault;
    my $acctype;
    my $cantype;
    my $TYPE = $field->safeAttr($schema, 'TYPE');
    if ( $TYPE ) {
      ## Get the perl-specific type info
      ##my $metatype = $TYPE->value()->newtype();
      my $metatype = $TYPE->value();
      my ($ref,$sref);
      if ( ! defined($metatype) ) {
          # This is a temporary hack - sometimes $metatype is undef,
          # presumably when the type is illegal wrt the Meta type system.
          $ref = '';
          $sref = '';
      } else {
        $cantype = $metatype->inCanonicalForm();
        my $nativePerlType = $metatype->asNativeType($self);
        ## Obtain the core base type (this is the ref of 'B*',
        ## where B is the base type of $TYPE).
        my $basecore = $nativePerlType->basetype()->core();
        ## Obtain the 'ref' for $TYPE.
        my $special = $nativePerlType->native();
        $ref = $special->{ref};
        ## Usually, it is $ref that dicates the default
        ## perl value, but Meta!Map@ and Meta!Vec@ have
        ## $ref = '' when we want 'HASH' and 'ARRAY'
        ## respectively (which $basecore happens to store
        ## in those cases).
        $sref = $ref || $basecore;
      }

      ## We establish the default value to assign to this field (in
      ## Meta<Perl>, we always initialize fields.
      if ( $sref eq 'SCALAR' ) {
        if ( ! $ref ) {
          ## The actual type has empty ref, which implies
          ## a primitive type.  Always 0 except for 'char'
          ## which is empty.  FUTURE FIX:
          $defaultDefault = '0';
          $acctype = 'scalar';
        } else {
          ## The actual type is SCALAR, meaning a pointer, so
          ## we initialized it to null.
          $defaultDefault = 'undef';
          $acctype = 'scalar';
        }
      } elsif ( $sref eq 'ARRAY' ) {
        $defaultDefault = '[]';
        $acctype = 'array';
      } elsif ( $sref eq 'HASH' ) {
        $defaultDefault = '{}';
        $acctype = 'hash';
      } else {
        ## Presumably a class type - default is null
        $defaultDefault = 'undef';
        $acctype = 'scalar';
      }

    } else {
      ## Whether it is an error to not have a type depends on
      ## whether we want this code to be migratable. This in turn is
      ## dictated by whether the field is being defined with a
      ## SCOPE, SCOPE<*>, or SCOPE<Perl> block.
      ##
      ## FUTURE FIX: What needs to be done here?
      $field->newWarning("Field $id is missing a type", 0);
      $defaultDefault = 'undef';
    }

    ####
    ## DEFAULT: A default value to assign to this field. It can be
    ## either a literal (number, pseudo-variable or string) or a
    ## complex block, depending on whether DEFAULT, DEFAULT<Perl> or
    ## DEFAULT<*> is specified.
    my $default;
    my $DEFAULT = $field->safeAttr($schema, 'DEFAULT');
    if ( $DEFAULT ) {
      my $complex = $DEFAULT->asComplexBlock();
      if ( $complex ) {
        ## We assign $default to the perl code needed
        ## to initialize the field.  We may need to
        ## disable complex initializations of fields!
        $field->newError("Currently not supporting DEFAULT<*> for FIELD",0);
      } else {
        ## We obtain the default as it is specified
        $default = $DEFAULT->valueAsString();
        ## We really need $default to be the fully legal Perl text
        ## to assign for the default. How do we determine whether we
        ## have a HEREDOC, a literal string, or something else?
      }
    } else {
      ## Whether we provide a Meta-assigned default or not depends
      ## on whether we are compiling in safe-mode or unsafe-mode.
      ## 
      ## FUTURE FIX: Provide support for an unsafe-mode in which
      ## variables are not initialized by Meta. For now, we always
      ## initialize.
      $default = $defaultDefault;
    }

    ####
    ## DELEGATE: If a FIELD has a DELEGATE attribute, no state is
    ## introduced - instead, all the accessors that would normally
    ## have been generated for the FIELD are delegated to the field
    ## specified in the DELEGATE value.
    my $DELEGATE = $field->safeAttr($schema, 'DELEGATE');
    my $delegate;
    if ( $DELEGATE ) {
      $delegate = $DELEGATE->valueAsString();
    }

    ####
    ## COMMENT: The documentation associated with this field
    my $COMMENT = $field->safeAttr($schema, 'COMMENT');
    if ( $COMMENT ) {

    } else {
      ## Whether we generate a warning for missing field comments depends
      ## on whether we are in 'ultra-safe' mode or not.
      ## 
      ## FUTURE FIX: Add support for ultra-safe mode.
    }

    ####
    ## SCOPE: Used to override accessor definitions, specify
    ## dumping behavior, size counts, etc.
    my $scope = $field->safeAttr($schema, 'SCOPE');
    if ( $scope ) {
    } else {
    }

    ####################
    ## Now generate state and methods based on the
    ## parameters.
    my $var = "$prefix$id";
    if ( ! $delegate ) {
      if ( $isInstance ) {
        my $varspec = ( $isOptional ) ? '#' : ' ';
        $varspec .= sprintf("%-20s => %s,", "'$var'", $default);
        $filemap->appendStr('state', "        $varspec\n");
      } elsif ( $isStatic ) {
        my $varspec = ( $isOptional ) ? '#' : ' ';
        $varspec .= sprintf("%-20s = %s;", "\$$var", $default);
        $filemap->appendStr('staticState', "  $varspec\n");
      }
    }

    ####################
    ## Now generate METHOD instances for the field
    ## methods
    ##  - do we want to continue supporting the
    ##    ACCESSOR code, or hardcode the accessors?
    ##     - the accessor code is terribly messy and hacked
    ##     - the accessor code allows user-specific accessors to be added
    my $line = $field->line();
    my $fqmetaname = $clazz->fullyQualifiedName($schema, \$id);

    print($pmfp "\n###############################\n");
    print($pmfp "# $level FIELD '$id'\n");
    print($pmfp "# META: $fqmetaname:$cantype\n");
    if ( $isStatic ) {
      if ( ! $delegate ) {
        ## We no longer generate field initialization code here,
        ## since the field is initialized in __meta_initStatic
        ## (initialization code was added to the 'staticState'
        ## FileMap string above).
        ##    print($pmfp "use vars qw(\$$var);\n\$$var = $default;\n");
        print($pmfp "use vars qw(\$$var);\n");
      }
    }

    if ( ! $isMeta ) {
      ## Obtain the ACCESSSOR definitions describing how accessor
      ## methods should appear.
      my $fieldAccessors = $schema->localConfigConstruct('FIELD')->rawAttr($schema, 'SPECIAL');
      my $angle = '/>';
      ACC:
      foreach my $accessor ($fieldAccessors->orderedConstructs()) {
        my $accid = $accessor->id();
        next if ( $accid =~ m/old/ );
        my $accscope = $accessor->scope();
        next unless $accscope;
        my $CONTEXT = $accessor->rawAttr($schema, 'CONTEXT');
        next unless $CONTEXT;
        my $context = $CONTEXT->value();
        foreach my $c (@$context) {
          if ( $c eq $acctype ) {
            ## This accessor applies to the current field.
            my $tmplLines = $accscope->value();
            shift(@$tmplLines) if ( $tmplLines->[0] !~ m/\S/ );

            ## We will maintain two lines here, the first containing
            ## the method name template, the second containing the
            ## method code. They are maintained as an array so that
            ## they can be passed to 'substituteValues'
            my @lines;
            my $namespec;
            if ( $tmplLines->[0] =~ m/METHOD\s+([^\s\(]+).*SCOPE<Perl>/ ) {
              $namespec = $1;
              next ACC if $namespec =~ m/singular/i; ## no longer supporting singular
              $lines[0] = $namespec;
              if ( $tmplLines->[2] =~ m/\}\s*(?:SCOPE|;)/ ) {
                $lines[1] = $tmplLines->[1];
              }
            } else {
              die("ERROR: Line failed to match expected - $tmplLines->[0]\n");
            }

            if ( $isOptional ) {
              ## FUTURE FIX: 
              ##  - a more general solution to the optional field problem should
              ##    probably be created (i.e. user-controllable code)
              ##  - currently we inserted a state initialization test before
              ##    the user-provided body of *every* accessor.  This may be
              ##    unnecessary in some accessors (and is to be avoided where
              ##    possible to avoid inefficiencies).
              my $f = 'var'; ## hack to avoid literal XML tag syntax (causing infinite loops and other errors)
              $lines[2] = "\$_[0]->{<$f/>} = $default unless exists(\$_[0]->{<$f/>}); ";
            }

            ## THIS CODE ASSUMES ONE-LINE BODIES!  lines[2] is actully
            ## put BEFORE lines[1] in code stream, if it exists!
            my ($name, $body, $opt) = @lines;
            if ( $delegate ) {
              $opt = '';
              $body = "shift->{__meta_$delegate}->$name(\@_);";
            } else {
              $opt ||= '';
              $body =~ s/^\s*//;
              $body =~ s/\s*$//;
              if ( $isStatic ) {
                ## We patch the body to make it syntactically correct
                ## for a static field (it is currently assuming the
                ## var is an instance field).
                $body =~ s/\$_\[0\]->\{(.*?)\}/\$$1/g;
                $body =~ s/\$_\[1\]/\$_\[0\]/g;
                $body =~ s/\$_\[2\]/\$_\[1\]/g;
              }
            }
            my $code = "sub $name { $opt$body }\n";
            $code =~ s%<name$angle%$id%g;
            $code =~ s%<Name$angle%\u$id%g;
            $code =~ s%<var$angle%$var%g;
            print($pmfp $code);

            ## Do not need to search any further
            last;
          }
        }
      } 
    }
  } else {
    $field->newError("Failed to find a class-like lexical parent for " . $field->tid(), 0, 0, $schema);
  }
  $schema->adjIndent(-2);
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD 'parseBlock'
# META: Meta.Oopl.BaseLanguage.Perl.parseBlock(#*Meta.Oopl.BaseLanguage.Perl,*Meta.Compiler.Parser):*Meta!Vec<@Meta!Str>
sub parseBlock {
  my $self = $_[0]; 
  my $parser = $_[1]; 
  #----------------------------
  # META: start of user-code
  my $result;
  my $lexer = $parser->lexer();
  $lexer->ExtendPerlBlock();
  if ( $lexer->tok_type() == $Meta::Compiler::Lexer::PERLBLOCK ) {
    $result = [ split(/\n/, $lexer->tok_value()) ];
  }
  return $result;
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD 'BaseToMetaError'
# META: Meta.Oopl.BaseLanguage.Perl.BaseToMetaError(*Meta!Map,*Meta!Map):@Meta!Str
sub BaseToMetaError {
  my $linemap = $_[0]; 
  my $filemap = $_[1]; 
  #----------------------------
  # META: start of user-code
  if ( m/ at (\S+) line (\d+)\.?$/ ) {
    ## Perl error:
    my ($basefile,$baseline) = ($1,$2);

    ## Remove any CLASSPATH prefix from $basefile
    $basefile =~ s%\.Meta/Oopl/src/Perl/%%;
    ##DEBUG: print("ERROR: $basefile = $baseline\n");

    ## Establish the corresponding Meta file
    my $metafile = $filemap->{$basefile};
    if ( defined($metafile) ) {
      ## Establish the line number within $metafile
      ## corresponding to line $baseline within $basefile.
      my $arr = $linemap->{$basefile};
      if ( defined($arr) ) {
        ## Search $arr for the tuple describing $baseline
        my $index;
        foreach my $i (0..$#$arr) {
          if ( $arr->[$i]->[0] > $baseline ) {
            $index = $i-1;
            last;
          }
        }
        if ( defined($index) ) {
          ## We've found the four-tuple. If $baseline is
          ## greater-equal $tuple->[1], we compute a
          ## relative offset from $tuple->[3]. However,
          ## if $baseline is greater-equal $tuple->[0]
          ## but less than $tuple->[1], we use
          ## $tuple->[2] without a relative offset (it is
          ## an error in the method prolog).
          my $tuple = $arr->[$index];
          my $metaline;
          if ( $baseline >= $tuple->[1] ) {
            my $diff    = $baseline - $tuple->[1];
            $metaline   = $tuple->[3] + $diff;
          } else {
            $metaline   = $tuple->[2];
          }
          ##print "ORIG: $_";
          s%(.*) at (\S+) line (\d+)\.?$%$metafile:$metaline: $1. ($2:$3)%;
          ##Meta::Lib::Root::metaPrint($tuple);

        } else {
          ## No such four-tuple found. The only common
          ## way this is possible is if the error line
          ## $baseline occurs before the first METHOD
          print(STDERR "WARN: Unable to find a line corresponding to $basefile:$baseline in $metafile\n");
        }

      } else {
        print(STDERR "WARN: Internal error - no linemap entry for $basefile!\n");

      }
    } else {
      ##print(STDERR "WARNING: Unable to find file mapping from $basefile to .meta source file\n");
    }
  }
  ##print "HERE: $_";
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD 'FilterCompilationOutput'
# META: Meta.Oopl.BaseLanguage.Perl.FilterCompilationOutput(*Meta!Input,&#Meta!Str):void
sub FilterCompilationOutput {
  my $ifp = $_[0]; 
  my $dir = $_[1]; if (!defined($_[1])) { $dir = ".Meta/Oopl"; } 
  #----------------------------
  # META: start of user-code
  my ($linemap,$filemap) = &Meta::Oopl::BaseLanguage::Root::ParseLineInfo($dir);

   #####
   ## Now process input
  while (<$ifp>) {
    &BaseToMetaError($linemap, $filemap);
    print;
  }
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_main'
# META: Meta.Oopl.BaseLanguage.Perl.__meta_main(@Meta!Str,*Meta!Vec<@Meta!Str>,@boolean,@int):void
sub __meta_main {
  my $exec = $_[0]; 
  my $args = $_[1]; 
  my $validate = $_[2]; 
  my $verbose = $_[3]; 

  {
    # Main method unit-testing prolog
    if ( $validate ) {
      print(STDERR "NOTE: Executing unit test for 'Perl' (stdout and stderr redirected)\n");
      close(STDOUT); open(STDOUT, ">Perl.out");
      close(STDERR); open(STDERR, ">Perl.err");
    } 
  }
  #----------------------------
  # META: start of user-code
  my $lang = Meta::Oopl::BaseLanguage::Perl->Instance();
  $lang->summary();

  my $id = 'var';
  foreach my $core (qw(A int Meta!Str Meta!Vec Meta!Map)) {
    printf(STDERR "\n%12s  %-6s %3s %3s %5s%6s  %-25s\n", 'Meta Type', 'PrlTyp', 'U', 'P', 'Acc', 'Elem', 'Tie');
    foreach my $sem ('@', '@#', '*', '*#', '#*', '&', '&#', '**', '***', '&*', '&**', '&***', '#*', '#**', '#***') {
      my $spec = "$sem$core";
      my $type = Meta::Oopl::Lib::Type::ForName($spec);
      my $ntype = $type->asNativeType($lang);

      my $nat = $ntype->native();
      my $ndesc = $ntype->semantics();
      my $perltype = $ndesc;
      $perltype =~ s/\(.*\)//;
      printf(STDERR "%12s  %-6s %3s %3s %5s%6s  %-25s\n", $type->desc(), ($perltype||'-'), ($nat->{undef}?'Y':'N'), $nat->{prefix}, ($nat->{access}||'-'), ($nat->{element}||'-'), ($nat->{tie} || ''));

      ##print $ntype->instantiate(4, '    ', "\$_[1]", 'var', undef);
      ##printf("For id $id, var is %s\n", $lang->idToVar($id, $type));
    }
  }

  ##my $basetype = $type->basetype();
  ##my $nbtype = $basetype->nativeBaseTypeFor($lang);
  ##printf("BType %s NBtype %s\n", $basetype->canonical(), $nbtype->canonical());
  # META: end of user-code
  #----------------------------
  {
    # Main method unit-testing epilog
    if ( $validate ) {
      my $tty = `tty`; chomp($tty);
      close(STDOUT); open(STDOUT, ">$tty");
      close(STDERR); open(STDERR, ">$tty");
      my $errors = &__meta_validate($validate);
      if ( ( -s 'Perl.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat Perl.out"); } unlink('Perl.out') unless ( $verbose > 2);
      if ( ( -s 'Perl.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat Perl.err"); } unlink('Perl.err') unless ( $verbose > 2);
    } 
  }
}

###############################
# static METHOD '__meta_validate'
# META: Meta.Oopl.BaseLanguage.Perl.__meta_validate(@int):@int
sub __meta_validate {
  my $verbose = $_[0]; 
  #----------------------------
  # META: start of user-code
  my $errors = 0;
  print("NOTE:    No unit testing provided for CLASS Perl\n");
  return $errors;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD '__meta_initInstance'
# META: Meta.Oopl.BaseLanguage.Perl.__meta_initInstance(#*Meta.Oopl.BaseLanguage.Perl,@int):@int
sub __meta_initInstance {
  my $self = $_[0]; 
  my $verbose = $_[1]; 
  #----------------------------
  # META: start of user-code
  $_[0]->SUPER::__meta_initInstance();
  $_[0]->__meta_extend({
  });
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_initStatic'
# META: Meta.Oopl.BaseLanguage.Perl.__meta_initStatic():void
sub __meta_initStatic {
  #----------------------------
  # META: start of user-code
  $__meta_Data         = '
     |BASELANGUAGE Perl NAME Perl ABBREVS "pm perl" SCHEMA Oopl COMMENT { 
     |  
     |
     |} OPERATORS {
     |  PAIR # "+"     => "op_plus";
     |  PAIR # "-"     => "op_minus";
     |  PAIR # "*"     => "op_times";
     |  PAIR # "/"     => "op_divide";
     |  PAIR # "++"    => "op_addone";
     |  PAIR # "--"    => "op_subone";
     |  PAIR # "+="    => "op_increment";
     |  PAIR # "-="    => "op_decrement";
     |  PAIR # "*="    => "op_timesment";
     |  PAIR # "/="    => "op_divment";
     |  PAIR # "<<"    => "op_left";
     |  PAIR # ">>"    => "op_right";
     |
     |} CONSTANTS {
     |  PAIR # "null"  => "undef";
     |  PAIR # "Null"  => "undef";
     |  PAIR # "false" => "0";
     |  PAIR # "False" => "0";
     |  PAIR # "true"  => "1";
     |  PAIR # "True"  => "1";
     |  PAIR # "this"  => "self";
     |  PAIR # "This"  => "\$self";
     |  PAIR # "self"  => "self";
     |  PAIR # "Self"  => "\$self";
     |
     |} PRIMITIVES {
     |  PAIR # "boolean" => "bool";
     |  PAIR # "byte"    => "char";
     |  PAIR # "char"    => "char";
     |  PAIR # "short"   => "int";
     |  PAIR # "int"     => "int";
     |  PAIR # "long"    => "int";
     |  PAIR # "float"   => "real";
     |  PAIR # "double"  => "real";
     |
     |} NATIVES {
     |
     |  METANATIVE Meta!Str BASENATIVE SCALAR
     |    BASEFUNC new
     |      PAIR # "T@" := { my $<rec> = ""; };
     |      PAIR # "T*" := { my $__meta_<rec>base = ""; my $<rec> = \$__meta_<rec>base; };
     |    BASEFUNC append
     |      PAIR # "T@" := { $<rec>  .= <arg1>; };
     |      PAIR # "T*" := { $$<rec> .= <arg1>; };
     |    BASEFUNC prepend
     |      PAIR # "T@" := { $<rec> = <arg1> . $<rec>; };
     |      PAIR # "T*" := { $$<rec> = <arg1> . $$<rec>; };
     |    BASEFUNC substr
     |      PAIR # "T@" := { substr($<rec>, <arg1>, <arg2>); };
     |      PAIR # "T*" := { substr($$<rec>, <arg1>, <arg2>); };
     |    BASEFUNC get
     |      PAIR # "T@" := { substr($<rec>, <arg1>, 1); };
     |      PAIR # "T*" := { substr($$<rec>, <arg1>, 1); };
     |    BASEFUNC set
     |      PAIR # "T@" := { substr($<rec>, <arg1>, 1, <arg2>); };
     |      PAIR # "T*" := { substr($$<rec>, <arg1>, 1, <arg2>); };
     |    BASEFUNC insert
     |      PAIR # "T@" := { substr($<rec>, <arg1>, 0, <arg2>); };
     |      PAIR # "T*" := { substr($$<rec>, <arg1>, 0, <arg2>); };
     |    BASEFUNC matches 
     |      PAIR # "T@" := { $<rec> =~ m/<arg1>/; };
     |      PAIR # "T*" := { $$<rec> =~ m/<arg1>/; };
     |    BASEFUNC replaceFirst
     |      PAIR # "T@" := { $<rec> =~ s/<arg1>/<arg2>/; };
     |      PAIR # "T*" := { $$<rec> =~ s/<arg1>/<arg2>/; };
     |    BASEFUNC replaceAll
     |      PAIR # "T@" := { $<rec> =~ s/<arg1>/<arg2>/g; };
     |      PAIR # "T*" := { $$<rec> =~ s/<arg1>/<arg2>/g; };
     |
     |  METANATIVE Meta!Vec BASENATIVE ARRAY BASEARGS <$V>
     |    BASEFUNC new 
     |      PAIR # "T@" := { my @<rec>; };
     |      PAIR # "T*" := { my $<rec> = []; };
     |    BASEFUNC append
     |      PAIR # "T@" := { push(@<rec>, <arg1>); };
     |      PAIR # "T*" := { push(@$<rec>, <arg1>); };
     |    BASEFUNC prepend 
     |      PAIR # "T@" := { unshift(@<rec>, <arg1>); };
     |      PAIR # "T*" := { unshift(@$<rec>, <arg1>); };
     |    BASEFUNC size 
     |      PAIR # "T@" := { scalar(@<rec>); };
     |      PAIR # "T*" := { scalar(@$<rec>); };
     |    BASEFUNC get
     |      PAIR # "T@" := { $<rec>[<arg1>]; };
     |      PAIR # "T*" := { $<rec>->[<arg1>]; };
     |    BASEFUNC set 
     |      PAIR # "T@" := { $<rec>[<arg1>] = <arg2>; };
     |      PAIR # "T*" := { $<rec>->[<arg1>] = <arg2>; };
     |    BASEFUNC insert
     |      PAIR # "T@" := { splice(@<rec>, <arg1>, 0, <arg2>); };
     |      PAIR # "T*" := { splice(@$<rec>, <arg1>, 0, <arg2>); };
     |    BASEFUNC pop
     |      PAIR # "T@" := { pop(@<rec>); };
     |      PAIR # "T*" := { pop(@$<rec>); };
     |    BASEFUNC shift
     |      PAIR # "T@" := { shift(@<rec>); };
     |      PAIR # "T*" := { shift(@$<rec>); };
     |    BASEFUNC remove
     |      PAIR # "T@" := { splice(@<rec>, <arg1>, 1); };
     |      PAIR # "T*" := { splice(@$<rec>, <arg1>, 1); };
     |    BASEFUNC print
     |      PAIR # "T@" := { printf("Array:\n"); foreach my $__meta_i (0..$#<rec>)  { printf("  [%3d] %s\n",$__meta_i,$<rec>[$__meta_i]); } };
     |      PAIR # "T*" := { printf("Array:\n"); foreach my $__meta_i (0..$#$<rec>) { printf("  [%3d] %s\n",$__meta_i,$<rec>->[$__meta_i]); } };
     |
     |  METANATIVE Meta!Map METAARGS <K,V> BASENATIVE HASH BASEARGS <$K,$V>
     |    BASEFUNC new
     |      PAIR # "T@" := { my %<rec>; };
     |      PAIR # "T*" := { my $<rec> = {}; };
     |    BASEFUNC size
     |      PAIR # "T@" := { a };
     |      PAIR # "T*" := { b };
     |    BASEFUNC get
     |      PAIR # "T@" := { c };
     |      PAIR # "T*" := { d };
     |    BASEFUNC remove
     |      PAIR # "T@" := { e };
     |      PAIR # "T*" := { f };
     |    BASEFUNC set
     |      PAIR # "T@" := { g };
     |      PAIR # "T*" := { h };
     |
     |  METANATIVE Meta!IStr            BASENATIVE ?
     |  METANATIVE Meta!Regexp          BASENATIVE Regexp
     |  METANATIVE Meta!IO              BASENATIVE File::IO
     |  METANATIVE Meta!Output          BASENATIVE File::IO
     |  METANATIVE Meta!Input           BASENATIVE File::IO
     |  METANATIVE Meta!Const<T>        BASENATIVE ?
     |  METANATIVE Meta!Val<T>          BASENATIVE ?
     |  METANATIVE Meta!Ptr<T>          BASENATIVE ?
     |  METANATIVE Meta!Ref<T>          BASENATIVE ?
     |  METANATIVE Meta!Any             BASENATIVE ?
     | 
     |  METANATIVE Meta!IStrMap<V>      BASENATIVE HASH  BASEARGS <Meta!IStr*/$V>
     |};
';
  $__meta_Inst         = undef;
  # META: end of user-code
  #----------------------------
}
&__meta_initStatic();


sub __Meta_main { &__meta_main(@_); }


###
# All well-formed perl modules return true.
1;

  
