package Meta::Oopl::BaseLanguage::PerlHashRef;
=head1 NAME
=head1 SYNOPSIS
=head1 DESCRIPTION
=head1 NOTES
=head1 IMPLEMENTATION
=cut

###
# Never leave home without it!
use strict;

###
# Initial "class-related" static variables
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
$VERSION = '0.01';

###
# The superclasses (definition and importation)
@ISA = qw(Meta::Oopl::BaseLanguage::PerlRef);
use Meta::Oopl::BaseLanguage::PerlRef;

###
# The associations of this class (importation)
use IO::File;
use Carp;
use Meta::Oopl::BaseLanguage::PerlRef;

###
# The executable code of this class (methods, accessors, initializers, finalizers)


# META: NATIVE__C67__
{
  sub TIEHASH   { return bless $_[1], $_[0]; }
  sub FETCH     { return $_[0]->{$_[1]}; }
  sub STORE     { $_[0]->{$_[1]} = $_[2]; }
  sub DELETE    { return delete $_[0]->{$_[0]}; }
  sub CLEAR     { %{$_[0]} = (); }
  sub EXISTS    { return exists $_[0]->{$_[0]}; }
  sub FIRSTKEY  { my $a = keys(%{$_[0]}); each %{$_[0]}; }
  sub NEXTKEY   { return each %{$_[0]}; }
  sub SCALAR    { return scalar(%{$_[0]}); }
  # do we have to do anything for DESTROY???  FIX THIS WMH!!!
  sub DESTROY   { }
  sub UNTIE     { croak("ERROR: PerlHashRef::UNTIE not yet implemented"); }
}

###############################
# static METHOD '__meta_main'
# META: Meta.Oopl.BaseLanguage.PerlHashRef.__meta_main(@Meta!Str,*Meta!Vec<@Meta!Str>,@boolean,@int):void
sub __meta_main {
  my $exec = $_[0]; 
  my $args = $_[1]; 
  my $validate = $_[2]; 
  my $verbose = $_[3]; 

  {
    # Main method unit-testing prolog
    if ( $validate ) {
      print(STDERR "NOTE: Executing unit test for 'PerlHashRef' (stdout and stderr redirected)\n");
      close(STDOUT); open(STDOUT, ">PerlHashRef.out");
      close(STDERR); open(STDERR, ">PerlHashRef.err");
    } 
  }
  #----------------------------
  # META: start of user-code
  # Main method core
  print("No RUN attribute was specified for CLASS PerlHashRef\n");
  # META: end of user-code
  #----------------------------
  {
    # Main method unit-testing epilog
    if ( $validate ) {
      my $tty = `tty`; chomp($tty);
      close(STDOUT); open(STDOUT, ">$tty");
      close(STDERR); open(STDERR, ">$tty");
      my $errors = &__meta_validate($validate);
      if ( ( -s 'PerlHashRef.out' ) && ( $verbose > 1 ) ) { print("\nSTDOUT\n======\n"); system("cat PerlHashRef.out"); } unlink('PerlHashRef.out') unless ( $verbose > 2);
      if ( ( -s 'PerlHashRef.err' ) && ( $verbose > 1 ) ) { print("\nSTDERR\n======\n"); system("cat PerlHashRef.err"); } unlink('PerlHashRef.err') unless ( $verbose > 2);
    } 
  }
}

###############################
# static METHOD '__meta_validate'
# META: Meta.Oopl.BaseLanguage.PerlHashRef.__meta_validate(@int):@int
sub __meta_validate {
  my $verbose = $_[0]; 
  #----------------------------
  # META: start of user-code
  my $errors = 0;
  print("NOTE:    No unit testing provided for CLASS PerlHashRef\n");
  return $errors;
  # META: end of user-code
  #----------------------------
}

###############################
# instance METHOD '__meta_initInstance'
# META: Meta.Oopl.BaseLanguage.PerlHashRef.__meta_initInstance(#*Meta.Oopl.BaseLanguage.PerlHashRef,@int):@int
sub __meta_initInstance {
  my $self = $_[0]; 
  my $verbose = $_[1]; 
  #----------------------------
  # META: start of user-code
  $_[0]->SUPER::__meta_initInstance();
  $_[0]->__meta_extend({
  });
  # META: end of user-code
  #----------------------------
}

###############################
# static METHOD '__meta_initStatic'
# META: Meta.Oopl.BaseLanguage.PerlHashRef.__meta_initStatic():void
sub __meta_initStatic {
  #----------------------------
  # META: start of user-code
  # META: end of user-code
  #----------------------------
}
&__meta_initStatic();


sub __Meta_main { &__meta_main(@_); }


###
# All well-formed perl modules return true.
1;

  
