package XFig::Box;
use strict;

=head1 NAME

XFig::Box -

=head1 SYNOPSIS

use XFig::Box ();

=head1 DESCRIPTION


=head1 NOTES


=head1 EXAMPLES


=head1 IMPLEMENTATION

=cut

use Carp;                      # everyone gets Carp!
use IO::File;                  # everyone gets IO::File!
use XFig::Polyline;
use IO::File;
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
@ISA = qw(XFig::Polyline);
$VERSION = '0.01';

####################### Package Global Variables ###################
use vars qw();




############################# Raw Code  ############################
				      
				      
########################## Class Methods ###########################

#line 2376 "fig.pxx"
sub new {
    carp('Usage: XFig::Box::new(class, args)') unless (@_ == 2);
    my($class) = $_[0]; CORE::ref($class) eq '' or carp(sprintf('XFig::Box::new: ref($class) = %s instead of .', CORE::ref($class))); 
    my($args) = $_[1]; ((!$args) || (CORE::ref($args) eq 'HASH')) or carp(sprintf('XFig::Box::new: ref($args) = %s instead of HASH.', ref($args))); 
#line 2377 "fig.pxx"
    $args->{sub_type} = 2;

    ###
    # A box must have 5 points and first and last points must be
    # equal.  Furthermore, the points must form a rectangle.  We
    # leave must of this to the 'validate' method, but do provide
    # a convience format.  If the 'bounds' arg exists, it should
    # be an array containing four elements (ulx, uly, lrx, lry).
    # These values are used to create the array of 5 points.  It
    # is an error to specify both 'bounds' and 'points'.
    my $bounds = delete $args->{bounds};
    if ( $bounds ) {
        die("ERROR: Do not specify both 'bounds' and 'points' args - ambiguous") if $args->{points};
        if ( ( ref($bounds) eq 'ARRAY' ) && ( $#$bounds == 3 ) ) {
            my ($ulx, $uly, $lrx, $lry) = @$bounds;
            $args->{points} = [ [$ulx, $uly], [$lrx, $uly], [$lrx, $lry], [$ulx, $lry], [$ulx, $uly] ];
        } else {
            die("ERROR: Invalid format for 'bounds' arg");
        }
    }
    my $self = $class->SUPER::new($args);
    return $self;
}

########################## Instance Methods ########################

###
# Accessors

# End Accessors
###

###
# User Code
#line 1 "GENERATED CODE"
sub initState {
    carp('Usage: XFig::Box::initState(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Box'))) or carp(sprintf('XFig::Box::initState: NOT $self->isa(XFig::Box)')); 
#line 3 "GENERATED CODE"
{
    $_[0]->SUPER::initState();
    $_[0]->extend({
    });
}}

#line 2403 "fig.pxx"
sub validate {
    carp('Usage: XFig::Box::validate(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Box'))) or carp(sprintf('XFig::Box::validate: NOT $self->isa(XFig::Box)')); 
#line 2404 "fig.pxx"
    $self->SUPER::validate();
    # Ensure there are five points defining a square, with
    # first point equal to last point.
}
# User Code
###

###
# Post text

# Post text
###

########################## END OF MODULE ###########################
1;

__DATA__


__END__

=head1 PUBLIC CLASS INTERFACE

=over 4



=head1 PUBLIC INSTANCE INTERFACE

=over 4

=head2 initState()
Automated method for initializing Perl class state based on field definitions.

=cut

=head1 AUTHOR

Wade Holst

=head1 SEE ALSO

perl(1).

=cut         