package XFig::Color;
use strict;

=head1 NAME

XFig::Color -

=head1 SYNOPSIS

use XFig::Color ();

=head1 DESCRIPTION


=head1 NOTES


=head1 EXAMPLES


=head1 IMPLEMENTATION

=cut

use Carp;                      # everyone gets Carp!
use IO::File;                  # everyone gets IO::File!
use IO::File;
use XFig::Object;
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
@ISA = qw(XFig::Object);
$VERSION = '0.01';

####################### Package Global Variables ###################
use vars qw();




############################# Raw Code  ############################
				      
				      
########################## Class Methods ###########################

#line 1693 "fig.pxx"
sub new {
    carp('Usage: XFig::Color::new(class, args)') unless (@_ == 2);
    my($class) = $_[0]; CORE::ref($class) eq '' or carp(sprintf('XFig::Color::new: ref($class) = %s instead of .', CORE::ref($class))); 
    my($args) = $_[1]; ((!$args) || (CORE::ref($args) eq 'HASH')) or carp(sprintf('XFig::Color::new: ref($args) = %s instead of HASH.', ref($args))); 
#line 1694 "fig.pxx"
    $args->{object_code} = 0;
    # Color does not have any friendly keys (not calling 'adjustArgs')
    my $self = $class->SUPER::new($args);
    $self->initFields($args, qw(color_number rgb));
    return $self;
}

########################## Instance Methods ########################

###
# Accessors
#line 1688 "fig.pxx"
sub color_number         {  return ( $#_ == 0 ) ? $_[0]->{color_number} : ( $_[0]->{color_number} = $_[1] );  }
#line 1688 "fig.pxx"
sub incrColor_number     {  return $_[0]->{color_number} += (defined($_[1]) ? $_[1] : 1); }
#line 1689 "fig.pxx"
sub rgb                  {  return ( $#_ == 0 ) ? $_[0]->{rgb} : ( $_[0]->{rgb} = $_[1] );  }
# End Accessors
###

###
# User Code
#line 1703 "fig.pxx"
sub bbox {
    carp('Usage: XFig::Color::bbox(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Color'))) or carp(sprintf('XFig::Color::bbox: NOT $self->isa(XFig::Color)')); 
#line 1707 "fig.pxx"
    return (0,0,0,0);
}

#line 1 "GENERATED CODE"
sub initState {
    carp('Usage: XFig::Color::initState(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Color'))) or carp(sprintf('XFig::Color::initState: NOT $self->isa(XFig::Color)')); 
#line 3 "GENERATED CODE"
{
    $_[0]->SUPER::initState();
    $_[0]->extend({
        # rgb => '',
        # color_number => '',
    });
}}
# User Code
###

###
# Post text

# Post text
###

########################## END OF MODULE ###########################
1;

__DATA__


__END__

=head1 PUBLIC CLASS INTERFACE

=over 4



=head1 PUBLIC INSTANCE INTERFACE

=over 4

=head2 bbox()
Rather than reporting an error (violating subtyping of
::Color relative to ::Object), we just return a dummy
bounding box

=cut

=head2 initState()
Automated method for initializing Perl class state based on field definitions.

=cut

=head1 AUTHOR

Wade Holst

=head1 SEE ALSO

perl(1).

=cut         