package XFig::Polyline;
use strict;

=head1 NAME

XFig::Polyline -

=head1 SYNOPSIS

use XFig::Polyline ();

=head1 DESCRIPTION


=head1 NOTES


=head1 EXAMPLES


=head1 IMPLEMENTATION

=cut

use Carp;                      # everyone gets Carp!
use IO::File;                  # everyone gets IO::File!
use IO::File;
use XFig::ShapeObject;
use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);
@ISA = qw(XFig::ShapeObject);
$VERSION = '0.01';

####################### Package Global Variables ###################
use vars qw();




############################# Raw Code  ############################
				      
				      
########################## Class Methods ###########################

#line 2493 "fig.pxx"
sub new {
    carp('Usage: XFig::Polyline::new(class, args)') unless (@_ == 2);
    my($class) = $_[0]; CORE::ref($class) eq '' or carp(sprintf('XFig::Polyline::new: ref($class) = %s instead of .', CORE::ref($class))); 
    my($args) = $_[1]; ((!$args) || (CORE::ref($args) eq 'HASH')) or carp(sprintf('XFig::Polyline::new: ref($args) = %s instead of HASH.', ref($args))); 
#line 2494 "fig.pxx"
    $args->{object_code} = 2;
    $args->{sub_type} ||= 1;
    my $self = $class->SUPER::new($args);
    $self->initFields($args, qw(join_style cap_style radius forward_arrow backward_arrow forward backward npoints points));
    return $self;
}

########################## Instance Methods ########################

###
# Accessors
#line 2489 "fig.pxx"
sub addPoint             {  push(@{$_[0]->{points}}, $_[1]);  }
#line 2486 "fig.pxx"
sub backward             {  if ( $#_ == 0 ) { return (wantarray) ? %{$_[0]->{backward}} : $_[0]->{backward}} else { $_[0]->{backward} = $_[1]; return (wantarray) ? %{$_[1]} : $_[1] }  }
#line 2484 "fig.pxx"
sub backward_arrow       {  return ( $#_ == 0 ) ? $_[0]->{backward_arrow} : ( $_[0]->{backward_arrow} = $_[1] );  }
#line 2481 "fig.pxx"
sub cap_style            {  return ( $#_ == 0 ) ? $_[0]->{cap_style} : ( $_[0]->{cap_style} = $_[1] );  }
#line 2485 "fig.pxx"
sub forward              {  if ( $#_ == 0 ) { return (wantarray) ? %{$_[0]->{forward}} : $_[0]->{forward}} else { $_[0]->{forward} = $_[1]; return (wantarray) ? %{$_[1]} : $_[1] }  }
#line 2483 "fig.pxx"
sub forward_arrow        {  return ( $#_ == 0 ) ? $_[0]->{forward_arrow} : ( $_[0]->{forward_arrow} = $_[1] );  }
#line 2484 "fig.pxx"
sub incrBackward_arrow   {  return $_[0]->{backward_arrow} += (defined($_[1]) ? $_[1] : 1); }
#line 2481 "fig.pxx"
sub incrCap_style        {  return $_[0]->{cap_style} += (defined($_[1]) ? $_[1] : 1); }
#line 2483 "fig.pxx"
sub incrForward_arrow    {  return $_[0]->{forward_arrow} += (defined($_[1]) ? $_[1] : 1); }
#line 2480 "fig.pxx"
sub incrJoin_style       {  return $_[0]->{join_style} += (defined($_[1]) ? $_[1] : 1); }
#line 2487 "fig.pxx"
sub incrNpoints          {  return $_[0]->{npoints} += (defined($_[1]) ? $_[1] : 1); }
#line 2482 "fig.pxx"
sub incrRadius           {  return $_[0]->{radius} += (defined($_[1]) ? $_[1] : 1); }
#line 2480 "fig.pxx"
sub join_style           {  return ( $#_ == 0 ) ? $_[0]->{join_style} : ( $_[0]->{join_style} = $_[1] );  }
#line 2487 "fig.pxx"
sub npoints              {  return ( $#_ == 0 ) ? $_[0]->{npoints} : ( $_[0]->{npoints} = $_[1] );  }
#line 2486 "fig.pxx"
sub numBackward          {  return scalar(keys(%{$_[0]->{backward}}));  }
#line 2485 "fig.pxx"
sub numForward           {  return scalar(keys(%{$_[0]->{forward}}));  }
#line 2489 "fig.pxx"
sub numPoints            {  return scalar(@{$_[0]->{points}});  }
#line 2489 "fig.pxx"
sub point                {  if ( @_ == 2 ) { return $_[0]->{points}->[$_[1]]; } else { $_[0]->{points}->[$_[1]] = $_[2]; return $_[2]; }  }
#line 2489 "fig.pxx"
sub points               {  if ( $#_ == 0 ) { return (wantarray) ? @{$_[0]->{points}} : $_[0]->{points}} else { $_[0]->{points} = $_[1]; return (wantarray) ? @{$_[1]} : $_[1] }  }
#line 2482 "fig.pxx"
sub radius               {  return ( $#_ == 0 ) ? $_[0]->{radius} : ( $_[0]->{radius} = $_[1] );  }
# End Accessors
###

###
# User Code
#line 2528 "fig.pxx"
sub bbox {
    carp('Usage: XFig::Polyline::bbox(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Polyline'))) or carp(sprintf('XFig::Polyline::bbox: NOT $self->isa(XFig::Polyline)')); 
#line 2530 "fig.pxx"

    # We iterate through each point looking for
    # minx/miny and maxx/maxy.

    my ($minx,$miny,$maxx,$maxy) = (100000,100000,-100000,-100000);
    foreach my $p ($self->points()) {
        my ($x,$y) = @$p;
        $minx = $x if $x < $minx;
        $miny = $y if $y < $miny;
        $maxx = $x if $x > $maxx;
        $maxy = $y if $y > $maxy;
    }
    return ($minx,$miny,$maxx,$maxy);
}

#line 2503 "fig.pxx"
sub clone {
    carp('Usage: XFig::Polyline::clone(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Polyline'))) or carp(sprintf('XFig::Polyline::clone: NOT $self->isa(XFig::Polyline)')); 
#line 2504 "fig.pxx"
    my $result = { %$self };
    bless $result, $self->myclass();

    # We need to deep-copy 'forward', 'backward' and 'points'
    $result->{forward} = { %{$self->{forward}} };
    $result->{backward} = { %{$self->{backward}} };

    my @points;
    foreach my $xy ($self->points()) {
        push(@points, [@$xy]);
    }
    $result->{points} = \@points;

    return $result;
}

#line 1 "GENERATED CODE"
sub initState {
    carp('Usage: XFig::Polyline::initState(self)') unless (@_ == 1);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Polyline'))) or carp(sprintf('XFig::Polyline::initState: NOT $self->isa(XFig::Polyline)')); 
#line 3 "GENERATED CODE"
{
    $_[0]->SUPER::initState();
    $_[0]->extend({
        # cap_style => '',
        # npoints => '',
        # join_style => '',
        backward => {},
        # radius => '',
        points => [],
        forward => {},
        # forward_arrow => '',
        # backward_arrow => '',
    });
}}

#line 2520 "fig.pxx"
sub rawTranslate {
    carp('Usage: XFig::Polyline::rawTranslate(self, dx, dy)') unless (@_ == 3);
    my($self) = $_[0]; ((!$self) || ($self->isa('XFig::Polyline'))) or carp(sprintf('XFig::Polyline::rawTranslate: NOT $self->isa(XFig::Polyline)')); 
    my($dx) = $_[1]; CORE::ref($dx) eq '' or carp(sprintf('XFig::Polyline::rawTranslate: ref($dx) = %s instead of .', CORE::ref($dx))); $dx =~ m/^[+-]?\d+$/ or carp(sprintf('XFig::Polyline::rawTranslate: Variable $dx = %s does not match type int.', $dx)); 
    my($dy) = $_[2]; CORE::ref($dy) eq '' or carp(sprintf('XFig::Polyline::rawTranslate: ref($dy) = %s instead of .', CORE::ref($dy))); $dy =~ m/^[+-]?\d+$/ or carp(sprintf('XFig::Polyline::rawTranslate: Variable $dy = %s does not match type int.', $dy)); 
#line 2522 "fig.pxx"
    foreach my $xy ($self->points()) {
        $xy->[0] += $dx;
        $xy->[1] += $dy;
    }
}
# User Code
###

###
# Post text

# Post text
###

########################## END OF MODULE ###########################
1;

__DATA__


__END__

=head1 PUBLIC CLASS INTERFACE

=over 4



=head1 PUBLIC INSTANCE INTERFACE

=over 4

=head2 bbox()
Return the bounding box for this object

=cut

=head2 initState()
Automated method for initializing Perl class state based on field definitions.

=cut

=head2 rawTranslate(int $dx, int $dy)
Need only adjust the 'points' field.

=cut

=head1 AUTHOR

Wade Holst

=head1 SEE ALSO

perl(1).

=cut         